2018-04-07 Wolfgang Hofer <hof@gimp.org>

- player cache limitation now supports higher values than 2047 MB
  Note: the player still will crash in case 
  the user sets the limit greater than the available memory.

 * gap/gap_pview_da.c [.h]
 * gap/gap_player_main.h
 * gap/gap_player_dialog.c
 * gap/gap_player_cache.c [h]

2018-01-25 Wolfgang Hofer <hof@gimp.org>

- use larger spinbutton entries in the MovePath Dialog and bigger inital preview size.
  update MovePath text docmentation.

 * gap/gap_mov_dialog.c
 * docs/reference/txt/plug-in-gap-move-path.txt
 
2018-01-25 Wolfgang Hofer <hof@gimp.org>

- master video encoder provides more information in the error message
  in case creating composite audiofile fails due to problems calling
  the external audioconverter (sox)

- Support L*A*B colorspace based colordiff methods 
  DelteE CIE94 and CIEDE2000  in the bluebox filter

 * gap/gap_colordiff.c [.h]
 * gap/gap_bluebox.c [.h]
 * gap/gap_bluebox_main.c
 * gap/gap_story_render_audio.c

2018-01-19 Wolfgang Hofer <hof@gimp.org>

- applied patch provided by Anders Jonsson @ https://bugzilla.gnome.org/show_bug.cgi?id=792549
  (0001-Fix-typos-in-translatable-strings.txt)
 
 * gap/gap_base_ops.c
 * gap/gap_detail_align_exec.c
 * gap/gap_detail_tracking_main.c
 * gap/gap_edge_detection_dialog.c
 * gap/gap_morph_dialog.c
 * gap/gap_morph_tween_dialog.c
 * gap/gap_mov_dialog.c
 * gap/gap_opacity_exposure_main.c
 * gap/gap_wr_resynth.c

2017-10-08 Wolfgang Hofer <hof@gimp.org>

- Fix for Storyboard Audio rendering in case where clips of the same 
  video (AUD_PLAY_MOVIE Storyboardelemnts) are used in more than 
  one audio track of the Storyboard.
  The bug triggered a huge amount of alternating audio segemnt load operations
  in the composite audiofile audiomix processing. This caused extreme slow rendering
  where one minute of audio did not finish in hours.

 * gap/gap_story_render_types.h
 * gap/gap_story_render_audio.c

2017-04-15 Wolfgang Hofer <hof@gimp.org>

- MovePath support Handle Offsets, "Reset all controlpoints" Button protects keyframe information by default
  This change of behavior is a bugfix to prevent unwanted loss of keyframe information in the path controlpoints.
  In case where reset of keyframe information is wanted
  Clicking "Reset all controlpoints" Button while holding down the ALT key removes keyframe information
  from all controlpoints the same way as the old behavior always did.
  
  Added X and Y Controlpoint Coordinate Buttons to copy coordinate from previous Controlpoint
  Holding down the shift Key copy coordinate from next Controlpoint
  Holding down the ctrl Key Calculate coordinate as average between previous and next Controlpoint.

- MovePath Save Button overwrites pointfile (after succsessful inital load or save) without popup the fileselection.
  Hold Ctrl or Shift forces the fileselection (Save As), 
  Show the pointfilename (as part of the framelabel Edit Controlpoints)

- Detail tracking history information is now stored in temporary image parasite
  in the (mtrace) image that is updated while playback in detail tracking mode.
  (older versions stored history global in the gimp session)

- bugfix in the BlendFill filter (that applied always to the layer on top of stack instead of the active drawable)
  furthermore keep the layermask (in case the active layer has one)

- The wrapper for the 3rd party resysnthesizer plugin now supports the same options as the
  python script "plugin-heal-selecton.py" that ships with the resynthesizer
  with additional option to load the selection from a vectors file in SVG format.

- Added a wrapper for the gimp desaturation procedure
  (so it can be used in GIMP-GAP triggered filtercalls such as filtermacro
  in filter all layers or modify frames feature)

- Added Dialog and extended the edge detection method for use in  GIMP-GAP triggered filtercalls
  (GIMP already has a similar Edge detection Filter based on Difference between 2 Gaussian Blur operations
  the GAP variante also provides shifting options and separated x y settings -- that makes it more complicated for the user --
  but allows more tuning when creating edge protectgion masks for remastering of videoframes)

- Onionskin creation of onionskin layers has now options to create the onionskin layer(s) with
  a layermask (none, Black, White, from Selection, Clipped from Selection) and has options
  to set the onionskin layer or its layermask active after crestion.

- FramesModify supports 2 additional functions for resizing layers in frame images
  to selction bounds (using the selection of invoking active frame, or individual selection in all frames)

- Added new base operation to remame the framename part in all framefiles.

  * gap/Makefile.am
  * gap/gap_base_ops.c
  * gap/gap_base_ops.h
  * gap/gap_blend_fill_main.c
  * gap/gap_detail_align_exec.c
  * gap/gap_detail_align_exec.h
  * gap/gap_detail_tracking_exec.c
  * gap/gap_detail_tracking_exec.h
  * gap/gap_detail_tracking_main.c
  * gap/gap_edge_detection.c
  * gap/gap_edge_detection.h
  * gap/gap_layer_copy.c
  * gap/gap_layer_copy.h
  * gap/gap_locate2.c
  * gap/gap_locate2.h
  * gap/gap_main.c
  * gap/gap_mod_layer.c
  * gap/gap_mod_layer.h
  * gap/gap_mod_layer_dialog.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_dialog.h
  * gap/gap_mov_exec.c
  * gap/gap_mov_render.c
  * gap/gap_mov_xml_par.c
  * gap/gap_onion_base.c
  * gap/gap_onion_base.h
  * gap/gap_onion_dialog.c
  * gap/gap_onion_main.c
  * gap/gap_onion_main.h
  * gap/gap_vex_exec.c
  * gap/gap_vin.c
  * gap/gap_vin.h
  * gap/gap_wr_resynth.c
  
  * gap/gap_edge_detection_dialog.c # new
  * gap/gap_edge_detection_dialog.h # new
  * gap/gap_edge_detection_main.c # new
  * gap/gap_geo.c # new
  * gap/gap_geo.h # new
  * gap/gap_opacity_exposure_main.c # new
  * gap/gap_wr_desaturate.c # new
  

2016-05-28 Wolfgang Hofer <hof@gimp.org>

- replaced deprecated procedure calls: 
    gimp_image_scale_full
    gimp_rect_select       (calling gimp_image_select_rectangle  instead)


 * gap/gap_image.c
 * gap/gap_story_att_trans_dlg.c
 * gap/gap_story_render_processor.c
 
2016-03-28 Wolfgang Hofer <hof@gimp.org>

- added the changes on file gap/gap_detail_align_exec.c
  (that were missing in my previous commit)
  DetailAlign filter extended for parsing additional XML attributes 
  recorded by DetailTracking.

 * gap/gap_detail_align_exec.c


2016-03-27 Wolfgang Hofer <hof@gimp.org>

- Fixed issues from test with GIMP-2.9.2 
  Replaced explicite pdb call to "gimp_xcf_save" procedure by
  by  gimp_file_save that shall do the same (since .xcf extension is used)
  Note that gimp-2.9.2 now performs checks for a valid drawale_id provided to the save procedure
  (even in case saving to XCF that should ignore the drawable_id as gimp-2.8.x did)
  that behavior caused GIMP-GAP automatic save to XCF fail ....
  The implented fix now picks the active layer (or the layer on stackposition 0 in case there is no active layer)
  for the gimp_file_save call and makes GIMP-GAP automatic save now work both with gimp-2.8.x and 2.9.x
  (but still fails in gimp-2.9.x when the image has no layer at all)
   


- DetailTracking now provides the option to track more details
  (up to 12 points are captured from the active path) 
   and the best matching one (or two) points are picked for logging to the XML file

  DetailTracking configure dialog supports the new parameter numPointsSelect
  that can be set to 1 (for simple movement x/y compensation)
  or set to 2 (for movemnet, scale and rotation compensation)

- Detail Tracking renders reference and tracked points as vectors object path 
  Hidden experimental feature to save tracked frames as sequence of frame images
  (using the extension .XCF instead of .xml for the xml logging file triggers this feature)

- DetailAlign filter extended for parsing additional XML attributes 
  recorded by DetailTracking.
  
 
 * gap/gap_detail_align_exec.c
 * gap/gap_detail_tracking_exec.c [.h]
 * gap/gap_detail_tracking_main.c
 * gap/gap_filter_foreach.c
 * gap/gap_filter_pdb.c [.h]
 * gap/gap_lib.c
 * gap/gap_locate2.c


2015-09-19 Wolfgang Hofer <hof@gimp.org>

Merged MovePath dialog resize fix from gap-2.8 branch to master.

 * gap/gap_mov_dialog.c  

2015-05-29 Wolfgang Hofer <hof@gimp.org>

merged fixes and new move path merge feature from gap-2-8 branch
  move path merge down features, 
  fixes for 
    #699207 (automake version check), 
    #732837 (typos)
  
 * autogen.sh  
 * docs/reference/txt/plug-in-gap-onionskin-configuration.txt  
 * docs/reference/txt/STORYBOARD_FILE_DOC.txt  
 * gap/gap_apcl_lib.h  
 * gap/gap_blend_fill_main.c  
 * gap/gap_colormask_dialog.c  
 * gap/gap_decode_mplayer.c  
 * gap/gap_detail_align_exec.c  
 * gap/gap_detail_tracking_main.c  
 * gap/gap_fg_matting_dialog.c  
 * gap/gap_filter_foreach.c  
 * gap/gap_image.c  
 * gap/gap_image.h  
 * gap/gap_layer_copy.c  
 * gap/gap_layer_copy.h  
 * gap/gap_lib.c  
 * gap/gap_main.c  
 * gap/gap_morph_dialog.c  
 * gap/gap_morph_tween_dialog.c  
 * gap/gap_mov_dialog.c  
 * gap/gap_mov_dialog.h  
 * gap/gap_mov_exec.c  
 * gap/gap_mov_xml_par.c  
 * gap/gap_mpege.c  
 * gap/gap_onion_dialog.c  
 * gap/gap_onion_main.c  
 * gap/gap_range_ops.c  
 * gap/gap_split.c  
 * gap/gap_story_att_trans_dlg.c  
 * gap/gap_story_dialog.c  
 * gap/gap_story_file.c  
 * gap/gap_story_properties.c  
 * gap/gap_story_render_processor.c  
 * gap/gap_video_index_creator.c  
 * gap/gap_water_pattern.c  
 * gap/gap_wr_resynth.c  
 * vid_common/gap_cme_main.c  
 * vid_enc_avi/gap_enc_avi_gui.c  
 * vid_enc_avi/gap_enc_avi_main.c  
 * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c  
 * vid_enc_rawframes/gap_enc_rawframes_main.c  


2015-05-14 Wolfgang Hofer <hof@gimp.org>

imported all GIMP-2.8 related changes
from gap-2-8 branch to GIT master.

From now on GIMP_GAP master depends on GIMP-2.8
(no further support for outdated GIMP-2.6 planed)

Note that current GIMP_GAP is still developed
and tested based on the stable GIMP-2.8 version
But Future changes and fixes to work with latest GIMP
versions (GIMP-2.9.x or later) shall happen
in the GIT masterof the GIMP_GAP repository.
 



2015-05-14 Wolfgang Hofer <hof@gimp.org>

added options for ffmpeg windows crosscompiliation 

 * extern_libs/configure_options_ffmpeg_win32.txt

2015-05-14 Wolfgang Hofer <hof@gimp.org>

- fixed bug when loading Movepath from XML file
  (the FromFrames value was set incorrect with the toFrames value)
  
 * gap_mov_dialog.c

2015-05-14 Wolfgang Hofer <hof@gimp.org>
 - applied (just the missing parts) provided by patch attached to bugreport #749290
   to fix the map object iterator for use with GIMP-2.8.x releases

 * gap/iter_ALT/mod/plug_in_map_object_iter_ALT.inc

2014-07-05 Wolfgang Hofer <hof@gimp.org>

- additional workaround for windows 64bit specific crash of the master video encoder window
  on attempt to move the window.
  
   The GAP_GUI_USE_GTHREAD (configure option -disable-gui-thread-support )
   now just disables threads in the master video encoder
   (i.e. calls encoder specific plug ins for the encoder parameters dialog synchron)
   
   .. but still uses a worker thread for the non interactive call of the productive video encoder plugin.
   This way the encoder progress updates are still working in the master encoder GUI while the
   video encoder is running.
  
   the new configure option 
    --disable-enc-thread-support
  
   may be used to separtely force synchron calls of the video encoder.
   (but this shall not be necessary even for windows 64 bit environment)

- more fixes for #730239 - e.g. used in strings where it should be i.e. 
  

  * configure.in
  * gap/gap_cme_gui.c
  * gap/gap_fg_matting_dialog.c



2014-06-18 Wolfgang Hofer <hof@gimp.org>

- workaround for windows specific crash of the master video encoder window
  on attempt to move the window.
  
  (gtk seems to have a bug in WINDOWS 64 bit environment when the GUI uses threads
   see also http://stackoverflow.com/questions/15675751/gtk-window-moved-then-crash)
   
  fortunately the master video encoder GUI already provides a fallback 
  implementation without using threads that now can be compiled optionally
  via configure option:
  
  (this option shall be used for WINDOWS 64 bit builds 
  
  * configure.in
  * README
  * gap/gap_cme_gui.c

2014-05-30 Wolfgang Hofer <hof@gimp.org>

- fixed typos (applied path by Anders Jonsson see #730549)

- fixed endless loop in storyboard processor at attempt to read frames frome a video clip after EOF.

- fixed crash after loading movepath settings from xml file.
   (in case current point index is higher than number of available destination frames
   the next refresh crashed on windows7 environment)

- fixed movepath freeze caused by unbalanced mallog/free error
  in gap_lib_dir_ainfo_duplicate (must duplicate all referenced strings of the ainfo structure)

   * gap/gap_story_render_processor.c
   * gap/gap_player_dialog.c
   * gap/gap_mov_dialog.c
   * gap/gap_mov_exec.c
   * gap/gap_lib.c

   typos:

   * gap/gap_accel_char.c [.h]
   * gap/gap_accel_da.c
   * gap/gap_apcl_lib.h
   * gap/gap_audio_extract.c [.h]
   * gap/gap_audio_wav.c
   * gap/gap_blend_fill_main.c
   * gap/gap_colormask_dialog.c
   * gap/gap_detail_align_exec.c
   * gap/gap_detail_tracking_exec.c [.h]
   * gap/gap_drawable_vref_parasite.c
   * gap/gap_fg_matting_dialog.c
   * gap/gap_morph_tween_dialog.c
   * gap/gap_mov_dialog.c
   * gap/gap_mov_exec.c
   * gap/gap_navigator_dialog.c
   * gap/gap_onion_dialog.c
   * gap/gap_player_dialog.c
   * gap/gap_range_ops.c
   * gap/gap_split.c
   * gap/gap_story_att_trans_dlg.c
   * gap/gap_story_dialog.c
   * gap/gap_story_render_audio.c
   * gap/gap_story_render_processor.c
   * gap/gap_vex_dialog.c
   * gap/gap_wr_opacity.c
   * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c



2014-05-21 Wolfgang Hofer <hof@gimp.org>

- fixed bug at loading movepath settings from xml file
  (load must not overwrite current and cached image_is's)

- movepath disabled checks for too many controlpoints.
    the old implementation refused rendering 
    when the number of handled frames is less than the number of controlpoints.
       Error: More controlpoints (%d) than handled frames (%d).
       Error: Keyframe %d at point [%d] higher or equal than last handled frame
    
    now rendering is possible and the rest of controlpoints is ignored.

- detailtracking 
    fixed bug that captures invalid coordinates in case the path has only one point
    (p_capture_2_vector_points)


- fixed some typo's (according to patch by Anders Jonsson see #730034 and #730239 )

- fixed a lot of compiler warnings. (most of them in debug logging printf calls..)

 
   * gap/gap_accel_da.c
   * gap/gap_arr_dialog.c
   * gap/gap_audio_wav.c
   * gap/gap_blend_fill_main.c
   * gap/gap_colordiff.c 
   * gap/gap_colormask_dialog.c
   * gap/gap_colormask_exec.c
   * gap/gap_colormask_file.c
   * gap/gap_colormask_main.c
   * gap/gap_dbbrowser_utils.c
   * gap/gap_decode_mplayer_main.c
   * gap/gap_detail_align_exec.c
   * gap/gap_detail_tracking_exec.c
   * gap/gap_detail_tracking_main.c
   * gap/gap_edge_detection.c
   * gap/gap_filter_iterators.c
   * gap/gap_fire_pattern.c
   * gap/gap_fmac_base.c
   * gap/gap_fmac_context.c
   * gap/gap_fmac_main.c
   * gap/gap_fmac_varying_main.c
   * gap/gap_frame_fetcher.c
   * gap/gap_image.c
   * gap/gap_layer_copy.c
   * gap/gap_lib.c
   * gap/gap_locate.c
   * gap/gap_main.c
   * gap/gap_mod_layer.c
   * gap/gap_mod_layer_dialog.c
   * gap/gap_morph_dialog.c
   * gap/gap_morph_exec.c
   * gap/gap_morph_shape.c   
   * gap/gap_morph_tween_dialog.c  

   * gap/gap_mov_dialog.c
   * gap/gap_mov_exec.c [.h]
   * gap/gap_mov_main.c
   * gap/gap_mov_render.c
   * gap/gap_mov_xml_par.c

   * gap/gap_navigator_dialog.c
   * gap/gap_onion_base.c
   * gap/gap_onion_dialog.c
   * gap/gap_onion_main.c   
   * gap/gap_pdb_calls.c   
   * gap/gap_pixelrgn.c
   * gap/gap_player_cache.c
   * gap/gap_player_dialog.c
   * gap/gap_pview_da.c
   * gap/gap_range_ops.c
   * gap/gap_stock.c
   * gap/gap_story_dialog.c
   * gap/gap_story_file.c
   * gap/gap_story_properties.c
   * gap/gap_story_render_lossless.c
   * gap/gap_story_render_processor.c  [.h]
   * gap/gap_story_section_properties.c
   * gap/gap_story_sox.c
   * gap/gap_story_undo.c   
   * gap/gap_thumbnail.c
   * gap/gap_vex_dialog.c
   * gap/gap_video_index_creator.c
   * gap/gap_water_pattern.c
   * gap/gap_wr_color_balance.c
   * gap/gap_wr_color_curve.c
   * gap/gap_wr_resynth.c
   * gap/gap_wr_trans.c

 
   * libgapbase/gap_base.c
   * libgapbase/gap_timm.c [.h]
   * libgapbase/gap_val_file.c
 
   * libgapvidapi/gap_vid_api.c
   * libgapvidapi/gap_vid_api_ffmpeg.c
   * libgapvidapi/gap_vid_api_gimp.c 
   * libgapvidapi/gap_vid_api_mp_util.c 
   * libgapvidapi/gap_vid_api_mpeg3.c
   * libgapvidapi/gap_vid_api_mpeg3toc.c
   * libgapvidapi/vid_api_vidindex.c 
 
   * libgapvidutil/gap_gve_raw.c [.h]

   * vid_common/gap_cme_callbacks.c
   * vid_common/gap_cme_gui.c

   * vid_enc_avi/gap_enc_avi_gui.c
   * vid_enc_avi/gap_enc_avi_main.c

   * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks
   * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
   * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
   * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c

   * vid_enc_rawframes/gap_enc_rawframes_main.c
   * vid_enc_single/gap_enc_singleframes_main.c
   
   
2014-05-09 Wolfgang Hofer <hof@gimp.org>

- provide additional video encoder preset file: ff_x264_aac_hq.preset
  that uses the AAC audio codec.
  The other ff_x264_hq.preset uses the AC3 codec that is not supported
  by some players (as the Media player on my Windows7 64bit machine)

- Movepath now supports unlimted number of controlpoints
  (old implementation was restricted to maximal 1024 controlpoints)

- various fixes (found at tests on linux64 bit and windows 64 bit crosscomiple environment)
    - g_stat shall use GStatBuf
    - timestamps shall use time_t  (gap_file_get_mtime, gap_base_get_current_time)
    - fixed crash in query of some plug-ins @ gimp_lastval_desc_register call.
       (use fopen mode "wb" and "rb" -- do not mix "w" & "rb")
    - fixed crash in storyboard rendering when move path transition is used.
       (procedure gap_mov_exec_new_GapMovValues   
         must initialize:  pvals->dst_group_name_path_string = NULL;
       )
    - fixed crash in storyboard dialog
      - at attempt to copy a clip when storyboard was not yet saved 
        (and internal filename is still NULL)
        both via copy/paste or with drag&drop
      - sporadic crash at open clip property dialog window
         (memory overwrite @ gap_story_pw_properties_dialog
          in the loop that should reset the 3 elements of the array 
          pw->pw_mask_anchor_radio_button_arr)

    - added gap_dialog_new  with same interface as gimp_dialog_new
        - shall fix crash on attempt to move the dialog window 
          with the mouse on Windows7 64 bit system
          (-- this issue is not yet fixed ---)
        - open the dialog as "Normal Toplevel Window"
           (e.g. in foreground and with minimize/maximize/close widget decorations)


    Windows64 bit cross compilation was done on SuSE 13.1 Virtual machine

    Setup Linux For GIMP-GAP cross compilation
    o) installed most dependency libs from openSuSE 13.1 windows 64 bit
    o) have a script to setup environment varbles 
       (PREFIX, LD_LIBRARY_PATH and other stuff see the gimp wiki crsosscompile page)
    o) crosscompiled some dependency libs that were not provided as binary by openSUSE 13.1
    o) crosscompiled gimp-2.8.10 (see gimp wiki crsosscompile page)
    o) configured GAP:
    
       -) Add the options:
              --enable-cross-compile  --target-os=mingw32  --arch=x86_64
          to the file:  extern_libs/configure_options_ffmpeg_win32.txt
       -) run autogen.sh (or configure) with the following configure options:
           ./configure  --prefix=$PREFIX --host=x86_64-w64-mingw32 --disable-libmpeg3 --disable-ff-libxvid
   

   * ChangeLog
   * configure.in
   * extern_libs/configure_options_ffmpeg_win32.txt
   * gap/gap_arr_dialog.c
   * gap/gap_arr_dialog.h
   * gap/gap_audio_wav.c
   * gap/gap_detail_tracking_main.c
   * gap/gap_drawable_vref_parasite.c
   * gap/gap_fmac_context.h
   * gap/gap_frame_fetcher.c
   * gap/gap_lib.c
   * gap/gap_lib.h
   * gap/gap_mov_dialog.c
   * gap/gap_mov_dialog.h
   * gap/gap_mov_exec.c
   * gap/gap_mov_exec.h
   * gap/gap_mov_main.c
   * gap/gap_mov_render.c
   * gap/gap_mov_xml_par.c
   * gap/gap_navigator_dialog.c
   * gap/gap_onion_base.h
   * gap/gap_player_dialog.c
   * gap/gap_story_att_trans_dlg.c
   * gap/gap_story_dialog.c
   * gap/gap_story_file.c
   * gap/gap_story_file.h
   * gap/gap_story_main.h
   * gap/gap_story_properties.c
   * gap/gap_story_undo_types.h
   * gap/gimplastvaldesc.c
   * libgapbase/gap_base.c
   * libgapbase/gap_base.h
   * libgapbase/gap_file_util.c
   * libgapbase/gap_file_util.h
   * libgapvidapi/gap_vid_api.h
   * libgapvidapi/gap_vid_api_util.c
   * libgapvidapi/gap_vid_api_vidindex.c
   * libgapvidutil/gap_gve_misc_util.c
   * libgapvidutil/gap_gve_xvid.c
   * vid_common/gap_cme_callbacks.c
   * vid_common/gap_cme_gui.c
   * vid_common/gap_cme_main.c
   * vid_enc_ffmpeg/Makefile.am


   * vid_enc_ffmpeg/ff_x264_aac_hq.preset    # new file


2014-02-27 Wolfgang Hofer <hof@gimp.org>

- fixed bug in the GAP video API that caused endless loop in
  ffmpeg based video index creation.
  (p_wrapper_ffmpeg_get_next_frame retcode was not returned to the caller !)

- video index creator and player dialog:
    video index creation now shows the current frame count in the progress bar.
    This is done because the total number of frames to process is just a guess
    and the percentage is kept at constant level if there are (much) more frames to process
    (than assumed in the initial guess.)

- Updated iterator procedures to fit last values buffer structures
  for the plug-ins that are part of the GIMP-2.8.10 release.
  (some of them have changed their structure and are not compatible
  with GIMP-2.6.x releases)


- added information column in the filtermacro dialog 
  this column shows errors that occured when recording a filtercall.
  The current implementation marks filters with Error 1
  when the probe iteratorcall fails at recording time 
  (triggered by the Add button in the filtermacro dialog)
  
  The probe iteratorcall typically fails when the last values buffer
  (where the filter stores its parmaters) does not match the
  corresponding iterator implementation.


  * gap/gap_filter_iterators.c
  * gap/gap_fmac_main.c
  * gap/gap_name2layer_main.c
  * gap/gap_player_dialog.c
  * gap/gap_video_index_creator.c
  * gap/iter_ALT/gen/plug_in_blinds_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_checkerboard_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_destripe_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_engrave_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_fractal_trace_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_mblur_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_mosaic_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_newsprint_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_ripple_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_shift_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_video_iter_ALT.inc
  * gap/iter_ALT/gen/plug_in_waves_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_applylens_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_bump_map_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_colors_channel_mixer_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_dog_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_map_object_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_polar_coords_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_sinus_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_solid_noise_iter_ALT.inc
  * gap/iter_ALT/mod/plug_in_sparkle_iter_ALT.inc
  * libgapvidapi/gap_vid_api_ffmpeg.c


2014-02-22 Wolfgang Hofer <hof@gimp.org>
- extended filtermacro reference sidecar filformat (.fmref)
  .fmref files do describe persistent layer ids and 
  allow succesful applying a filter that requires additional layers
  (such as bumpmap that needs a layer for the map)
  with recorded lastvlues buffer in the next gimp session.

  The old format describes layer rference by imagname and stackposition.
  In case of nested layer this is not sufficient.
  
  Therefore the fileformat was exteded with keyword "parentstack:",
  followed by a list of integer stack positions of all parent group layers 
  concatenated by the "/" delimiter character.
  
  Note that toplevel layers are still refered without the new parentstack
  (== compatible to the old format) 

  id:800003 frameNr:000000 stack:02 track:-1 mtime:01392968915  type:3 file:"/home/hof/testimage.xcf" parentstack:2/0



- replaced deprecated gimp_drawable_is_valid calls by gimp_item_is_valid

- Filter All Layers feature now has options how to handle applying a filter to a group layer.
  The GAP filter db browser dialog provides radio buttons how to handle group layers.
    - normal mode (enables filter calls on group layer items)
    - merge group items before calling a filter
    - skip filtercalls on group items

  This feature is mainly a workaround for the fact, that many plug-in filters
  of the GIMP-2.8.10 release fail on attempt to process a group layer.
  
  Example: the  whirl-pinch plugin fails with the message:
  Calling error for procedure 'gimp-drawable-merge-shadow':
                  Item 'GR-1' (20) cannot be modified because it is a group item

- fixed issuses for the "FramesModify" feature
  when function "Apply filter on layer(s)" is selected.
  Support skip and automatical merge on selected group layers in the processed frames
  for this modify function.
  Notes:
    for filter apply with constant values (acceleration characteristic value == 0)
    the first processed frame must contain at least one layer 
    that matches the selection criteria.
    
    for filter apply with varying values both 
    the first and the last processed frame
    must contain at least one layer 
    that matches the selection criteria.
    
    This is required for the interactive filtercalls to record the
    last values buffer(s) for the called filter pdb procedure.
    

- dropped support for GAP_FILTER_PITSTOP environment variable
  the pitstop dialog is now configurable via gimprc parameters:
    (gap-filterall-enable-pitstop-dialog "no")
    (gap-modify-enable-pitstop-dialog "no")
  
  Both pitstop dialogs now have an option "do not show this dialog again"
  to disable those (optional) dialogs in the future (in this and further sessions).
  

  * gap/gap_blend_fill_main.c
  * gap/gap_dbbrowser_utils.c
  * gap/gap_dbbrowser_utils.h
  * gap/gap_edge_detection.c
  * gap/gap_fg_matting_dialog.c
  * gap/gap_filter_foreach.c
  * gap/gap_filter_iterators.c
  * gap/gap_fire_pattern.c
  * gap/gap_fmac_base.c
  * gap/gap_fmac_context.c
  * gap/gap_fmac_context.h
  * gap/gap_frame_fetcher.c
  * gap/gap_frame_fetcher.h
  * gap/gap_image.c
  * gap/gap_image.h
  * gap/gap_mod_layer.c
  * gap/gap_player_cache.c
  * gap/gap_water_pattern.c
  * gap/iter_ALT/mod/plug_in_bump_map_iter_ALT.inc



2014-02-15 Wolfgang Hofer <hof@gimp.org>

- applied fix for the foreground matting feature as suggested at bug #723818
  The warning "Problem!: final_confidence: %f\n" now shall be printed only in critical case.

  TODO: Note that GAP still uses a copy of the old foreground matting implementation
  The already available GEGL implementation will be used in future GAP versions
  targeted for the use with GIMP 2.10.

  * gap/gap_fg_matting.c
  * gap/gap_fg_matting_main.c

2014-02-15 Wolfgang Hofer <hof@gimp.org>

  - added LAYER GROUP support for the "FramesModify" feature.

     - Added Groupname and delimiter entry widgets where the user can
       specify the scope of the layer selection.
       (e.g. the name of the group that contains the layers that are to be selected)
       Nested groups can be selected as "MyGroup/SubGroup"
       Where the delimiter string "/" is used to split subgroup names.
       An empty Groupname refers to the images toplevel layers.
     
     - Added new Functions:
        Layer Stackposition/Raise layers(s) to top
        Layer Stackposition/Lower Layers(s) to bottom
        Layer Stackposition/Reorder Layer
        
        Merge Layers/Merge down layer(s) expand as necessary
        Merge Layers/Merge down layer(s) clipped to image
        Merge Layers/Merge down layer(s) clipped to bg-layer
        
        Create Layergroup
        
        ----------
        
        The Reorder Layer function provides new entries
          New Group Name
          New Position
        to specify the target group (empty name refers to toplevel image)
        and stackposition where the selected Layer(s) shall be moved to.
     
     - Modify Functions "Merge.." 
     

     - Modify Function "duplicate layer"  now creates the layer above the source layer
       (older versions placed the duplicate above the active layer)


  - replaced the follwing deprecated procedure calls
   
    gimp_drawable_get_###   gimp_item_get_###
    gimp_drawable_set_###   gimp_item_set_##
    gimp_image_raise_layer  gimp_image_raise_item
    gimp_image_lower_layer  gimp_image_lower_item


  * gap/gap_blend_fill_main.c
  * gap/gap_bluebox.c
  * gap/gap_colormask_exec.c
  * gap/gap_detail_tracking_exec.c
  * gap/gap_edge_detection.c
  * gap/gap_fg_matting_dialog.c
  * gap/gap_fg_matting_exec.c
  * gap/gap_filter_codegen.c
  * gap/gap_filter_foreach.c
  * gap/gap_filter_iterators.c
  * gap/gap_fire_pattern.c
  * gap/gap_image.c
  * gap/gap_image.h
  * gap/gap_layer_copy.c
  * gap/gap_lib.c
  * gap/gap_main.c
  * gap/gap_match.c
  * gap/gap_mod_layer.c
  * gap/gap_mod_layer.h
  * gap/gap_mod_layer_dialog.c
  * gap/gap_mod_layer_dialog.h
  * gap/gap_morph_dialog.c
  * gap/gap_morph_exec.c
  * gap/gap_morph_main.c
  * gap/gap_morph_shape.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_exec.c
  * gap/gap_mov_render.c
  * gap/gap_mov_xml_par.c
  * gap/gap_onion_base.c
  * gap/gap_player_dialog.c
  * gap/gap_range_ops.c
  * gap/gap_split.c
  * gap/gap_story_att_trans_dlg.c
  * gap/gap_story_render_processor.c
  * gap/gap_vex_exec.c
  * gap/gap_water_pattern.c
  * gap/gap_wr_resynth.c
  * libgapvidapi/gap_vid_api.c
  * libgapvidutil/gap_gve_png.c

2014-02-02 Wolfgang Hofer <hof@gimp.org>

- added LAYER GROUP Support in the "MovePath" dialog.
     Tis dialog now provides a "Target Group" and Delimiter entry
     To specifiy a Groupname where the rendered layer(s) shall be
     inserted in all processed frame images. 
     The groupname may also refere a subgroup when
     it is separeted by the specified delimiter character
     Example: 
        Delimiter: /
        Target Group: "animals/flying/birds"
        
     Note that an empty groupname refers to the image.
     (e.g. the rendered layer(s) are inserted at image level)
        
     The Stepmode loop for layer specific stepmodes 
     (loop, loop reverse, once, once reverse, ping pong)
     now iterates over the layers that are member of the same group as the selected
     Source Image/Layer. Selecting a toplevel Layer (or toplevel Grouplayer) iterates
     over all toplevel layers including all toplevel Grouplayers of the Source image.

 * gap/gap_image.c [.h]
 * gap/gap_mov_dialog.c [.h]
 * gap/gap_mov_exec.c [.h]
 * gap/gap_mov_main.c
 * gap/gap_mov_render.c [.h]
 * gap/gap_mov_xml_par.c
 * gap/gap_xml_util.c [.h]


2014-01-12 Wolfgang Hofer <hof@gimp.org>
- support for RAW files as "readonly" frame sequences for processing 
  as high bit depth video source in MovePath operations or Storyboard Clips.
  
  Note that the final video encoding (ffmpeg engine) still operates at 8 bit depth
  (This will not change in the near future) but rendering in GIMP
  can be done at higher bit depth.
  
  This feature was implemented to support rendering videos
  based on RAW frame sequences 
  (.cr2 files of a timelapse sequence shot on Canon EOS DSLR camera)
  
  To use RAW files you need a file load plug in that is capable to load
  RAW files without truncating them to 8 bit depth
  in non-interactive way (e.g. without opening a dialog
  for each processed frame)
  
  For my tests i used the 3rd party plug-in UFRaw (version 0.19.2)
  but it did not work properly out of the box.
  workaround: I patched the source ufraw-gimp.c by commenting out the line:
  //    if (run_mode == GIMP_RUN_NONINTERACTIVE) uf->conf->shrink = 8; 
  
  // because this causes loading at reduced size 1/8
  // (i have no idea what is it good for ??)
  
  new gimprc parameters
  ---------------------
  o) (gap-load-ufraw-%s "yes")
     force explicite call of the UFRaw file load plugin
     whenever GIMP-GAP loads a frame image non-interactive mode.
     
  
  o) (video-save-mode-for-%s "readonly")
     # NON-XCF frame processing/export overwrite behaviour:
        possible configuration values are:
         "overwrite"
           automaticaly overwrite the discfile image that corresponds 
           to the current frame (which is opened in the gimp session)
           on frame exchange opertions (such as go to next/previous frame)
           where the file save plug-in is called with the backround layer as active layer.
           
         "overwrite_flattened"
           automaticaly overwrite the discfile image that corresponds 
           to the current frame (which is opened in the gimp session)
           on frame exchange opertions (such as go to next/previous frame)
           where the current frame is flattened before calling the file save plug-in.
       
         "readonly"
           frame exchange will fail in case the current frame image has
           unsaved changes (e.g. the dirty flag is set).
           GIMP-GAP does not overwrite frame files on disc in this mode.
           It is intended for fileformats where export/overwrite
           is not available or not wanted.
       
         "readonly_discard"
           GIMP-GAP does not overwrite frame files on disc in this mode,
           but discards unsaved changes without any notice on frame exchange.
           USE THIS ONLY WHEN YOU KONW WHAT YOUR DIONG ON YOUR OWN RISK !



  * gap/gap_lib.c
  * gap/gap_pdb_calls.c [.h]
  * docs/reference/txt/gap_gimprc_params.txt

2014-01-12 Wolfgang Hofer <hof@gimp.org>

- audio resample via external tool (sox) did not work in WINDOWS environment.
  The old code was restricted to Unix only.
  Fixed the parameter substitution and use g_spawn_sync for the external audio converter call
  that now shall work on other operating systems than unix.
  
  tests on windows with sox as external converter were successful,
  but only in case when the external converter was configured with
  the full absolute path.
  sox is available on Linux, Windows, and MacOSX
  see http://sox.sourceforge.net/

  (note that this fix was already done 2013-01-16 in my local 
   environment and already mentioned in the commit message on that date
   .. but the file gap/gap_story_sox.c was forgotten to be added in the commit
   .. now i recognized that mistake and can provide the fix)

  * gap/gap_story_sox.c

2013-11-09 Wolfgang Hofer <hof@gimp.org>
  - fixed comment lines 
    (related to #711402)
 
   OLD:
     * along with this program; if not, write to the Free Software

   NEW:
    * License along with this library.  If not, see

   (due to a bug in my "replace in all sources" scripts
    this changes were not performed at the previous attempt)


  * This again touched nearly all *.c and *.h files
  
2013-11-09 Wolfgang Hofer <hof@gimp.org>
  - replaced more software address of Free software foundation in the 2-8 branch sources
     OLD: * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
     NEW: * <http://www.gnu.org/licenses/>.

2013-11-09 Wolfgang Hofer <hof@gimp.org>

  - replaced outdated Incorrect software address of Free software foundation 
    in comments in the 2-8 branch sources (assuggested in #711402)
 
   OLD:
     * You should have received a copy of the GNU General Public License
     * along with this program; if not, write to the Free Software
     * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NEW:
    * You should have received a copy of the GNU Lesser General Public
    * License along with this library.  If not, see
    * <http://www.gnu.org/licenses/>.
  
  * This touched nearly all *.c and *.h files

2013-09-09 Wolfgang Hofer <hof@gimp.org>

- Replaced some deprecated calls by gimp-2.8 compatible pendants.
  (this task is not yet finished, but current GAP should now run
  both with GIMP-2.8 and GIMP-2.9 git master with remarkable less annoying deprection warning pop up windows)
  
  Handled so far:
     gimp_selection_load        ==> gimp_image_select_item
     gimp_drawable_transform_*  ==> gimp_item_transform_*
     gimp_image_add_layer       ==> gimp_image_insert_layer (was already done at creation of branch gap-2-8)
     
  gap-2-8 branch now requires at least gimp-2.8.0 version.

  * configure.in
  * gap/gap_fg_matting_exec.c
  * gap/gap_image.c
  * gap/gap_mod_layer.c
  * gap/gap_mov_render.c
  * gap/gap_wr_resynth.c
  * gap/gap_wr_trans.c

  * gap/gap_layer_copy.c
  * gap/gap_pdb_calls.c
  * gap/gap_story_file.c
  * gap/gap_story_render_processor.c

  * gap/gap_detail_align_exec.c
  * gap/gap_mov_render.c

  (2013-07-21) merged latest features from master to gap-2-8 branch


- Moved render framename feature to submenu.
   from menu  <Image>/Video/Filename to Layer
   to menu    <Image>/Video/Layer/Render/Filename to Layer
 
   
- added support for processing of incomplete frame sequences where some frame images are missing.
  old behaviour handled this case as error condition and stopped processing.
  new behaviour makes attempts to find the next available framenumber and continues
  processing when a next frame image can be found.

  The implemted strategy checks some (10) potential next frame numbers
  and triggers a directory scan (that is more expensive tha a single file exists check)
  in case when more frames are missing.
  Example how this works:
  
      IMG_0050.XCF
      IMG_0051.XCF
      ............   (frames 52 to 59 are missing and will be checked via
                      if (IMG_nr.XCF exists) in a loop.
                      processing continues with IMG_0060.XCF)
      IMG_0060.XCF
      IMG_0061.XCF
      IMG_0062.XCF
      ............   (frames 62 to 89 are missing
                      after 10 failed attempts if (IMG_nr.XCF exists)
                      a directory scan is performed to find the next framenumber 90
                      and processing continues with IMG_0090.XCF)
      IMG_0090.XCF
      
  The following features (menu entries) were updated
  to support the new behaviour:

   Video/Go to/Next Frame
   Video/Go to/Previous Frame
   Video/Delete Frames
   Video/Duplicate Frames
   Video/Frames To Image
   Video/Frames Flatten
   Video/Frames Layer Delete
 
   Video/Frames Convert
   Video/Frames Resize
   Video/Frames Crop
   Video/Frames Scale
   Video/Frame Sequence Shift
   Video/Frame Sequence Reverse
   Video/Frames Renumber
   Video/Frames Modify

   Video/VCR navigator
     - dont show old thumbnails when corresponding image does (no longer) exits.
     - show icons for all frames in range from first frame number up to last frame number.
       all missing frames are shown but rendered as default icon.

   Video/Onionskin/*
     process all available frames in range but no longer stop
     when frames are missing.
     skip onionskin rendering whenever referenced frame 
          (at number +n or -n) is not available.

   Video/Playback   
    implemented new preferences option to automatically skip missing frames at playback
    OFF: missing frame images are shown as fully transparent (checker board) 
    ON:  automatically step over missing frames
    
    this option is persisted as new gimprc parameter
        "video_player_enable_auto_skip_missing_frames"
        
   Video/Movepath   
    autoskip rendering of missing frames.
    (and also skip missing frames in the moving object
    when Frame based source stepmodes are used)


   NOTE:
      Missing frames in storyboard clips (with cliptype frames)
      are still handled as ERROR.
      .. and there are no plans to support autoskip of the missing frames there.
         Because this would 
         - remarkable slow down both storyboard rendering and editing.
           To get the amount of frames included in a clip
           this feature would require a directory scan
           and not just a simple calculation 1 + (end_range - start_range)
         - be much effort and makes the code more complex..


           


  * gap/gap_lib.c [.h]
  * gap/gap_image.c [.h]
  * gap/gap_base_ops.c
  * gap/gap_range_ops.c
  * gap/gap_mod_layer.c
  * gap/gap_player_main.c [.h]
  * gap/gap_player_dialog.c
  * gap/gap_story_main.h 
  * gap/gap_story_dialog.c 
  * gap/gap_story_render_processor.c 
  * gap/gap_navigator_dialog.c
  * gap/gap_name2layer_main.c  
  * gap/gap_onion_base.c
  * gap/gap_onion_worker.c

  * gap/gap_mov_exec.c
  * gap/gap_mov_render.c [.h]




   (added local features from 2013-06-02 that were not yet published until now)

- workaround for winodows specific Audio Playback deadlock on short clips (only 1 frame)

- added capability to set layermode in storyboard processing via filtermacro.
   Therfore GIMP-GAP now provides a wrapper plug-in (gap_wr_layermode.c)
   to set the layermode.
   This wrapper plug-in can be recorded as filtermacro, and applied
   to clips while storyboard processing via filtermacro calls.

- support autogen versions 1.13 1.12 (as suggested in #699207)

- Storyboard toggle unit support to display src frame number and frame count
  as additional mode.



  * autogen.sh
  * gap/Makefile.am
  * gap/gap_wr_layermode.c # new file
  
  * gap/gap_player_dialog.c
  * gap/gap_range_ops.c
  * gap/gap_story_render_processor.c 
  * gap/gap_story_dialog.c
  * gap/gap_story_main.h


2013-02-20 Wolfgang Hofer <hof@gimp.org>

- 2nd. bugfix for creation of storyboard from video extract plug-in.
  fixes crash on attempt to save the created storyboard immediate after creation.
   [the internal copy of the filename in the GapStoryBoard struct
    was replaced (OK) but then free'd (NOT OK)]

  * gap/gap_story_dialog.c

2013-02-19 Wolfgang Hofer <hof@gimp.org>

- storyboard debug features now support logging to file.
  This can be optionally configured in the file "GAP_DEBUG_STORYBOARD"  (located in gimpdir)
  by adding a line like this:
    logfile=/tmp/GAP_STORYBOARD_DEBUG.log  

  or like that (on Windows):
    logfile=S:\SsdShare\GAP_STORYBOARD_DEBUG.log
  
  Note that logging to stdout is default, in case no logfile is specified.
  (the filename must start immediate after the = character,
   blanks in the logfilename/path are not supported !)

  This feature was added for analyse of Storyboard bugs in Windows environment.

- bugfix creation of storyboard from video extract plug-in.
  A broken storyboard was created (with section list NULL)
  


  * gap/gap_story_dialog.c
  * gap/gap_story_file.c [.h]
  * gap/gap_story_undo.c [.h]
  * gap/gap_story_vthumb.c [.h]
  
  * gap/gap_vex_dialog.c
  * gap/gap_vex_exec.c

2013-02-10 Wolfgang Hofer <hof@gimp.org>

- added audio support for other Operating Systems than Linux.
  Audio playback now can be configured to use an SDL media library based
  audio playback module (as alternative to the already existing
  wavplay client/server based audio playback).

  The configure option --disable-audio-support was removed and
  replaced by the new options: 

     --disable-audio-support-sdl
     --disable-audio-support-wavplay  

  on Linux
    enable-audio-support-sdl is default
    enable-audio-support-wavplay  is fallback (when SDL library is not installed)

  on Windows
    enable-audio-support-sdl is default,
    
    NO audio playback possible when SDL library  library is not installed)
    

  The SDL library is available for Linux, Windows and MacOS


    * configure.in
    * Makefile.am
    * gap/Makefile.am
    * gap/gap_apcl_lib.h              #new file
    * gap/gap_sdl_audioplayer.c [.h]  #new files
    * gap/gap_player_dialog.c

2013-01-16 Wolfgang Hofer <hof@gimp.org>

- fixed bug in the storybard master properties that truncated framerate to integer values.

- audio resample via external tool (sox) did not work in WINDOWS environment.
  The old code was restricted to Unix only.
  Fixed the parameter substitution and use g_spawn_sync for the external audio converter call
  that now shall work on other operating systems than unix.
  
  tests on windows with sox as external converter were successful,
  but only in case when the external converter was configured with
  the full absolute path.
  sox is available on Linux, Windows, and MacOSX
  see http://sox.sourceforge.net/

- Support audio rendering of an audiotrack that is an extracted audiotrack from a videofile.
  I used this as workarond in case of unsupported audio codec.
  The workaround allows extract the audio with another external tool (that supports the codec)
  and then refere the external audiotrack in same way as internal audiotracks. 
  (e.g. access it in the storyboard by frame numbers via AUD_PLAY_MOVIE)
    
    ==> manually edit the Storyboard and 
          replace AUD_PLAY_MOVIE .... "my_video.mpg"
          by      AUD_PLAY_MOVIE .... "my_video_extracted_audio.wav"

- Added a new feature that creates a storyboard triggered by
  the video extract plug-in.
  The new output mode creates the stroryboard from the videofile,
  adds the current selected range as initial clip,
  and opens the created storyboard in the storyboard editor dialog.

- new boolean gimprc parameter video-enable-storyboard-debug-features
  enables the debug menu in the storyboard dialog
  and preview image extraction by click on the preview image 
  in the storyboard attributes dialog window.

- fixed a bug in rendering the preview of clip type movie 
  in the storyboard attributes dialog window.
  (This bug did occure with gimp-2.6.11 running on Windows7
   but did not occure with gimp-2.6.11 on Linux)

- automake version check support for automake-1.12

  * autogen.sh
 
  * gap/gap_story_sox.c
  * gap/gap_story_render_audio.c
  * gap/gap_story_main.c [.h]
  * gap/gap_story_dialog.c [.h]
  * gap/gap_story_att_trans_dlg.c
  * gap/gap_story_render_processor.c [.h]
  * gap/gap_vex_dialog.c [.h]
  * gap/gap_vex_exec.c [.h]
  * gap/gap_vex_main.c [.h]
  
  * docs/reference/txt/gap_gimprc_params.txt
  
  * vid_common/gap_cme_gui.c   
 
    
2012-09-30 Wolfgang Hofer <hof@gimp.org>

- fixed german menuname translations. Translated message must keep the prefix "<Image>"
  (that must NOT be translated to "<Bild>")

  fixes lots of translation warnings at Gimp startup with 
  in german  setting  (LANG=de_DE.UTF-8)
  that look like this:

   bad translation "<Bild>/Ebene/Transparanz/"
   for menu path   "<Image>/Layer/Transparency/"
   (<Prefix> must not be translated)


 * po/de.po


2012-09-26 Wolfgang Hofer <hof@gimp.org>

- Performance relevant changes for storyboard when rendering
  large images.
  o) gap_frame_fetcher supports caching of prescaled images.
  o) storyboard render processor look ahead when processing
   frame types GAP_FRN_IMAGE or GAP_FRN_ANIMIMAGE
   and calculate the max prescale size.
   
   look ahead as far as the same imagename is used.
   
   procedure: p_stb_render_image_or_animimage

   - "gap-image-delete-workarond"
   
    The workaround disables undo and scales the image down to miniumum size
    before calling the gimp_image_delete procedure.
    this way memory resources for big layers will be freed up immediate.
    
    Note that this workaround implematation is already present in previous
    GIMP-GAP versions but now can be turned off via gimprc configuration.
    
    When using GIMP-GAP with gimp-2.6.x it is recommanded to enable this workaround
    (otherwise encoding videos or stroryboard editing may quickly run out of memory
    because lots of internally rendering is done by creating temporary images
    and deletes them immediate after processing).
    
    This workaround may not be required when GIMP-GAP is used with newer gimp
    versions. (not yet tested)

 * gap/gap_image.c
 * gap/gap_frame_fetcher.c [.h]
 * gap/gap_story_render_processor.c



2012-08-28 Wolfgang Hofer <hof@gimp.org>

- Speed up for the BlendFill filter.
  Use tile chache and write back only changed rows/columns
  for performance reasons.

 * gap/gap_blend_fill_main.c


2012-06-07 Wolfgang Hofer <hof@gimp.org>

- Implementation of dialog window for the exact align transform filter.
  Now supports 2 modes for path point interpretation.
  The mode is persisted as gimprc setting

     (gap-exact-aligner-path-point-order "0")
     (gap-exact-aligner-path-point-order "1")

  where value 0 (default) is compatible behavior to previous
  implementation (and to the exact aligner script
  that is available in the plug-in regstry)

  use mode TRANSFORM-RESIZE-ADJUST (0) for the transformation
  because this feature is intended to do no clipping.
  
 * gap/gap_detail_align_exec.c [.h]
 * gap/gap_detail_tracking_main.c


2012-05-26 Wolfgang Hofer <hof@gimp.org>

- added AC_CHECK_LIB(gthread-2.0, g_thread_init)
  as suggested in #676701 to fix build on ubuntu 12.10
  
 * configure.in


2012-05-05 Wolfgang Hofer <hof@gimp.org>

- the configure.in script displays error message in case
  when the pkg-config program is not executable.

 * configure.in

2012-05-02 Wolfgang Hofer <hof@gimp.org>

- fixed Bug #675188 Frame filename matching misses 8-digit frame numbers
- fixed Bug #675187 Frame Sequence Reverse handles filename improperly

 * gap/gap_lib.c

2012-01-29 Wolfgang Hofer <hof@gimp.org>

- fixed a bug in the GAP video API that caused a crash when decoding audio.
  This bug occured when GIMP-GAP was built with ffmpeg confiure options that enabled MMX
  and ac3 or aac encoded audio was extracted from videofiles.
  The fix uses an additional aligned buffer (required for proper operation of MMX based
  audio format conversions)
  Note that the current implementation of this fix eliminates the performance advantage 
  of MMX for the audio conversion, but enabled MMX is still preferable for video processing.
  
  The fix is relevant for both ffmpeg-0.6.1 and ffmpeg-0.7.11

- update to ffmpeg-0.7.11 "Peace" that was released on 2012-01-12
  removed confiure "--enable-libfaad" (that is no longer supported by ffmpeg-0.7.11.)

  The gimp-gap configure.in script now checks for the yasm assembler
  and automatically adds --disable-yasm configure option when configuring
  the ffmpeg libraries build.
  It displays a warning that installation of yasm is recommanded
  for the ffmpeg build in that case.


  The ffmpeg configure call now uses the options:
   --disable-ffmpeg  --disable-ffplay  --disable-ffprobe  --disable-ffserver 
  because those binaries are not required to build GIMP-GAP
  and may cause fail of the build in case different librariy versions
  are available on different locations.

      The ffmpeg build of those binaries failed in my environment with
          older libx264 installed at /usr/lib 
          and newer version at /usr/local/lib
      but built successful when building just the static libs without the ffmpeg binaries.

  - compile support for older ffmpeg 0.6 is still there.
     replace extern_libs/ffmpeg.tar.gz with an older 0.6, or 0.6.1 tarball
     and remove the extern_libs/ffmpeg directory before
     running the autoconf.sh script to build gimp-gap with the older versions)

  - #define GAP_USES_OLD_FFMPEG_0_6  when compiling against 0.6 or 0.6.1
   
  - support new encoder flags: (via preset parameterfile and GUI)
     epp->codec_FLAG2_INTRA_REFRESH        = 0; /* 0: FALSE */

  - new encoder codec parameters (supported via preset parameterfile):
    gdouble crf_max;               // float crf_max;
    gint32  log_level_offset;      // int log_level_offset;
    gint32  slices;                // int slices;
    gint32  thread_type;           // int thread_type;
    gint32  active_thread_type;    //  int active_thread_type;
    gint32  thread_safe_callbacks; // int thread_safe_callbacks;
    gint64  vbv_delay;             // uint64_t vbv_delay;
    gint32  audio_service_type;    // enum AVAudioServiceType  audio_service_type;
  
- new plug-in to fill selected (small) areas by blending surrounding
  colors to cover pixel errors. Intended to fix videos
  shot with (my) camera that has some defect sensor pixels.

- new plug-in to for tracking a detail over a sequence of video frames.
  This plug-in is typically triggered by the Player and records the movement
  as XML file usable with the MovePath plug-in.
  Intended to compensate unwanted camera movements.
  
  implemented alternative locate algorithm that
  uses gimp regions more efficient than the old one.
  (runs at least 10 times faster)
  
  per default all calls of the old procedure
  are redirected to use the newer implementation.
  With the gimprc parameter "
  (gap-locate-details-use-old-algorithm "yes")
  the old implementation can be enabled
  -- for more test and compare purpose on further development cycles--) 

- new plug-in inspired by the "exact aligner" script.

  This plug-in can operate on XML files (recorded with the detail tracking feature)
  to align multiple frames when called as filter with the frames modify feature.
  

- the module gap_pixelrgn implements the procedure 
  gap_gimp_pixel_rgns_unref to enable clean escape
  from loops based on gimp_pixel_rgns_register, gimp_pixel_rgns_process.

  * Usage CODE example:
  *
  *  for (pr = gimp_pixel_rgns_register (2, &PR1, &PR2);
  *      pr != NULL;
  *      pr = gimp_pixel_rgns_process (pr))
  *  {
  *      ... evaluate pixel data in pixel regions PR1, PR2
  *      ...
  *      if (further evaluation of the remaining tiles is not necessary)
  *      {
  *        // escaping from the loop without the call
  *        // to gap_gimp_pixel_rgns_unref
  *        // leads to memory leaks because of unbalanced tile ref/unref calls.
  *        break;
  *      }
  *  }
  *  if (pr != NULL)
  *  {
  *    gap_gimp_pixel_rgns_unref(pr);
  *  }
  
  NOTE:  A procedure like gap_gimp_pixel_rgns_unref
  that deals with libgimp internal private structures
  should better be part of libgimp.
  (and should be generally available for plug-in development
  in future gimp releases.)
  BUT: The GIMP-GAP implementation would still be required for backwards compatibilty
  with GIMP-2.6.x releases.
  
- fixed wrong dialog title in the MovePath single frame apply feature

- MovePath rotation Threshold
  The old move path implementation ignores rotate values between -0.5 and + 0.5 degree.
  The threshold is intended for better render performance by skipping
  rotate transformations when angle is nearly 0.
  The hardcode value 0.5 is too high (especially for larger frame sizes introduced with HD video)
  
  The new implementation allows to configure this threshold 
  in the range 0.0 upto 1.0 degree.
  The new default threshold is configurable via gimprc parameter. "video-move-path-rotate-threshold"
  and now the default is set to 0.015 degree that shall result in smoother rotations.
  individual rotateThreshold configuration is supported via MovePath XML file.
  The rotate_threshold value is not exposed in the Dialog.


 * NEWS
 * configure.in  
 * po/POTFILES.in
 * libgapbase/gap_base.c [.h]
 * docs/reference/txt/gap_gimprc_params.txt  

 * gap/Makefile.am
 * gap/gap_mov_dialog.h
 * gap/gap_mov_exec.c  [.h]
 * gap/gap_mov_render.c
 * gap/gap_mov_xml_par.c

 * gap/gap_image.c [.h]
 * gap/gap_player_main.c [.h]
 * gap/gap_player_dialog.c 
 * gap/gap_locate.c 
 * gap/gap_colordiff.c [.h]
 * gap/gap_edge_detection.c [.h]

 * gap/gap_blend_fill_main.c             # new file
 * gap/gap_detail_align_exec.c [.h]      # new files
 * gap/gap_detail_tracking_exec.c [.h]   # new files
 * gap/gap_detail_tracking_main.c        # new file
 * gap/gap_locate2.c [.h]                # new files
 * gap/gap_pixelrgn.c [.h]               # new files

 * extern_libs/ffmpeg.tar.gz                # updated to ffmpeg release 0.7.11
 * extern_libs/README_extern_libs  
 * extern_libs/configure_options_ffmpeg_win32.txt
 * extern_libs/configure_options_ffmpeg.txt

 * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
 * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
 * libgapvidapi/gap_vid_api_ffmpeg.c


2011-11-30 Wolfgang Hofer <hof@gimp.org>

- added option to merge visible layers
  in the frames convert plug-in
  This option merges the visible layers (and removes
  the invisible layers) in the converted copy
  to keep transparency before calling the file save plug-in.
  This is useful for formats like PNG that can handle transparency,
  but can not handle multiple layers.
  (this feature was suggested in #665142)


- Increased limits for animated filter apply last values buffer size
  allow filtermacro with last values buffer larger than 255 bytes.
  Note that current processing is still limited by intrnal buffer size for
  reading one line via gap_val_file procedures.

  gap_val file increased internal buffer to handle line length upto 16000 bytes
  (old limit was 4000 bytes) GAP_VAL_MAX_BYTES_PER_LINE

  
- bugfix  Storyboard render processor ignored the move-path transformation
  in case of processing a frame image in the 1st track 
  when the move-path was the only transformation.


- bugfix  MovePath xml paramfile.
  Keyframe information was not saved to XML file in case the keyframe number
  is lower or equal to the lower frame number of the specified frame range.
  This unexpected behavior is caused by checking for valid relative keyframe number.
  The save procedure was changed to save the absolute keyframe numbers
  this fixes the problem and makes the xml file content easier to understand.
  Note that loading now supports both relative <keyframe nn> and absolute <keyframe_abs nn>
  to ensure compatibility with already existing move path xml files.

  note that the same problem occurs with the old controlpoint format
  but will not be fixed there becuse the change would break backwards compatibility
  -- backwards compatibility is the only reason why the old format is still supported --

 * libgapbase/gap_val_file.c [.h]
 * gap/gap_fmac_base.c

 * gap/gap_mov_xml_par.c
 * gap/gap_story_render_processor.c

 * gap/gap_main.c
 * gap/gap_range_ops.c
 * gap/gap_image.c [.h]


2011-11-23 Wolfgang Hofer <hof@gimp.org>

 * gap/Makefile.am
- Foreground selection: fixed parameters for non interactive calls.

- new feature: foreground extraction from current selection.
  This feature generates the tri map by filling shrinked and expanded
  variants of the current selection, and uses the alpha matting algoritm
  to create a duplicate of the layer. Transparency of the duplicate
  is automatically trimmed to the foreground object shape in the range
  between shrinked and expanded selections variants.

 * po/POTFILES.in
 * gap/Makefile.am
 * gap/gap_fg_matting_exec.c [.h]
 * gap/gap_fg_matting_main.c [.h]
 * gap/gap_fg_from_sel_dialog.c [.h]                             # new files
 * docs/reference/txt/plug-in-selection-to-foreground-layer.txt  # new file
 * docs/reference/txt/Makefile.am


2011-11-12 Wolfgang Hofer <hof@gimp.org>

- added implementation of the foreground extraction via alpha matting algorithm
  as plug-in.
  The code is a modificated copy of the implementation as
  GIMP-tool originally done by Jan Ruegg.
  (you can find the original at the un-official GIT repository:
        https://github.com/rggjan/Gimp-Matting
        IMPORTANT:  be sure to check out the "new_layer" branch...)

  The quality of the alpha matting results are more promising than the
  offical GIMP foreground extraction ( based on the  SIOX algorthm)
  and may be a base for future GAP features to add 
  transparency for video frames.

- using --disable-vaapi option to configure ffmpeg
  to avoid linking problems on platforms where libva
  based video acceleration is installd.
  (thanks to AndrzejL.PCLinuxOS@gmx.com for pointig out
  this kind of problems on the PCLinuxOS platform)
  Note that gimp-gap and the FFmpeg project, does not support VA-API, 
  but libavcodec (also part of the FFmpeg project) does contain code 
  that other applications use to support hardware accelerated decoding, including VA API."

- added HD video sizes entries to the combo box
  in the master video encoder dialog.

- ffmpeg encoder parameter dialog hides the complex settings by default
  and shows only the presets, aspect and comment that is sufficient for
  the most users.

- keep title,author,copyright an comment when load / select another preset.
 
- added video encoder preset for HD video encoding with the x264 codec.
  the ffmpeg based encoder now checks for preset in the systemwide gimp_data_diretory
  and the user specific gimp_directory

- disabled all hardcoded presets and installed same presets as preset file.


  NOTE: presets that refere to invalid codecs are no longer shown in the dialog.
  e.g. the new HD x264 preset is not shown in case GIMP-GAP is compiled without
  libx64 support for the ffmpeg encode engine.

 * NEWS  
 * po/POTFILES.in

 * gap/Makefile.am
 * gap/gap_fg_matting_main.c [.h]    # new files
 * gap/gap_fg_matting_exec.c [.h]    # new files
 * gap/gap_fg_matting.c	[.h]         # new files
 * gap/gap_fg_matting_dialog.c [.h]  # new files
 * gap/gap_fg_regions.c [.h]         # new files
 * gap/gap_fg_tile_manager.h         # new file

 * vid_enc_ffmpeg/Makefile.am
 * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
 * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c [.h]
 * vid_enc_ffmpeg/ff_divx_hq.preset         # new file
 * vid_enc_ffmpeg/ff_divx_low.preset        # new file
 * vid_enc_ffmpeg/ff_divx_standard.preset   # new file
 * vid_enc_ffmpeg/ff_divx_win.preset        # new file
 * vid_enc_ffmpeg/ff_mpeg1_hq.preset        # new file
 * vid_enc_ffmpeg/ff_mpeg1_vcd.preset       # new file
 * vid_enc_ffmpeg/ff_mpeg2_dvd.preset       # new file
 * vid_enc_ffmpeg/ff_mpeg2_svcd.preset      # new file
 * vid_enc_ffmpeg/ff_real_standard.preset   # new file
 * vid_enc_ffmpeg/ff_x264_hq.preset         # new file
 * vid_common/gap_cme_main.h
 * vid_common/gap_cme_gui.c
 * vid_common/gap_cme_callbacks.c
 * extern_libs/configure_options_ffmpeg_win32.txt
 * extern_libs/configure_options_ffmpeg.txt


 * gap/gap_lib.c [.h]
 * gap/gap_layer_copy.c
 * docs/reference/txt/Makefile.am  
 * docs/reference/txt/INTRODUCTION.txt  
 * docs/reference/txt/gap_gimprc_params.txt  
 * docs/reference/txt/plug-in-foreground-extract-matting.txt            #new file 



2011-10-12 Wolfgang Hofer <hof@gimp.org>


- applied changes based on patche provided Thibaut Paumard 
  to fix build problems with option -Werror=format-security #660250
  
  note that patch provided at #660262 was not applied 
  because all the adresses issues for 64 bit environment
  are already fixed in the main latest version.



- fixed bug in the makefile for extern_lib (data hook for removing static libs)
  as reported in #642512

 * extern_libs/Makefile.am

 * gap/gap_arr_dialog.c
 * gap/gap_split.c
 * gap/gap_fmac_base.c
 * gap/gap_fmac_main.c
 * gap/gap_morph_exec.c
 * gap/gap_vex_dialog.c
 * libgapvidutil/gap_gve_sox.c
 * vid_common/gap_cme_gui.c

 * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c


2011-10-02 Wolfgang Hofer <hof@gimp.org>

- explicitly link with libm (patch provided by Ismail Donmez <idonmez@suse.com>. #660443)
- added plural handling for several strings as suggested in #659447 
- include the public visible header (libgimpwidgets/gimpwidgets.h)
  instead of the private headers gimpwidgetstypes.h gimphelpui.h
  (this fix is required to build GIMP-GAP for GIMP-2.7.x or latest GIT versions
  note that GIMP-GAP is still backwards compatible to GIMP-2.6.x versions)
- Disabled Tween frame morphing in case called on a single frame image
  (and show information "This operation requires more than one frame."
  in the dialog window)


 * libgapbase/gap_base.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
 * vid_common/gap_cme_gui.c
 * gap/gap_morph_tween_dialog.c
 * gap/Makefile.am





2011-09-18 Wolfgang Hofer <hof@gimp.org>

- fixed configure / compile problems in MinGW environment
  Now the configure script is using a MinGW variant of ffmpeg_configure options
  The configuration that built usable Winows video encoder plug-in.exe files im my tests
  is now the default setting in MinGW environment.
  see extern_libs/configure_options_ffmpeg_win32.txt for more details.

- fixed "array subscript is above array bounds" error in run procedures of the video encoder plu-ins 

 * configure.in
 * autogen.sh
 * extern_libs/configure_options_ffmpeg_win32.txt       #new file
 * extern_libs/configure_options_ffmpeg.txt
 * extern_libs/Makefile.am
 * libgapbase/gap_base.c
 * gap/gap_frame_fetcher.c
 
 * vid_enc_single/gap_enc_singleframes_main.c
 * vid_enc_rawframes/gap_enc_rawframes_main.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
 * vid_enc_avi/gap_enc_main_avi.c

2011-05-08 Wolfgang Hofer <hof@gimp.org>

- added edit button in the Storyboard attributes dialog
  to pop up a movepath edit dialog window
  for creation and edit of movepath settings.

- handle undo / redo for edited movepath xml paramter file content
  when edited via the new edit button in the Storyboard attributes dialog

 * gap/gap_lib.c [.h]
 * gap/gap_mov_dialog.c [.h]
 * gap/gap_mov_exec.c
 * gap/gap_story_att_trans_dlg.c
 * gap/gap_story_main.h
 * gap/gap_story_dialog.c
 * gap/gap_story_undo.c [.h]
 * gap/gap_story_undo_types.h
 


2011-04-27 Wolfgang Hofer <hof@gimp.org>

- fixed a bug in procedure gap_mov_xml_par_save that did write an invalid 
  xml movepath parameter file
  and added error handling in the xml parser.

 * gap/gap_mov_xml_par.c

2011-04-26 Wolfgang Hofer <hof@gimp.org>

- Storyboard render processor now supports processing
  of new transition attribute record VID_MOVE_PATH
   (based on the new singleframe mode of the move path feature)

- Move Path now supports save of all settings (controlpoints and other relevant settings)
  using a new XML stuctured fileformat.
  Note that the old controlpoint file format is still supported both for load and save.
  The new format is selected implicite by finename extension .xml 

- New plug-in to call the MovePath for rendering only one frame where the
  moving object is an already existing layer of the frame and all parameters
  are provided via xml parameterfile
  (this new feature is intended to be called as filter with the modify frames
  feature)

- The MovePath feature is still limited to process image types RGB 
  (both for the frame and the moving object)
  Therefore the PDB requstration was changed  
   from "RGB*, INDEXED*, GRAY*"
   to   "RGB*"

  to disable the MovePath feature on unsupported frame types. 
  (see also remarks at bugzilla #645303)
  
  
- the MovePath feature now is built as separate plug-in with its own main
  procedure to handle run and query.
  
- added a new gimprc parameter that enables logging of the
  relevant render parameters each time the movePath feature
  renders a frame. This parameter defaults to "no" in productive environment
  and is intended for debug and analyse purpose.
  This logging was used as base for regression tests on the current changes.
  
  (video-move-path-log-render-params "yes")


 * NEWS  
 * po/POTFILES.in
 * gap/Makefile.am
 * gap/gap_bluebox.h
 * gap/gap_main.c
 * gap/gap_mov_dialog.c  [.h]
 * gap/gap_mov_exec.c    [.h]
 * gap/gap_mov_main.c          # NEW FILE   
 * gap/gap_mov_render.c  [.h]
 * gap/gap_mov_xml_par.c [.h]  # NEW FILES    
 * gap/gap_xml_util.c    [.h]  # NEW FILES    

 * gap/gap_story_main.h
 * gap/gap_story_file.c   [.h]
 * gap/gap_story_render_processor.c [.h]
 * gap/gap_story_render_lossless.c
 * gap/gap_story_render_types.h
 * gap/gap_story_syntax.c  [.h]
 * gap/gap_story_vthumb.c
 * gap/gap_story_properties.c
 
 * gap/gap_story_att_trans_dlg.c
 * docs/reference/txt/STORYBOARD_FILE_DOC.txt

 
2011-04-26 Wolfgang Hofer <hof@gimp.org>

- applied patch that fixes string typos provided by Christian Kirbach at #648607

 * gap/gap_morph_tween_dialog.c
 * gap/gap_player_dialog.c
 * gap/gap_story_file.c
 * gap/gap_video_index_creator.c
 * gap/gap_wr_opacity.c
 * vid_common/gap_cme_main.c
 * vid_enc_avi/gap_enc_avi_main.c
 * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
 * vid_enc_rawframes/gap_enc_rawframes_main.c
 * vid_enc_single/gap_enc_singleframes_main.c

2011-02-24 Wolfgang Hofer <hof@gimp.org>

- added new plug-ins to render an animated water pattern and flame effect, 
  based on the algorithms
  by William Morrison (his original wave tank scripts sf-will-wavetank.scm
  and sf-will-flames.scm can be found  in the plugin registry)
  The GAP variant supports the GIMP-GAP typical iterator interface that
  allows to apply the same effect on already existing multilayer images or frames.

- fixed a bug in storyboard processor (processing failed in case
  the processed layer_id was changed during filtermacro processing)

- fixed bug in handling of persistent drawable ids.
  Filtermacros that call filters with additional drawable references 
  (such as the plug-in-bump-map that uses the bumpmap DRAWABLE
   in addition to the input drawable) used a flattened copy of the
   image that contained the refered additional drawable (e.g. the bumpmap)

- filtermacro processing now can handle the case when one of the called
  filters makes the processed layer invalid.
  (this is typicall the case after merge operations 
  where the merged reult gets a new drawable id)
  The implemented new behavior checks for valid layer
  after each single filtercall. In case the processed layer
  gets invalid it tries to find a newly created layer_id,
  preferrable at same stackposition. If such a newly created layer
  is found the next filtercall (in the list of filters in the macro) 
  will be executed on this newly created layer.

- GIMP-GAP typical animated filtercalls now provide
  information about total_steps and current step of the animated call
  intended for query by the called plug-in where necessary.
  (The new firepatern plug-in makes use of this feature
  for varying colors when 2 gradients are used in aminated calls)
  
  This information is available during the call of the iterator procedure
  and during the call of the filter via gimp_get_data
  code example:
  
  //  typedef struct
  //  {
  //    gboolean  animatedCallInProgress;
  //    gint32    total_steps; 
  //    gdouble   current_step;            /* current step respecting acceleration characteristics */
  //  } GapLastvalAnimatedCallInfo;
  
  #include "gimplastvalsdesc.h"
  GapLastvalAnimatedCallInfo  animCallInfo;
  gimp_get_data(GAP_LASTVAL_KEY_ANIMATED_CALL_INFO, &animCallInfo);

 * NEWS  
 * docs/reference/txt/Makefile.am
 * docs/reference/txt/plug_in_filter_macro.txt
 * docs/reference/txt/plug-in-firepattern.txt   # new file
 * docs/reference/txt/plug-in-waterpattern.txt  # new file

 * po/POTFILES.in
 * gap/gap_filter_iterators.c  
 * gap/gap_story_render_processor.c
 * gap/gimplastvaldesc.h
 * gap/Makefile.am
 * gap/gap_fmac_base.c 
 * gap/gap_filter_pdb.c
 * gap/gap_pdb_calls.c [.h]
 * gap/gap_layer_copy.c
 * gap/gap_fire_pattern.c    # new file
 * gap/gap_water_pattern.c   # new file


2010-12-18 Wolfgang Hofer <hof@gimp.org>

- storyboard rounding at offest calcultion 

 *  gap/gap_story_file.c


2010-12-14 Wolfgang Hofer <hof@gimp.org>

- GIMP-GAP has swichted its main video encoder/decoder engine
  from ffmpeg-0.6 to ffmpeg-0.6.1
  
  - test videos videoinex creation smartscan gives same analyse files as ffmpeg-0.6
  - seek tests repeated, same results as ffmpeg-0.6
  - read various videoformat samples same results as ffmpeg-0.6

- Analyze of the videoencoding performance 
    GVA api and ffmpeg based encoder were checked and
    some performance relevant changes were implemented.
    
    Note: the multithread support did NOT fulfill my expectations.
    the performance advantage was minimal compared with singlethreaded implementation
    on my 4 Processor development machine.
    Other changes (like enable mmx ffmpeg options, replacement of row-by-row
    processing) were more efficient for performance.

- GVA video api 
   - GVA_fetch_frame_to_buffer use fcache filling reads in case of backwards seek.
   - added fcache_mutex to prepare fcache access code for multithred environment.
   - provide new procedure GVA_search_fcache_and_get_frame_as_gimp_layer_or_rgb888 
     intended for use in multithreaded environment (e.g. the prefetch tread
     in the storyboard processor)

- replaced the slow row by row implementation
  that converts from drawable to RGB buffer at encoding
  (see: libgapvidutil/gap_gve_raw.c gap_gve_drawable_to_RgbBuffer)
  
- added multithreading support for the ffmpeg based video encoder plug-in
  using a ringbuffer queue implementation where the main thread
  feeds the queue via storyboard processor. The parallel running encoder
  thread reads from the queue and uses libavformat/libavcodec to write
  the resulting videofile.

  On singleprocessor configuration encoding is done without the queue
  (the same way as prior implementation did)

- added a new menu in the storyboard dialog that allows edit gimprc parameters
  that are relevant for the storyboard render processing.

- The storyboardprocessor provides a new API procedure
    gap_story_render_fetch_composite_image_or_buffer_or_chunk
  that allows video encoders to bypass the render engine 
  in scenes where simple 1:1 copy of fetched frames in movie clips is possible.
  (in such cases an rgb888 buffer is delivered to the encoder instead of 
  a gimp layer)
  The ffmpeg based video encoder already uses this new API
  and runs faster when encoding those storyboards scenes.

- added gimprc parameters:
  
  "video-storyboard-fcache-size-per-videofile"
  "video-storyboard-resource-log-interval"
    # the integer parameter video-storyboard-resource-log-interval
    # enables logging of cached resources during storyboard processing
    # value n (positive integer) triggers resource logging every n-th frame.
    #         where logging includes information about cached images 
    #         and currently open video handles.
    #         This is intended for debug purpose.
    # value 0 (is the default) turns off this type of logging.

  "video-storyboard-multiprocessor-enable"
    # the boolean parameter video-storyboard-multiprocessor-enable
    # enables multiprocessor support for the storyboard processor
    # The current implementation uses a parallel running prefetch thread
    # that reads frames from referenced videofiles into a frame cache
    # in advance.
  
  "video-enoder-ffmpeg-multiprocessor-enable"
    # the boolean parameter video-enoder-ffmpeg-multiprocessor-enable
    # enables multiprocessor support for the ffmpeg based video encoder
    # The current implementation uses a parallel running encoder thread
    # that uses a ringbuffer queue that is feed by the storyboard processor.
  

- Analyse for out of memory errors while encoding large HD videos via storyboard processor.
  ==> the default values for: 
    video-storyboard-max-open-videofiles    12
    GAP_STB_RENDER_GVA_FRAMES_TO_KEEP_CACHED 36

  are too large in case HD video is processed
  (this fills up my 4 GB ram on storyboard encoding
  with the fcache of the video api.

     one HD frame takes 6271236 bytes  // (1920 x 1088 x 3) + 4  + (1088 * 4)
     for all videohandles this is a summary of 2709173952 bytes    //  12  * 36 * 6271236
     
     the rest of 4GB was mainly filled with gimp images 
     (the image cache default "gap_ffetch_max_img_cache_elements" is 18 images)
     
  as result of this analyse the GAP_STB_RENDER_GVA_FRAMES_TO_KEEP_CACHED value
  is now configurable via gimprc parameter "video-storyboard-fcache-size-per-videofile"
  furthermore the configured value is only used in case videoclips are played backwards
  For standard ascening frame access a small fcache size (6) is picked that 
  shall be big enough for prefetch of videoframes in mutithreaded environment.
  Those changes result in remarkable less usage of memory resources without
  loss of performance.

- added optional performance logging in single or multithread environment 
  for storyboard processing, ffmpeg videoapi parts and ffmpeg based video encoder.

  The new configure option
     --enable-runtime_recording
  compiles gimp-gap with support for runtime recording/logging on some
  instrumented procedures, intended for performance analysis and tuning purpose.
  (see gap_timm.c calls in the source code)
  
  
  Logging report is triggered by
  o) STOP button clicked in the player
  o) after ffmpeg based encoder finished
  
  
- optional resource usage logging while storyboard processing

- use rounding in calculation of storboard scale and movement koords
  (use gdouble variables and rint function in procedure gap_story_file_calculate_render_attributes)

- AVI1 videoencoder added option to select RGB or BGR for raw video
  (intended mainly for test purpose, most players want BGR for RAW video

  * NEWS  
  * configure.in  

  * docs/reference/txt/gap_gimprc_params.txt  
  * docs/reference/txt/STORYBOARD_FILE_DOC.txt  

  * extern_libs/configure_options_ffmpeg.txt  
  * extern_libs/ffmpeg.tar.gz                # updated to ffmpeg release 0.6.1
  * extern_libs/README_extern_libs  

  * gap/gap_frame_fetcher.c  
  * gap/gap_frame_fetcher.h  
  * gap/gap_player_dialog.c  
  * gap/gap_story_dialog.c  
  * gap/gap_story_file.c  
  * gap/gap_story_file.h  
  * gap/gap_story_main.c  
  * gap/gap_story_main.h  
  * gap/gap_story_render_audio.c  
  * gap/gap_story_render_lossless.c  
  * gap/gap_story_render_processor.c  
  * gap/gap_story_render_processor.h  
  * gap/gap_story_render_types.h  
  * gap/Makefile.am  

  * libgapbase/gap_base.c  
  * libgapbase/gap_base.h  
  * libgapbase/gap_libgapbase.h  
  * libgapbase/Makefile.am  

  * libgapvidapi/gap_vid_api.c  
  * libgapvidapi/gap_vid_api_ffmpeg.c  
  * libgapvidapi/gap_vid_api.h 
  * libgapvidapi/Makefile.am  

  * libgapvidutil/gap_gve_raw.c  
  * libgapvidutil/gap_gve_raw.h  

  * vid_common/gap_cme_gui.c 
 
  * vid_enc_avi/gap_enc_avi_gui.c  
  * vid_enc_avi/gap_enc_avi_main.c  
  * vid_enc_avi/gap_enc_avi_main.h 
 
  * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.h  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.h  


  *  libgapbase/gap_timm.c                # NEW FILE
  *  libgapbase/gap_timm.h                # NEW FILE
  *  libgapvidapi/gap_vid_api_mp_util.c   # NEW FILE

2010-10-10 Wolfgang Hofer <hof@gimp.org>
  
- GIMP-GAP has swichted its main video encoder/decoder engine
  from ffmpeg-0.5 to ffmpeg-0.6
  
  ( Note that gimp-gap still supports compile/linking with the 
    old ffmpeg-0.5 libraies.
  
    to do so, just replace file extern_libs/ffmpeg.tar.gz
    with a copy from older releases that contains the 0.5 release
    and then configure gimp-gap with option:

      --disable-ff-libx264
  )
  
  
  *** COMPATIBILITY WARNING: 
  
  Positioning to exact frame numbers in 
  videos that do not start with a keyframe, or have read errors
  is not compatible to older ffmpeg-0.5 based GIMP-GAP releases.

  libavcodec prints error logging messages to stderr like this:
      [mpeg2video @ 0x8d7c290]warning: first frame is no keyframe
      [mpeg2video @ 0x8d7ef50]mpeg_decode_postinit() failure


  Decoding of the first few frames of a video that does not start with a keyframe
  triggers codec internal error handling and delviers different results
  in different releases of the ffmpeg libraries.
  
  In my tests with mpeg2 encoded .vob files (DVD stuff) ffmpeg-0.6 detects 
  and decodes some more leading non-key frames than ffmpeg-0.5 did.

  BUT THIS BREAKS BACKWARDS COMPATIBILITY ON POSITIONING BY FRAME NUMBER !

  Therefore Storyboards that were created based on older releases and include
  references to frames in such videos may now refere to another frame
  when processed with the newer release.


- video api feature: continue after read errors for the ffmpeg based implementation.
  
  some of my testvideos that could be read with ffmpeg-0.5 based decoding
  now fail because ffmpeg-0.6 seems to have a more restrictive error recognition
  at least when decoding mpeg2 videos.
  
  The ffmpeg based gap video API now supports a gimprc parameter 
    (video-gva-libavformat-continue-after-read_errors "yes")
  that allows continue reading frames after read errors
  and therefore is able to skip one frame and read further frames after read errors.
  The default value is "yes" (e.g. TRUE)
  



- changed menu path for morphing tools 
    to: "<Image>/Video/Morph/"
    to: "<Image>/Video/Morphing/"
  I made this change, because in German settings (LANG=de_DE.UTF-8)
  the morph submenu was presented whre invocation of MovePath was expected
  (Bewegungspfad) and Morph was not present at all.
  ==> TODO check german translation for errors..
    


  -- 2010-09-18 ----


- video api fixed for usage with ffmpeg-0.6 (MJPEG bug)
  some codecs of the ffmpeg-0.6 release no longer deliver valid 
  input length information about a successfully decoded frame.
  The fix assumes that the decoded frame size is the full packet length
  Note that packet is already read with av_read_frame and that shall already
  collect all data of one frame in the packet.
  The case where multiple frames are included in one packet
  can not be handled after this fix
  But this theroretical case does not occure in my testvideos 
  and probably is not relevant at all (or probably is already handled
  at lower level internally in  av_read_frame)
  Note that the gap-video API was written before av_read_frame
  was available and had to deal with collecting data
  for one frame.
    
    
  Further disable native seek support in case the codec
  just delivers DTS timecodes with value 0.
    
     
 
- gimp-gap configure.in was changed to detect current versions
  of libx264 and libxvid.
  it is now ready for ffmpeg-0.6 (and prepared for latest snapshots)
  (both libs require to include stdint.h (or inttypes.h) 
  before including the headerfile x264.h )
  xvid now depends on the pthread library, 
       therefore add the option --enable-pthreads when ffmpeg is configured
       with option --enable-libxvid  

  The older ffmpeg-0.5 fails to detect properly installed libx264 library
  with current versions. This is OK, because it requires old libx264 version
  (greater equal 0.65  but less than 0.85) to compile
  
  gimp-gap still supports using old ffmpeg-0.5
  but have to use gimp-gap configure option

   --disable-ff-libx264
 
  further note that latest ffmpeg snapshots already
  dropped libfaad support after release ffmpeg-0.6.
  to compile gimp-gap with latest ffmpeg snapshot it is required
  to configure with option:
  
    --disable-ff-libfaad


- various bug fixes in the ffmpeg based video encoder.
  
  
  o) added handling to compensate encoder frame latency.
     some codecs keep frames in internal buffer and start
     generate output when this internal buffer is filled.
     After feeding the last input frame N to the codec
     the obtained output frame is the one with number N - size of internal cached frames.
     The fix continues feeding the last frame to the codec
     multiple times until all relevant frames are written
     to the output video file.
     
     without this fix, some frames at the end
     were not written to the resulting video output file,
     especially for codecs with high latency like the libx264.
     
  o) some codecs (x264) just pass through pts information obtained from
     the AVFrame struct (big_picture_codec)
     the fix now sets a valid the pts code to init
     the AVFrame struct before encoding a video frame.
     Note that invalid pts code could produce unusable videos,
     it is also relevant for playback order of the frames.     

 o) fixed another colormodel convert relevant bug.
    the fix applies for codecs that want BGR input 
    (dont konw if there is such a codec)
    note that gap_gve_raw_RGB_drawable_encode was recently fixed to deliver RGB (not BGR)

 o) qmin/qmax upper limit changed to 51
 
 o) Gui parameter support for partition and new codec flags that are new in ffmpeg-0.6:
     parti4x4
     parti8x8
     partp4x4
     partp8x8
     partb8x8

     MB-Tree RC    // codec_FLAG2_MBTREE
     PSY           // codec_FLAG2_PSY
     Compute SSIM  // codec_FLAG2_SSIM


  * configure.in
  * NEWS
  * gap/gap_morph_main.c
  * extern_libs/configure_options_ffmpeg.txt
  * extern_libs/README_extern_libs
  * extern_libs/ffmpeg.tar.gz                 # update from ffmpeg-0.5 to ffmpeg-0.6
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * docs/reference/txt/gap_gimprc_params.txt

2010-09-09 Wolfgang Hofer <hof@gimp.org>

- applied patch #625667 that fixed various spelling mistakes.
  (most of them occured in comments, some in message texts)


 * gap/gap_decode_mplayer.c
 * gap/gap_fmac_base.c  
 * gap/gap_lib.c
 * gap/gap_main.c  
 * gap/gap_match.c  
 * gap/gap_mod_layer.c  
 * gap/gap_morph_dialog.c  
 * gap/gap_morph_main.c  
 * gap/gap_story_att_trans_dlg.c  
 * gap/gap_story_dialog.c  
 * gap/gap_story_file.c  
 * gap/gap_story_properties.c  
 * gap/gap_story_render_audio.c  
 * gap/gap_story_section_properties.c  
 * gap/gap_story_vthumb.c  
 * gap/gap_thumbnail.c  
 * gap/gap_vex_dialog.c  
 * gap/gap_video_index_creator.c  
 * gap/TESTPROT_iter_ALT  
 * libgapbase/gap_val_file.c  
 * libgapvidapi/gap_vid_api_mpeg3.c  
 * libgapvidapi/gap_vid_api_mpeg3toc.c  


--- 2010-08-23

- added wrapper plug-in to run gimp_color_balance tool as animated filter.

   
 * gap/Makefile.am
 * gap/gap_wr_color_balance.c  # NEW file
 * po/POTFILES.in

--- 2010-08-15 (Morph features)
   
- Added features to the Morph plug-in to support
  more convenient creation of workpoints and lead to better
  results (especially for morping tweens of a video)

- Created new plug-in "Morph Workpoint Generator" 
  (in the menupath Video/Morph/)
  Generates workpointfiles for each frame in the specified frame range.

- added new feature to morph plug-in "Create Tween Frames"
   that creates a directory with (renumbered) copies of the processed frames
   and additionally generated tween frames that are rendered via fade or morphing.
   individual workpointfiles per processed frame are located via
   name convention (extension .morphpoints) and used for morphing when they exist.
   (such files can be created with the help of the plug-in "Morph Workpoint Generator").
   
 
   example1:
     generate 2 tween frames between each handled frame.
     master_tween_steps = 2, tween_subdir = "with_tweens"
    
    frame_000001.xcf     == copied to     ==>  with_tweens/frame_000001.xcf
                         render via morph ==>  with_tweens/frame_000002.xcf
                         render via morph ==>  with_tweens/frame_000003.xcf

    frame_000002.xcf     == copied to     ==>  with_tweens/frame_000004.xcf
                         render via morph ==>  with_tweens/frame_000005.xcf
                         render via morph ==>  with_tweens/frame_000006.xcf


    frame_000003.xcf     == copied to     ==>  with_tweens/frame_000007.xcf

   
   example2:
     generate 1 tween frame between each handled frame
     master_tween_steps = 1, tween_subdir = "with_tweens"
     in this example frame 2 is missing, therefore 3 tweens
     are generates between frame 1 and 3.
    
    frame_000001.xcf     == copied to     ==>  with_tweens/frame_000001.xcf
                         render via morph ==>  with_tweens/frame_000002.xcf
                         render via morph ==>  with_tweens/frame_000003.xcf
                         render via morph ==>  with_tweens/frame_000004.xcf

    frame_000003.xcf     == copied to     ==>  with_tweens/frame_000005.xcf
                         render via morph ==>  with_tweens/frame_000006.xcf
   
    frame_000004.xcf     == copied to     ==>  with_tweens/frame_000007.xcf

- Morph dialog provides new features
  for edge detection based automatic workpoint generation.
  This feature is available when CTRL modifier key is hold down while
  the Shape button is pressed.
  


- morph dialog now supports a special way to set morph workpoints
  that automatically tries to find the corresponding point in the other image
  within a specified locate radius.
  This feature is useful when both images contain similar data.

  This new feature is available via CTRL modifier key when setting morph points
  (in the modes set and move)


 * gap/Makefile.am
 * gap/gap_colordiff.c [.h]          # NEW files
 * gap/gap_locate.c [.h]             # NEW files
 * gap/gap_edge_detection.c [.h]     # NEW files
 * gap/gap_morph_shape.c [.h]        # NEW files
 
 * gap/gap_morph_dialog.c [.h]
 * gap/gap_morph_main.c [.h]
 * gap/gap_libgimpgap.h
 * gap/gap_morph_tween_dialog.c [.h]
 
 * docs/reference/txt/INTRODUCTION.txt
 

-- 2010-07-30 (started update to ffmpeg release ffmpeg 0.6)
  
  status: partly works, but problems to read some videoformats
      - mjpeg (my Olympus SP-560UZ digicam uses this format)
      - RealMedia

  switch to ffmpeg-0.6 shall not be done until fixing this,
  because update to new release shall not break 
  compatibility with videoformats that already worked fine with the 
  ffmpeg-0.5 based gimp-gap video api.

- fixed gap_gve_raw_RGB_drawable_encode  
  that method did convert to BGR colormodel (and not to RGB as it should)
  but this was compensated by another bug when using ffmpeg conversion via deprecated
  img_convert.

- ffmpeg API no longer supports the procedure img_convert.
  gimp-gap now uses sws_scale (that was already part of ffmpeg-0.5) and provides
  the colormodel conversions required to feed the codecs of libavcodec.

- replaced calls to deprecated video/audio decoder procedures
       avcodec_decode_video  ==> avcodec_decode_video2
       avcodec_decode_audio2 ==> avcodec_decode_audio3

- ffmpeg-0.6 configure now requires --enable-nonfree when built with
  non free libs (gimp-gap configure now adds this option when
  building with the non free libfaac)
  
- support to compile gimp-gap with ffmpeg-0.6,
  but keep older ffmpeg-0.5 release as default 

- build gimp-gap with latest versions of xvid and x264 libraries is currently not possible.
  note that the gap configure script checks the same way as the included ffmpeg 0.5 version
  which does not accept new versions of those libraries.
  therefore a change in the gap configure.in is not sufficient !

  ==> for support of newer xvid and x264 libs porting gimp-gap to newer ffmpeg
      is also required



  * configure.in
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * extern_libs/README_extern_libs
  * extern_libs/ffmpeg.tar.gz
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
  * libgapvidutil/gap_gve_raw.c  


--- 2010-05-xx

- workaround for gtk_button_new_from_stock (); problem.

  Short description of the problem:
      buttons created with gtk_button_new_from_stock sometimes do not show the icon
      (at least in case the theme is configured as "Show symbols in menus" = false")
      
      Some of the gimp-gap buttons do not have any text
      (For example the play, pause and reverse buttons in the playback dialog)
      and appear as very small completely empty buttons
      that makes it very hard to use with such a theme configuration.
  

      Here are some examples of stock_ids where the button does NOT show the image:
        GAP_STOCK_PLAY
        GAP_STOCK_PAUSE
        GAP_STOCK_PLAY_REVERSE

        GIMP_STOCK_RESET

        GTK_STOCK_SAVE
        GTK_STOCK_CLOSE

      Note that other plug-ins (map object, lighting, gfig) that are using stock images
      in similar way as gimp-gap have the same problem.
  
  The workaround uses the new procedure gap_stock_button_new
  instead of gtk_button_new_from_stock to create buttons with stock images
  and is used only where it makes no sense to disable the images via themes configuration.

- support for configuration of the gap frame fetcher cache by new gimprc parameters:

  (gap_ffetch_max_img_cache_elements "18")
  (gap_ffetch_max_gvc_cache_elements "6")
  (gap_ffetch_gva_frames_to_keep_cached "36")
  
  the gap frame fetcher cache settings are relevant for storyboard
  and filtermacro processing.
  


- fixed sporadic crash in the storyboard render processor.
  work copy duplicates of images that are cached as gimp image in the gap frame fetcher cache
  now do detach the image parasite "GAP-IMAGE-CACHE-PARASITE" that marks the image as member of the cache.
  In case rendering of one frame requires more than one image fetch operations this parasite
  did sometimes cause an unexpected delete of the duplicate during fetch
  when the maximum number of cached images is already reached.

  * gap/gap_player_dialog.c  
  * gap/gap_stock.c [.h]
  * gap/gap_frame_fetcher.c [.h]
  * gap/gap_story_render_processor.c
  * docs/refernce/txt/gap_gimprc_params.txt
  

----- 2010-04-xx ----

- modify frames plug-in now keeps dialog window open to show progress while processing frames
  and provides button to cancel processing.
  The old behavior based on gimp_progress was not sufficient, especially in case
  when a filter is applied and the called filter also uses gimp_progresss
  for local progress. This resulted in confusing concurrent progress updates...

- New colormask plug-in added
  The colormask filter can apply transparency for pixels matching the colormask image.
  intended for processing frames where moving objects can be isolated
  from the non-moving constant background by applying the constant background
  as colormask on all frames.
  
  NOTICE:
  The current implementation is NOT YET READY for use.
  There are more implementation variants, most of them are experimental
  some of them will be removed after testing.
  The dialog window currently hides the options for those experimental variants
  (until implentation is finished, those options are only visible for USERNAME=hof).
  
  

- New storyboard processing feature mask anchor mode CLIP_COLOR
  applies the selected mask as colormask

- Storyboard support rotate transitions

- New storyboard processing feature to add external transparency 
  for clip type movie. This is done via format string that refers to
  the external frames (typical gray image frames)
  the format string has placeholder %s (replaced by basename of the video)
  and %06d (replaced by the currently processed frame number)
  
  The format string can be specified in the storyboard master properties dialog
  (similar to the area replacement for logo processing)
  
  * docs/reference/txt/plug-in-gap-move-path.txt
  * libgapbase/gap_val_file.c [.h]
  * gap/gap_mod_*         

  * NEWS
  * docs/reference/txt/INTRODUCTION.txt
  * docs/reference/txt/STORYBOARD_FILE_DOC.txt
  * docs/reference/txt/plug-in-colormask.txt    # NEW FILE

  * gap/gap_colormask_main.c          # NEW FILE
  * gap/gap_colormask_exec.c [.h]     # NEW FILES
  * gap/gap_colormask_file.c [.h]     # NEW FILES
  * gap/gap_colormask_dialog.c [.h]   # NEW FILES
  * gap/Makefile.am
  * gap/gap_libgimpgap.h
  * gap/gap_layer_copy.c [.h]

  * gap/gap_morph_dialog.c


  * gap/gap_lib.c
  * gap/gap_lib.h
  * gap/gap_story_att_trans_dlg.c
  * gap/gap_story_dialog.c
  * gap/gap_story_file.c
  * gap/gap_story_file.h
  * gap/gap_story_main.h
  * gap/gap_story_properties.c
  * gap/gap_story_render_lossless.c
  * gap/gap_story_render_processor.c
  * gap/gap_story_render_types.h
  * gap/gap_story_syntax.c
  * gap/gap_story_syntax.h


2010-07-04 Wolfgang Hofer <hof@gimp.org>

- added gitignore files (applied patch provided by Carlo Baldassi #623050)

   git add .gitignore
   git add docs/.gitignore
   git add docs/howto/.gitignore
   git add docs/howto/txt/.gitignore
   git add docs/reference/.gitignore
   git add docs/reference/txt/.gitignore
   git add extern_libs/.gitignore
   git add gap/.gitignore
   git add images/.gitignore
   git add libgapbase/.gitignore
   git add libgapvidapi/.gitignore
   git add libgapvidutil/.gitignore
   git add libwavplayclient/.gitignore
   git add po/.gitignore
   git add vid_common/.gitignore
   git add vid_enc_avi/.gitignore
   git add vid_enc_ffmpeg/.gitignore
   git add vid_enc_rawframes/.gitignore
   git add vid_enc_single/.gitignore
   
2010-07-04 Wolfgang Hofer <hof@gimp.org>

- removed the execution bit on .txt, *.c and *.h source files
  as suggested in #623078
  
    find . -name '*.txt' -exec chmod a-x '{}' \;
    find . -name '*.c' -exec chmod a-x '{}' \;
    find . -name '*.h' -exec chmod a-x '{}' \;
  
  
2010-07-04 Wolfgang Hofer <hof@gimp.org>

- fixed bug in move path rendering acceleration handling at last controlpoint.
  when acceleration characteristic value other than 0 and 1 was used, 
  the value(s) specified in the last controlpoint were not reached in the last frame.

  example:
  have 5 frames and use 2 controlpoints that scale an object from 25 % to 400 %
  expected result is an object scaled to 400% in the last frame
  
  with (buggy version) got unexpected result:
  frame  | scale in %
  -------+------------
  1      |  25.0
  2      |  64.3979 
  3      | 128.9717
  4      | 208.4185
  5      | 299.3830    // expected to reach 400% in the last rendered frame


  with fixed version now get the expected result:

  frame  | scale in %
  -------+------------
  1      |  25.0
  2      |  78.8452 
  3      | 167.0984
  4      | 275.6785
  5      | 400.0000

- fixed bug in fetching boolean gimprc parmeter that always returned FALSE

  * gap/gap_mov_exec.c
  * libgapbase/gap_base.c [.h]

2010-04-19 Wolfgang Hofer <hof@gimp.org>

- move path fix for unwanted object jumps forth and back as reported in #607927
  (the 1st frame in a segment was sometimes calculated based on the controlpoint
   of the previous segment. this resulted in the reported  pixel jumps)

- added information label to the move path dialog to show max speed for current segment
  and current segment length in pixels.
  (this shall help to adjust ontrolpoints in a way to avoid unwanted speed jumps)
  
  * gap/gap_mov_render.c
  * gap/gap_mov_exec.c [.h]
  * gap/gap_mov_dialog.c [.h]
  * docs/reference/txt/plug-in-gap-move-path.txt
  

2010-03-21 Wolfgang Hofer <hof@gimp.org>

- added gimprc parameters to specify width and height
  for the previews in the morph dialog.
  In additon with some other layout changes
  (Moved buttons for save,load, and swap to button row at the bottom of the dialog window
   and omitted "Layer:" labels ...)
  the dialog window now fits into small resolution displays (1024x768)
  when using english language settings.
  (relevant for #611826)

  Note that translated texts may still result in dialog window that
  does not fit into small displays.
  
  (gap_morph_preview_width  "260")
  (gap_morph_preview_height "180")

- fixed a bug in the bluebox filter
  (hue difference handling must respect that 180 degree is the biggest
   difference for a hue value in the HSV colorspace)
   
  * gap/gap_bluebox.c
  * gap/gap_morph_dialog.c



2010-02-16 Wolfgang Hofer <hof@gimp.org>

- acceleration characteristic behavior was changed for MovePath.
  In case movement uses acceleration characteristic other than 0
  and other transitions (rotate, zoom, perspective, opacity)
  do not use their own (e.g have acceleration characteristic value == 0)
  the frametiming of those other transitions is now syncronized
  to the frametiming of the movement.

  This new behavior allows rotation following the path in case
  the object move shall use acceleration, deceleration or constant speed
  via acceleration characteristic setting.
  (see also discussion at #607927)

  * gap/gap_mov_exec.c
  * docs/reference/txt/plug-in-gap-move-path.txt

2010-02-15 Wolfgang Hofer <hof@gimp.org>

- acceleration graph widget changed. Now the widget knows the connected adjustment
  and can handle refresh on changed value internally.
  further provides setting the value with the mouse by click on the graph
    Button 1 (LEFT):   sets value dependent from y position
    Button 2 (MIDDLE): sets value 0 (acceleration OFF)
    Button 3 (RIGHT):  sets value 1 (constant speed)

- implementation for acceleration characteristic support im
  storyboard transitions.

- refactoring: moved multiple local definitions of the same macro MIX_VALUE
  to one central module libgapbase/gap_libgapbase.h
  (and renamed as GAP_BASE_MIX_VALUE)


- alternative Rendering algorithm for STORYBOARD processing
  scale, move operations where the result is larger than the frame in the composite image
  are now handled by computing the affected (clipped) rectangle that will be visible on frame
  after scale/move. Only this smaller part is copied, scaled and moved.
  This shall use less resources and speeds up processing when scrolling or zooming images
  that are larger than the resulting video frame size.

   a first test, a zoom into a 1200 x 900 imgae rendered
   to 110 frames of size 640 x 480 showed that render time of 1 min 30 sec
   was nearly the same with or without that optimize feature .....
   TODO ... further testing

  * NEWS
  * docs/reference/txt/gap-filterall-db-browser.txt
  * docs/reference/txt/plug-in-gap-move-path.txt
  * docs/reference/txt/plug-in-gap-storyboard-attr-prop.txt
  * docs/reference/txt/plug-in-gap-storyboard-clip-prop.txt
  * docs/reference/txt/STORYBOARD_FILE_DOC.txt

  * libgapbase/gap_libgapbase.h

  * gap/gap_accel_char.c [.h]
  * gap/gap_accel_da.c [.h]
  * gap/gap_dbbrowser_utils.c [.h]
  * gap/gap_filter_foreach.c
  * gap/gap_filter.h
  * gap/gap_filter_main.c
  * gap/gap_filter_pdb.h
  * gap/gap_fmac_main.c
  * gap/gap_mod_layer.c
  * gap/gap_morph_exec.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_exec.c

  * gap/gap_story_att_trans_dlg.c
  * gap/gap_story_file.c [.h]
  * gap/gap_story_main.h
  * gap/gap_story_properties.c
  * gap/gap_story_render_processor.c
  * gap/gap_story_render_types.h.
  * gap/gap_story_syntax.c



2010-02-08 Wolfgang Hofer <hof@gimp.org>

- the GIMP-GAP libavformat(libavcodec based video encoder
  now disables pre convert to YUV420P colormodel before feeding frame data to the encoding
  engine. This GIMP_GAP internal pre convrsion seems to fail on 64bit OS
  (see also #607924)
  furthermore YUV420P input typically reduces quality of the resulting output video.
  
  (pre convert to YUV420P colormodel is still available for test purpose
   and can be enabled by environment variable
     export GAP_FFENC_USE_YUV420P=y
  )

  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

2010-02-07 Wolfgang Hofer <hof@gimp.org>

- implementation for acceleration characteristic support im MovePath
  (as suggested in #607927)
  
  * gap/gap_accel_char.c [.h]  # NEW files
  * gap/gap_accel_da.c [.h]    # NEW files
  * gap/Makefile.am

  * gap/gap_mov_exec.c
  * gap/gap_mov_dialog.c [.h]


2010-01-16 Wolfgang Hofer <hof@gimp.org>
- applied patch provided at #607040 that fixes the crash when selcting
   controlpoint color.

  * gap/gap_morph_dialog.c

2009-12-29 Wolfgang Hofer <hof@gimp.org>

- fixed a bug in generating original audiotrack for storyboard
  whre the generated audio track sometimes is shorter than orignal video playtime
  when videoclips without audio are included in the storyboard.

- fixed storyboard composite playback of selected frames.
  The calculation of total selected frames did not work in
  some special cases where clips with overlapping frames
  are selected. In case the user selected a clip
  that was fully overlapped by an unselected clip
  a total number of 0 frames was the result.

  * gap/gap_story_file.c

2009-11-19 Wolfgang Hofer <hof@gimp.org>

 - fixed a bug in the storyboard clip properties
   that removed masks from video clips when the properties popup dialog was closed and opend again.
   an active_index -1 in the combo box inidcates empty combo box (typic while widget creation)
   and must NOT trigger removal of the mask (this is restricted to selection of the "None" entry with index 0
   or in case entries are present but none is matching the list of valid mask names)

  * gap/gap_story_properties.c

2009-08-11 Wolfgang Hofer <hof@gimp.org>

- detection of videofiles by extension now also accepts.mp4 videos.
- fixed broken videoapi framerate detection (did not work on some video files)
  the fix for the libavformat based api now takes care of the
  ticks_per_frame value of the video codec
  (that is typically 2 in interlaced videos)
  an additional fallback uses the container framerate in case the codec delivers
  unplausible value.
  now it seems to work, tested with videos of different types mpg, vob, wma, avi, mp4

  * gap/gap_story_file.c
  * gap/gap_story_dialog.c
  * libgapvidapi/gap_vid_api_ffmpeg.c  
 
 
2009-07-28 Wolfgang Hofer <hof@gimp.org>

- fixed broken initialisation of default values in case the file
  with animation properties (*_vin.gap) does not yet exist.
  This also fixes the reported resource bug #589897
  (that allocated memory for GapVinVideoInfo structure
   that was never freed)


  * gap/gap_vin.c
  
2009-06-20 Wolfgang Hofer <hof@gimp.org>

- fixes for many compiler warnings
  applied patches provided by Stanislav Brabecat at bugzilla #585343
  this includes a fix in gap_vid_api.c relevant for 
  correct handling of deinterlacing video frames.

- replaced deprecated gimp_md5_get_digest procedure by GChecksum from GLib
  (as suggested in the gimpmd5.c sourcecode)

  * extern_libs/Makefile.am
  * gap/gap_pdb_calls.c
  * gap/gap_pdb_calls.h
  * gap/gap_split.c
  * gap/gap_story_dialog.c
  * gap/gap_story_dialog.h
  * gap/gap_story_properties.c
  * gap/gap_story_section_properties.c
  * gap/gap_story_sox.c
  * gap/gap_wr_color_curve.c
  * gap/gimplastvaldesc.c
  * libgapbase/gap_base.c
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * libgapvidapi/gap_vid_api_util.c
  * libgapvidapi/gap_vid_api_vidindex.c
  * libgapvidutil/gap_gve_misc_util.c
  * libgapvidutil/gap_gve_png.c
  * libgapvidutil/gap_gve_png.h
  * vid_common/gap_cme_gui.c
  * vid_enc_avi/gap_enc_avi_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
 
  * libgapvidapi/gap_vid_api.c
  * vid_common/gap_cme_callbacks.c

2009-05-22 Wolfgang Hofer <hof@gimp.org>

- applied changes from gap-2-6 branch to master

- autgen.sh script chcks for required automake now accepts automake-1.11
  (applied patch from David Evans #583500)

- added some missing files to POTFILES.in (fixes #583497)
     gap/gap_audio_extract.c
     gap/gap_morph_tween_dialog.c
     gap/gap_wr_resynth.c
     vid_enc_rawframes/gap_enc_rawframes_main.c

- configure now is using a LINGUAS file 
  (applied patch from Claude Paroz #583498)

  * autogen.sh
  * po/POTFILES.in
  * po/LINGUAS       # new file
  * configure.in
 
2009-05-20 Wolfgang Hofer <hof@gimp.org>

Updated Version to 2.7.0

  README
  * configure.in

2009-05-17 Wolfgang Hofer <hof@gimp.org>

- iconify storyboard dialog window when calling video encoder from storyboard menu
  and deiconify when the encoder call returns.
  
  On my gnome windowmanager the encoder dialog always opened behind the storyboard dialog window
  but the storyboard dialog is not refreshed due to the synchron call of the encoder plug-in.
  the iconify /deiconify is a practicable workaround to avoid this annoying situation.

- Master Video encoder moved from "Video/Encode" to "Video" Menu
  menu name "Master Videoencoder..." now has ending ... to inidcate that ist opens a dialog.
  note that the other old video encoders are not built by default
  therefore the submenu is not required for normal gimp-gap users.

  * gap/gap_story_dialog.c
  * vid_common/gap_cme_main.c

2009-05-16 Wolfgang Hofer <hof@gimp.org>
- configure now checks for detection of FAAD2 or FAAD library
  that is also sufficient to build with ffmpeg 0.5

  * configure.in

2009-05-12 Wolfgang Hofer <hof@gimp.org>

- applied patch from David Evans #582241 to make sure to include
  ffmpeg header files of the the local embedded copy of ffmpeg
  even if another copy of ffmpeg is installed in system include paths.

- fixed confusing configure warnings (reported in #582216)
  unrecognized options: --disable-audio-support, --enable-gdkpixbuf-pview

- use autool typical AC_CHECK_PROG to check gmake program 

  * configure.in
  * libgapvidapi/Makefile.am
  
2009-05-10 Wolfgang Hofer <hof@gimp.org>

configure and build issues to fix Mac specific bugs reported by David Evans.

- applied patch from David Evans  for properly detection of  FAAD2. (provided at Bug #581807) 
- use gmake via variable $EXGMAKE for build external libs if available. if gmake not available
  $EXGMAKE points to make program. (shall fix #581805)

- pass configue options 
    --prefix=
    --with-ff-extra-cflags
    --with-ff-extra-ldflags
  to ffmpeg configure. (shall fix #581809)

  
  * configure.in
  * extern_libs/Makefile.am

2009-04-28 Wolfgang Hofer <hof@gimp.org>

- fixed Grab Path Points default settings bug #580416

 * gap/gap_mov_dialog.c

2009-04-24 Wolfgang Hofer <hof@gimp.org>

- ffmpeg based video encoder colormodel conversion to YUV420P is only done
  for codecs that require this as input colormodel.
  For codecs that do not want YUV420P
  use ffmpeg's img_convert procedure to convert from rgb.
  (old implementation always used YUV420P as input for the conversion
  which may results in loss of quality)

- ffmpeg based video encoder now terminates with error message
  in case the auido input is not supported by the selected audio codec.
  (the old implementation crashed in such cases)
  this typically occurs for non standard samplerates
  therfore the error message includes the hint to try
  48 kHz, 44.1 kHz or 32 KHz

- master video encoder combo box for selection of commonly used samplerate
  is now updated automatically when a commonly used samplerate is entered
  in the corresponding spinbutton widget.
  
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

  * vid_common/gap_cme_callbacks.c
  * vid_common/gap_cme_gui.c

2009-04-14 Wolfgang Hofer <hof@gimp.org>

- fixed audio extract problem that delivered unusable results 
  for videos with 8bit audiotracks,
  (as found in AVI files written by OLYMPUS digital cameras)
  the ffmpeg based videoapi now automatically converts to signed 16 bit format, 
  that is required in subsequent audio processing in GIMP-GAP.

  * libgapvidapi/gap_vid_api_ffmpeg.c

2009-04-13 Wolfgang Hofer <hof@gimp.org>

- fixed audio handling in the AVI1 encoder
  playback of resulting avi files was tested with mplayer (linux and Windosws XP)
  and with MS mediaplayer (Windows XP)
  
  - mp3rate must not be 0 
   (with value 0 playback attempts of the resulting avi file
    causes freeze of mplayer)

  - changed internal handling of audio chunk size.
    AUDIO_CHUNK_ADVANCE_FRAMES defines the duration of one audio chunk (unit frames)
    with the hardcoded deaults, an audio chunk is written every 16 video frames

  - fixes in avilib.c:
   a) idx1 chunks offesets are now written relative to the start of the movi chunk data
      (old implementation used global offsets in the file that was not correct)
      
   b) fixs in write/update of the AVI audio stream header related to pcm audiodata
      (samplesize, blockAlign and averageBytesPerSec.
       incorrect values resulted in video playback that is NOT synchron to the audio.
   c) use "00dc" for compressed video chunks (old avilib always used "00db" that
      should be used for uncompressed video according to AVI specification)

   d) allow samplesize < 4 (that is required for mono samples 8 and 16 bit)
   
  * vid_enc_avi/avilib.c [.h]
  * vid_enc_avi/gap_enc_main_avi.c
  * README

2009-04-06 Wolfgang Hofer <hof@gimp.org>

- applied fixes for avilib.c (as found at http://svn.xiph.org/trunk/theora-tools/vp32theora/avilib.c)
  must use O_BINARY flag on win32 platform,  this fixes the bug that did write
  corrupt AVI files on Win32 Platform (relevant for bug #326201)

- replace fopen by  g_fopen

  * vid_enc_avi/avilib.c 
  * libgapvidutil/gap_gve_misc_util.c

2009-04-04 Wolfgang Hofer <hof@gimp.org>

- replaced tab characters by blanks

  * gap/gap_arr_dialog.c
  * gap/gap_arr_dialog.h
  * gap/gap_audio_extract.c
  * gap/gap_audio_wav.c
  * gap/gap_audio_wav.h
  * gap/gap_base_ops.c
  * gap/gap_bluebox.c
  * gap/gap_bluebox_main.c
  * gap/gap_dbbrowser_utils.c
  * gap/gap_dbbrowser_utils.h
  * gap/gap_decode_mplayer.c
  * gap/gap_decode_mplayer_main.c
  * gap/gap_decode_xanim.c
  * gap/gap_filter_codegen.c
  * gap/gap_filter_foreach.c
  * gap/gap_filter_iterators.c
  * gap/gap_filter_main.c
  * gap/gap_filter_pdb.c
  * gap/gap_fmac_main.c
  * gap/gap_frontends_main.c
  * gap/gap_image.c
  * gap/gap-intl.h
  * gap/gap_layer_copy.c
  * gap/gap_layer_copy.h
  * gap/gap_lib.c
  * gap/gap_lock.c
  * gap/gap_main.c
  * gap/gap_match.c
  * gap/gap_morph_dialog.c
  * gap/gap_morph_exec.c
  * gap/gap_morph_exec.h
  * gap/gap_morph_main.c
  * gap/gap_morph_main.h
  * gap/gap_morph_tween_dialog.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_dialog.h
  * gap/gap_mov_exec.c
  * gap/gap_mov_render.c
  * gap/gap_mpege.c
  * gap/gap_name2layer_main.c
  * gap/gap_navi_activtable.c
  * gap/gap_navigator_dialog.c
  * gap/gap_onion_base.c
  * gap/gap_onion_dialog.c
  * gap/gap_onion_main.c
  * gap/gap_pdb_calls.c
  * gap/gap_pdb_calls.h
  * gap/gap_player_dialog.h
  * gap/gap_player_main.c
  * gap/gap_pview_da.c
  * gap/gap_range_ops.c
  * gap/gap_range_ops.h
  * gap/gap_stock.c
  * gap/gap_story_dialog.h
  * gap/gap_story_main.c
  * gap/gap_story_render_audio.c
  * gap/gap_story_render_audio.h
  * gap/gap_story_render_processor.h
  * gap/gap_story_sox.c
  * gap/gap_story_vthumb.c
  * gap/gap_thumbnail.c
  * gap/gap_thumbnail.h
  * gap/gap_vex_dialog.c
  * gap/gap_vex_dialog.h
  * gap/gap_vex_exec.c
  * gap/gap_vex_main.c
  * gap/gap_video_index_creator.c
  * gap/gap_vin.c
  * gap/gap_wr_color_huesat.c
  * gap/gap_wr_color_levels.c
  * gap/gap_wr_opacity.c
  * gap/gap_wr_trans.c
  * gap/gimplastvaldesc.c
  * libgapbase/gap_base.c
  * libgapbase/gap_base.h
  * libgapbase/gap_file_util.c
  * libgapbase/gap_file_util.h
  * libgapbase/gap_val_file.c
  * libgapbase/gap_val_file.h
  * libgapvidapi/gap_vid_api.c
  * libgapvidapi/gap_vid_api_gimp.c
  * libgapvidapi/gap_vid_api.h
  * libgapvidapi/gap_vid_api-intl.h
  * libgapvidapi/gap_vid_api_mpeg3.c
  * libgapvidapi/gap_vid_api_mpeg3toc.c
  * libgapvidapi/gap_vid_api_util.c
  * libgapvidapi/gap_vid_api_vidindex.c
  * libgapvidutil/gap_gve_jpeg.c
  * libgapvidutil/gap_gve_jpeg.h
  * libgapvidutil/gap_gve_misc_util.c
  * libgapvidutil/gap_gve_png.c
  * libgapvidutil/gap_gve_png.h
  * libgapvidutil/gap_gve_raw.c
  * libgapvidutil/gap_gve_sox.c
  * libgapvidutil/gap_gve_xvid.c
  * vid_common/gap_cme_callbacks.c
  * vid_common/gap_cme_gui.c
  * vid_common/gap_cme_gui.h
  * vid_common/gap_cme_main.c
  * vid_enc_avi/gap_enc_avi_gui.c
  * vid_enc_avi/gap_enc_avi_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.h
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
  * vid_enc_rawframes/gap_enc_rawframes_main.c
  * vid_enc_single/gap_enc_singleframes_main.c
 
2009-04-04 Wolfgang Hofer <hof@gimp.org>

- changes to the configure script for build in MinGW Environment
  for Win32 systems.

- fixed bug in the configure --disable-libmpeg3 
  changes for build on MinGW environment on Win32 systems

- replaced usage of sleep (that was not available on MinGW) by usleep

- fixed handling of gint64 datatype in gap basic key/value file in MinGW environment.

     gint64 bigval = 1778;
     printf ("%lld", bigval);
       
         output on LINUX: 1778
         output on Win32: 1778(null)

     the fix uses g_strdup_printf which handles %lld correct in both environments.       
     (relevant for persiting ffmpeg based video analyse and parameter files)
   
  * configure.in
  * vid_common/gap_cme_main.c
  * libgapbase/gap_val_file.c

2009-03-22 Wolfgang Hofer <hof@gimp.org>

- updated news.

  * NEWS
  * docs/howto/txt/HOWTO-do-lossless-MPEG-cut.txt
  
2009-03-15 Wolfgang Hofer <hof@gimp.org>

- update to ffmpeg release ffmpeg-0.5
  now a stable ffmpeg release 0.5 is available
  i decided to update gimp-gap after repeating read and write tests 
  that showed same behaviour as the ffmpeg snapshot from Jan 2009.

  ffmpeg-0.5 has deprecated some procedures/attributes that were used
  in GIMP-GAP.
  therefore i replace following deprecated FFMPEG API usages:

  - av_alloc_format_context   procedure is deprecated, using avformat_alloc_context() instead. 

  - use procedure av_metadata_set for setting author, comment, copyright and title
    instead of filling the deprecated attributes in the   AVFormatContext structure

       
- changed the bitrate_tol value in the MPEG1 VCD preset from 0 to 1150 kbit
   (because ffpeg-0.5 crashes with message
   "bitrate tolerance too small for bitrate"
   when value 0 is used for encoding)

- fixed bug when saving ffmpeg encoder presets to file
   the value showed in the dialog did not always match the saved value in the file.
   (only in case when parameters were entered via keyboard)
   
   ==> must connect the callbacks for spinbutton widgets on signal "value_changed"
       (the signal "changed" works only in case the value was changed via mouse clicks
       on the spinbutton)

- configure.in added checks for both older ffmpeg versions
  (to force update of those derived directory after svn update)

- fixed bug in master video encoder. audiotime and audio labels are now
  updated in the dialog widgets when audiofile in WAV format is entered
  in the Audio Options.
  (procedure p_update_aud_info)
   
  * configure.in
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c:
  * extern_libs/README_extern_libs
  * extern_libs/ffmpeg.tar.gz

  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c

  * vid_common/gap_cme_gui.c

2009-03-12 Wolfgang Hofer <hof@gimp.org>

- attempt to fix #558730 (Mac OS X specific issue ?)
  dont know why the wrapper to set layer opacity fails in the query procedure on Mac OS X
  the reported Gimp assertion message
  
	(gap_wr_opacity:1754): LibGimp-CRITICAL **: gimp_install_procedure: assertion
	`(n_return_vals == 0 && return_vals == NULL) || (n_return_vals > 0 &&
	return_vals != NULL)' failed
  
  and 
	GIMP-Error: Plug-in "gap_wr_opacity"
	(/opt/local/lib/gimp/2.0/plug-ins/gap_wr_opacity)
	attempted to register the menu item "<Image>/Video/Layer/" for the procedure
	"plug-in-wr-set-opacity".
	It has however not installed that procedure.  This is not allowed.
  
  both do NOT occure in my Linux development environment. 
  Therefore the following changes are are just a guess without guarantee for succes..
  
  - register with a return value 
    (now returns id of the handled drawable as most plug-ins do)
  
  - register with new-stlyed name (old name had underscore characters)
     #define PLUG_IN_NAME        "plug-in-wr-set-opacity"
 
  - register in the new submenu "<Image>/Video/Layer/Attributes"
    (all other wrappers that seems to work also
    do register in submenus)

- the default options for the external audio resample tool sox
  have changed because new sox version(s) do no longer 
  support -w to specify the wav fileformat
  and the resample option is marked as deprecated.
  
  note that the options for the external sound converter utilitiy
  can be set in the master video encoder dialog
  and via gimprc parameter (video_encode_com_util_sox_options )
  so it is still possible to use older sox version(s).

  value for older sox versions was
    "$IN"  -w -r $RATE "$OUT" resample 
 
  new default value for sox v14.1.0v
    
    "$IN" -t wav $RATE "$OUT" " rate -h $RATE
   
   
- optimized videoapi procedure GVA_fetch_frame_to_buffer
  seek to very near framenumber target now is done as loop
  of sequential read that is faster than seek in this special case.
  (for better playback performance of video clips with stepsize != 1)

  * libgapvidapi/gap_vid_api.c
  * gap/gap_story_render_audio.c
  * gap/gap_story_sox.c [.h]
  * libwavplayclient/audioconvert_to_wav.sh

  * gap/gap_wr_opacity.c
  * gap/gap_wr_resynth.c
  
  
2009-03-10 Wolfgang Hofer <hof@gimp.org>

- added checks for nasm assembler in the configure.in script
  and disable build with libmpeg3 in case nasm is not installed
  (relevant for #144650)

 * configure.in

2009-03-09 Wolfgang Hofer <hof@gimp.org>

- check in of the missing changes.
  (The commit for Rev 818 2009.03.08 was not performed on toplevel directory,
   therefore most of the changes were not transfered to SVN.

  * gap/Makefile.am
  * gap/gap_arr_dialog.c
  * gap/gap_audio_wav.c
  * gap/gap_decode_mplayer.c
  * gap/gap_decode_xanim.c
  * gap/gap_file_util.c [.h]           # are now empty
  * gap/gap_fmac_context.c
  * gap/gap_frame_fetcher.c
  * gap/gap_lib.c [.h]
  * gap/gap_libgimpgap.h
  * gap/gap_lock.c
  * gap/gap_morph_exec.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_exec.c
  * gap/gap_mpege.c
  * gap/gap_navigator_dialog.c
  * gap/gap_onion_base.c
  * gap/gap_player_cache.c
  * gap/gap_player_dialog.c
  * gap/gap_split.c
  * gap/gap_story_dialog.c
  * gap/gap_story_file.c
  * gap/gap_story_properties.c
  * gap/gap_story_render_audio.c
  * gap/gap_story_vthumb.c
  * gap/gap_video_index_creator.c
  * gap/gap_wr_color_curve.c
  * gap/gimplastvaldesc.c 
 
  * libgapvidapi/gap_vid_api.c [.h]
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * libgapvidapi/gap_vid_api_mpeg3.c
  * libgapvidapi/gap_vid_api_util.c
  * libgapvidapi/vid_api_vidindex.c
  
  * libgapvidutil/gap_gve_misc_util.c [.h]
  * libgapvidutil/gap_gve_png.c

  * vid_common/gap_cme_gui.c
  * vid_common/gap_cme_main.c

  * vid_enc_avi/gap_enc_avi_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

  * docs/reference/txt/gap_gimprc_params.txt

2009-03-08 Wolfgang Hofer <hof@gimp.org>

- support limit for the number of open videohandles while storybboard processing.
  to avoid running out of memory and resources in case the storyboard has references to
  many different videofiles.
  the limit can be configured via the newly added gimprc parameter:
   
    (video-storyboard-max-open-videofiles 12)
  
- fixed a bug in the total_frames detection via libavformat based native seek
  that delivered one frame too much on most videos.
  (procedure: p_detect_total_frames_via_native_seek)
  
- videoindex based seek sometimes used slow sequential search (in rare cases)
  even if a complete video index was available.
  tests showed that the wanted frame could not be identified due to wrong checksum.
  This can occure if there are delta references to a frame in the video stream
  that is before the seek position.
  Note that the checksum is built based on the already decoded frame that may be
  incomplete in this case.
  
  ==> the applied fix tolerates a checksum missmatch if
  both length and timecode can be used to identify the target frame.
  if the target frame can not be identified that way, the next attempt
  starts from a smaller seek position and increases the number of sync read operations
  this shall lead to clean decoding and correct checksum calculation of the wanted frame
  

- fixed libavformat video index based seek in case the video index is NOT complete.
  (may occure if video index creation was cancelled by the user)
  now 1st try native seek in case where seek to the target frame number would require the missing
  part of the videoindex.
  fallback to very slow sequential read is only done if native seek is not possible either.

- video index creation tool now deletes incomplete video indexes when created
  in SMART_MODE for check purpose only.

- fixed missing initialisation of total_frames. (procedure GVA_new_videoindex)

-  master video encoder now checks if encoder process is still alive
   and reports termination of the encoder process in the progress bar message.
   "ENCODER process terminated"
   (this feature is only available on UNIX platforms)

- cleanup for old communication files used in the master video encoder
  in case encoding crashed or was killed in a previous session.
  (gap_gve_misc_util.c. p_gap_delete_old_communication_files)

- refactoring removed some code duplicates,
  and moved central procedures for common use in all gap modules
  from gap_lib.c to new module gap_base.c
      NEW name                                                      OLD name
      ==========================================================================================
      gap_base_shorten_filename                                      gap_lib_shorten_filename
      gap_base_strdup_add_underscore                                 gap_lib_strdup_add_underscore
      gap_base_strdup_del_underscore                                 gap_lib_strdup_del_underscore
      gap_base_dup_filename_and_replace_extension_by_underscore      gap_lib_dup_filename_and_replace_extension_by_underscore
      gap_base_fprintf_gdouble                                       gap_lib_fprintf_gdouble
      gap_base_sscan_flt_numbers                                     gap_lib_sscan_flt_numbers
      gap_base_check_tooltips                                        gap_lib_check_tooltips
      gap_base_get_gimprc_int_value                                  gap_lib_get_gimprc_int_value
      gap_base_get_gimprc_gboolean_value                             gap_lib_get_gimprc_gboolean_value
      gap_base_getpid                                                gap_lib_getpid
      gap_base_is_pid_alive                                          gap_lib_is_pid_alive
      gap_file_get_mtime

  * libgapbase/Makefile.am
  * libgapbase/gap_libgapbase.h        # NEW file
  * libgapbase/gap_base.c [.h]         # NEW files
  * libgapbase/gap_file_util.c [.h]    # NEW files (moved from gap directory)

  * gap/Makefile.am
  * gap/gap_arr_dialog.c
  * gap/gap_audio_wav.c
  * gap/gap_decode_mplayer.c
  * gap/gap_decode_xanim.c
  * gap/gap_file_util.c [.h]           # are now empty
  * gap/gap_fmac_context.c
  * gap/gap_frame_fetcher.c
  * gap/gap_lib.c [.h]
  * gap/gap_libgimpgap.h
  * gap/gap_lock.c
  * gap/gap_morph_exec.c
  * gap/gap_mov_dialog.c
  * gap/gap_mov_exec.c
  * gap/gap_mpege.c
  * gap/gap_navigator_dialog.c
  * gap/gap_onion_base.c
  * gap/gap_player_cache.c
  * gap/gap_player_dialog.c
  * gap/gap_split.c
  * gap/gap_story_dialog.c
  * gap/gap_story_file.c
  * gap/gap_story_properties.c
  * gap/gap_story_render_audio.c
  * gap/gap_story_render_processor.c
  * gap/gap_story_vthumb.c
  * gap/gap_video_index_creator.c
  * gap/gap_wr_color_curve.c
  * gap/gimplastvaldesc.c 
 
  * libgapvidapi/gap_vid_api.c [.h]
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * libgapvidapi/gap_vid_api_mpeg3.c
  * libgapvidapi/gap_vid_api_util.c
  * libgapvidapi/vid_api_vidindex.c
  
  * libgapvidutil/gap_gve_misc_util.c [.h]
  * libgapvidutil/gap_gve_png.c

  * vid_common/gap_cme_gui.c
  * vid_common/gap_cme_main.c

  * vid_enc_avi/gap_enc_avi_main.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

  * docs/reference/txt/gap_gimprc_params.txt


2009-02-25 Wolfgang Hofer <hof@gimp.org>

- fix bug in Storyboard dialog: when clip is added via player 
  there was no undo possible for that step.

- fixed menu text #538419

- wrapper for 3rd party plug-in resynthesizer 
  now uses gap_pdb_procedure_name_available for the check.
  (this avoids the gimp-2.6 typical warning pop up that complains
  about calling gimp_procedural_db_proc_info on non-intalled plug-ins)

  * gap/gap_story_dialog.c
  * gap/gap_wr_resynth.c

2009-02-23 Wolfgang Hofer <hof@gimp.org>

- Singleframes and rawframes encoder have no parameter dialog.
  the old implementation of a dummy PopUp dialog is no longer used.
  Those encoders now and deliver an empty string "\0"
  as result when the master video encoder queries for GAP_VENC_PAR_GUI_PROC
  
  this has the effect that the Parameter button in the maste video encoder
  is disabled (greyed out) instead of presenting the dummy pop up.


  * vid_enc_rawframes/gap_enc_rawframes_main.c
  * vid_enc_single/gap_enc_singleframes_main.c

2009-02-21 Wolfgang Hofer <hof@gimp.org>

- removed workaround (and bug) that restricted storyboard invokation to numbered frame image.
  now the storyboard can be opened from any image via video->storyboard menu.

- fixes to handle build options --disable-videoapi-support  --disable-libavformat 
  (relevant for #571444)
  - fixed Makefiles where the order of libraries matters
  - disable build of videoextract and video index creation programs in case videoapi disabled
	$(GAP_VIDEO_EXTRACT)
	$(GAP_VIDEO_INDEX)
  - added #ifdef GAP_ENABLE_VIDEOAPI_SUPPORT to sources
    (in modules that are still useable with limited features when videoapi is disabled)

  - build video encoder even when videoapi disabled.
    if libavformat is disabled just build without ffmpeg based encoder.
    video encoders now are usable without the videoapi
    (with the restriction that storyboard based input
    is limited and cliptype Movie is not supported)
  
  successful tested build variants on Open Suse 11.1 Linux Operatingsystem when configured with
     --disable-libavformat 
     --disable-libmpeg3 
     --disable-videoapi-support
     --disable-videoapi-support  --disable-libavformat

- fixed bug when seek near to end of last frame in ffmpeg video indexed based seek.
  seek to positions near to the last frame and subsequent frame reads
  sometimes failed.
  the fix now checks or success on each frame read in the sync loop
  and now makes new attempts with the previous index(es) when frame read operations
  fail.
  With this new method fetching of the last few frames now seems to work properly.

- video index creator 
  p_check_videofile procedure now checks the filename for known video extensions (.avi, .mpeg ...)
  before attempt to open as video.
  this fixes annoying gimp_file_load pop up that complains
  this popup message is triggered by the check_sig call of the gap_vid_api_gimp.c
  that allows access to anim frames via the videoapi.
  But it does not make sense to detect images as video here, where
  video index creation makes no sense and therefore is not supported.
  
  * configure.in
  * Makefile.am
  * gap/Makefile.am
  * gap/gap_arr_dialog.c [.h]
  * gap/gap_audio_extract.c [.h]
  * gap/gap_frame_fetcher.c [.h]
  * gap/gap_player_dialog.c
  * gap/gap_story_dialog.c
  * gap/gap_story_render_audio.c [.h]
  * gap/gap_story_render_lossless.c
  * gap/gap_story_render_processor.c [.h]
  * gap/gap_story_render_types.h
  * gap/gap_video_index_creator.c

  * libgapvidapi/gap_vid_api_ffmpeg.c
 
  * libgapvidutil/gap_gve_story.h 

  * vid_common/gap_cme_gui.c

  * vid_enc_rawframes/gap_enc_rawframes_main.c
  * vid_enc_single/gap_enc_singleframes_main.c

2009-02-14 Wolfgang Hofer <hof@gimp.org>

- fixed Bug #571428 'frames to image' now transfer DPI settings to new image.
  GIMP-GAP now generally transfers DPI resolution settings whenever new images
  are created based on an already existing image.

- fixed aspect detection in videoapi for ffmpeg based decoder
  Note:
  libmpeg3 based encoder still did not detect aspect values
  in my tests, this bug of old libmpeg3-1.5.4 version 
  is not yet fixed with libmpeg3-1.8

- fixed Bug #499553  plug-in-wr-color-levels does not work in NON-INTERACTIVE runmode
  (the parameters were fetched from wrong parameter indexes
  similar bug fixed for plug_in_wr_set_opacity)

- fixed #516819  Morph now works for for greyscale images.

- videoapi changed order of registered decoders
   ffmpeg based decoder shall be picked if compile with
   ffmpeg is enabled and no prefered decoder is selected.
   (the old order picked libmpeg3)

- added new gap/gap_decode_mplayer_main.c to POTFILES.in
  
  * po/POTFILES.in
  * gap/gap_range_ops.c
  * gap/gap_frame_fetcher.c
  * gap/gap_image.c
  * gap/gap_mov_exec.c
  * gap/gap_split.c
  
  * gap/gap_wr_color_levels.c
  * gap/gap_wr_opacity.c

  * gap/gap_morph_exec.c

  * libgapvidapi/gap_vid_api.c
  * libgapvidapi/gap_vid_api_ffmpeg.c


2009-02-11 Wolfgang Hofer <hof@gimp.org>
- configure now checks for old versions of ffmpeg and libmpeg3
  in case old version is detected those directories are renamed by adding
  the suffix -OLD and prints out an information message.
  The check is useful for build from svn, because svn update
  does not care for the "Derived" direcories ffmpeg and libmpeg3
  (note that only the tarballs are under svn control)
  fixes the "can not compile" part of #571444

  TODO: fix build variants when configured with
  --disable-videoapi-support
  --disable-libavformat 
  --disable-libmpeg3 

- configure no longer builds old unix frontends for xanim, and old mpeg encoders
  by default (this stuff is very old, build is still supported

- frontend for mplayer based frame extract was moved to its own
  main program (this frontend was successfully tested with MPlayer SVN-r28347)

- added support for new ffmpeg encoder options. 
  various parameters and codec flags tat are new in ffmpeg 2009.01.31
  
  Note that some of the new capabilities are not provided in the GUI.
  this stuff needs ffmpeg expert knowledge (more than i have) and
  can be used via a preset file that can be saved and loaded
  from the GUI and allows full control for all encoder capabilities.
  
- added GUI support for new FFMPEG codec flags /flags2  

- implemented support for 2-pass encoding in the FFMPEG based videoencoder
  and in the GapGveMasterEncoderStatus (for update of the progress
  in the master video encoder GUI)

- Some of the GIMP-GAP dialogs have iconify and maximize
  decoration, this is done by adding type hint for NORMAL window
  for the window manager. 
  gtk_window_set_type_hint (shell_window, GDK_WINDOW_TYPE_HINT_NORMAL);
  
  - Master Video Encoder
  - Parameter Dialog for FFMPEG and AVI
  - MovePath
  - VideoExtract
  - Morph
  
  * configure.in
  * gap/Makefile.am
  * gap/gap_frontends_main.c
  * gap/gap_decode_mplayer_main.c   ## new file
  * gap/gap_mov_dialog.c
  * gap/gap_vex_dialog.c
  * gap/gap_morph_dialog.c

  * libgapvidutil/gap_gve_misc_util.c [.h]

  * vid_common/gap_cme_gui.c
  * vid_enc_avi/gap_enc_avi_gui.c
 
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_par.c
  * vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c


2009-02-08 Wolfgang Hofer <hof@gimp.org>

- Updated external libs

  * configure.in

  * extern_libs/Makefile.am
  * extern_libs/README_extern_libs
  * extern_libs/configure_options_ffmpeg.txt
  * extern_libs/ffmpeg.tar.gz
  * extern_libs/libmpeg3.tar.gz

  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
  * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c 

  * libgapvidapi/gap_vid_api.h 
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * libgapvidapi/gap_vid_api_vidindex.c
  * libgapvidapi/gap_vid_api_mpeg3.c
  * libgapvidapi/gap_vid_api_mpeg3toc.c


- PORTING GIMP-GAP to use recent libmpeg3-1.8

   - configure.in:  disabled check if the compiler is able to handle the libmpeg3
     Note that this check once was introduced because old libmpeg3-1.5.4 did not compile
     with recent gcc compiler version.
     the libmpeg3-1.8 did compile fine on my openSuse 11.1 system that has gcc --version

       gcc (SUSE Linux) 4.3.2 [gcc-4_3-branch revision 141291]


   - mpeg3_open and mpeg3_open_copy have an additional parameter  int *error_return
     (returns 0 if OK, errorcode on failure)
 
   - toc file format has changed
     now GIMP-GAP uses new procedures
      mpeg3_start_toc 
      mpeg3_do_toc
      mpeg3_stop_toc
      
     to create video indexes compatible for libmpeg3-1.8 format
     

  - procedure mpeg3_set_mmx was removed since libmpeg3-1.8
      /// mpeg3_set_mmx(handle->main_handle, FALSE);





- PORTING GIMP-GAP to use recent ffmpeg-export-snapshot.2009.01.31.tar.bz2


  ======= Compile issuses ===================  

  - pointer to first_avcodec no longer public.
    iterate through codecs now can be done with av_codec_next
      for(codec = av_codec_next(NULL); codec != NULL; codec = av_codec_next(codec)) { ...}

     acc->error_resilience = 2;  ==> acc->error_recognition = FF_ER_COMPLIANT

     added explicite configurarion for normal compliance behaviour
     acc->strict_std_compliance = FF_COMPLIANCE_NORMAL;

  - linker complains about missing avcodec_decode_audio 
    ==> therfore use the new procedure avcodec_decode_audio2
        instead.
        (requires data_size initialized and must be >= AVCODEC_MAX_AUDIO_FRAME_SIZE:192000
        if not the call will fail and print a message like this:
        [mp2 @ 0x99a5800]buffer smaller than AVCODEC_MAX_AUDIO_FRAME_SIZE
        )
        
        
  - constant for DEFAULT_FRAME_RATE_BASE no longer available

    some codec flags no longer supported:

     CODEC_FLAG_TRELLIS_QUANT  remove this
     CODEC_FLAG_H263P_AIC      has same   value as CODEC_FLAG_AC_PRED

  - AVCodecContext has no member named rtp_mode

  - removed support for OLD ffmpeg releases. 
    ( #define HAVE_OLD_FFMPEG_0408 and HAVE_FULL_FFMPEG)
  


  ======= CONFIGURE / BUILD  issuses ===================  

  -  ## TODO  ffmpeg no longer supports the configure option --enable-liba52bin
    ==> commented out --enable-liba52bin (remove from configure.in may follow when
        update to ffmpeg is proofed stable.
        
  - ## TODO  ffmpeg requires at least BUILD >= 65 for the option --enable-libx264
     ==> disables the option --enable-libx264 until the check
         for condition x264.h "X264_BUILD >= 65" works.

  - added  -I$FFMPEG_DIR because ffmpeg libraries
    changed include style to add the subdirectory
      OLD: #include "avformat.h"
      NEW: #include "libavformat/avformat.h"

  - ffmpeg libs are not built automatically
    make target  "lib" no longer available.
    ==> now simple make 
       (default target all) builds all ffmpeg libs and programs

  - ffmpeg libs require linking with libbz2 (at least the codec matroskadec want bz2)
    libbz2 was autotomatically detected by the ffmpeg configure script,
    but GIMP-GAP configure must also check for libbz2 and add -lbz2
    to the ffmpeg linker options.


  ======= Functional issuses ENCODE ===================  

  - ffmpeg based vide encoder crash  in av_write_frame 
    (crash occurs both for audio frame and video frame encoding)
    encoder pts is 0, dts is AV_NOPTS_VALUE
    
    ==> recent ffmpeg requires additional initialisations to run properly.
    
    gap_enc_ffmpeg_main.c  :: p_init_video_codec


    if(epp->qscale)
    {
      video_enc->flags |= CODEC_FLAG_QSCALE;
      ffh->vst[ii].vid_stream->quality = FF_QP2LAMBDA * epp->qscale;   /* video_enc->quality = epp->qscale; */
      video_enc->global_quality =  FF_QP2LAMBDA * epp->qscale;      // ### 2009.01.31 must init global_quality to avoid crash
    }

    video_enc->sample_aspect_ratio = av_d2q(l_dbl, 255);
    ffh->vst[ii].vid_stream->sample_aspect_ratio = video_enc->sample_aspect_ratio;  /* 2009.01.31 must init stream sample_aspect_ratio to avoid crash */

  - support nev values for already existing parameters.
    - support new motion estimation algorithm methods
       7 (hex), 8 (umh), 9 (iter), 10 (tesa) [7, 8, 10 are x264 specific, 9 is snow specific]

    - support new idct algorithm methods
                                  _("12 vp3"),             GAP_GVE_FFMPEG_IDCT_ALGO_12_VP3,
                                  _("13 ipp"),             GAP_GVE_FFMPEG_IDCT_ALGO_13_IPP,
                                  _("14 xvidmmx"),         GAP_GVE_FFMPEG_IDCT_ALGO_14_XVIDMMX,
                                  _("15 cavs"),            GAP_GVE_FFMPEG_IDCT_ALGO_15_CAVS,
                                  _("16 simplearmv5te"),   GAP_GVE_FFMPEG_IDCT_ALGO_16_SIMPLEARMV5TE,
                                  _("17 simplearmv6"),     GAP_GVE_FFMPEG_IDCT_ALGO_17_SIMPLEARMV6,
                                  _("18 simplevis"),       GAP_GVE_FFMPEG_IDCT_ALGO_18_SIMPLEVIS,
                                  _("19 wmv2"),            GAP_GVE_FFMPEG_IDCT_ALGO_19_WMV2,
                                  _("20 faan"),            GAP_GVE_FFMPEG_IDCT_ALGO_20_FAAN,
                                  _("21 ea"),              GAP_GVE_FFMPEG_IDCT_ALGO_21_EA,
                                  _("22 simpleneon"),      GAP_GVE_FFMPEG_IDCT_ALGO_22_SIMPLENEON,
                                  _("23 simplealpha"),      GAP_GVE_FFMPEG_IDCT_ALGO_23_SIMPLEALPHA,

 
  ======= Functional issuses DECODE ===================  
 
  - video index based seek does not work with recent ffmpeg versions.

    ==> AVFormatContext
    pb is now a pointer to ByteIOContext

    OLD:  url_ftell(&handle->vid_input_context->pb);
    NEW:  url_ftell(handle->vid_input_context->pb);

    video index code was updated.
    the new format for video indexes records dts timecodes and allows positioning
    based on DTS timecodes
    using libavformat av_seek_frame, but only if valid DTS timecodes are detected.
    Otherwise the video index uses byte positions (based on url_ftell / url-fseek,
    similar to the old GIMP-GAP video index implementation) as fallback solution.

    old video index files are no longer supported.
    (In my test i already implemented code for the migration, but this does not work
    because decoding delivers slightly different colors for the decoded frames
    and this results in differnt checksums as in older ffmpeg release that was used
    at creation time of the video index. So i found out that migration is NOT POSSIBLE)
    
    - fixed bug:
    frame length is just stored with 16 lower bits in the videoindex
    compare must also use just 16 lower bits
    (changed type and name of 
     old: gint32   handle->got_frame_length
     new: guint16  handle->got_frame_length16
    to point out that only 16 bits are used)
    
    - byte position based seek takes us to one frame after the wanted frame
      recording of video index byte offset now compensates this effect
      by recording offests of the 14. frames before the wanted frames


  -  native seek fails on some videos
     old ffmpeg version constantly delivered dts timecodes for all frames in all my test videos.

     unfortunately recent ffmpeg dts timecode detection now fails for some videos.
     (tested with .VOB files from DVD)
     this change breaks the GIMP-GAP native seek feature whenever this problem occures...

     == > the new libgapvidapi/gap_vid_api_ffmpeg.c code now checks
     while proberead for valid dts timecodes, and disables native seek
     if no valid dts timecodes can be detected.

     (and creating a video index for those videos is recommanded)


  - dts timecodes are sometimes not exact and may differ 
    ==> now allow tolerance of +-2
        (see gap_vid_api_ffmpeg.c::p_areTimecodesEqualWithTolerance)
      

 


 
2009-01-25 Wolfgang Hofer <hof@gimp.org>
 
- fixed Storyboard single clip playback of cliptype GAP_STBREC_VID_IMAGE.
   The playback did missinterpret the single image as animframe in case the image has a number part
   and showed non-relevant frames according to the from / to parameters in the internal clip datastructure
   that should be ignored for single image.

- fixed minor memory leak in  gap/gap_story_file.c::gap_story_filename_is_videofile_by_ext

- fixed Storyboard thumbnail rendering, where clip of type movie caused GIMP-2.6 error message
  that complains about unknown filetype.
    "Fehler beim Ausführen der Prozedur »gimp-file-load«:
    Unbekannter Dateityp"
  This was triggered when thumbnails for clips of type movie (*.mpg, *.avi ....)
  are to be rendered from full "image" as fallback strategy in case no thumbnail is available,
  but such fallback does only make sense for frames and single images that can be loaded as
  image by the gimp core.
  For movies and sections we must use the relevant default icon in this case. 
  (the typically situation when videothumbnail is disabled)


- bugfix: master videoencoder dialog does NOT update encoder status progress while encoding.
  Using gimp_set_data gimp_get_data as communication channel between master encoder dialog plugin 
  and the video encoder plug in (running in another process) does no longer work
  with GIMP-2.6, because the master encoder call to gimp_get_data now blocks
  until the encoder exits.
  Now using a binary file to communicate the encoder status and cancel requests,
  this allows to keep the master encoder GUI progress page active while 
  the encoder process is running
 
  * gap/gap_story_dialog.c
  * gap/gap_story_file.c
  * gap/gap_story_properties.c

  * vid_common/gap_cme_main.c [.h]
  * vid_common/gap_cmegui.c
  * vid_common/gap_cme_callbacks.c
  * libgapvidutil/gap_gve_misc_util.c [.h]

2009.01.22 Wolfgang Hofer <hof@gimp.org>

- added support run with last values for Split Image to frames feature.
  this fixes the  GIMP Message  Execution error for procedure 'gimp-file-save'
  as reported in #568143

  * gap/gap_split.c


2009-01-21 Wolfgang Hofer <hof@gimp.org>

- removed restriction in split image feature as suggested in bugreport #568143
  added overwrite dialog 
  (the old implementation did silently overwrite the frames without asking for permission)

    * gap/gap_lib.c [.h]
    * gap/gap_split.c

2009-01-20 Wolfgang Hofer <hof@gimp.org>


- fixed Gtk warnings about non zero page size in all GIMP-GAP dialogs
  Gtk-WARNING **: GtkSpinButton: setting an adjustment with non-zero page size is deprecated

    * gap/gap_morph_dialog.c
    * gap/gap_onion_dialog.c
    * gap/gap_player_dialog.c
    * gap/gap_resi_dialog.c
    * gap/gap_story_att_trans_dlg.c
    * gap/gap_story_dialog.c
    * gap/gap_vex_dialog.c
    * gap/gap_wr_color_huesat.c
    * gap/gap_wr_color_levels.c
    
    * vid_common/gap_cme_gui.c
    * vid_enc_avi/gap_enc_avi_gui.c
    * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c

- fixed bugs in the curves tool wrapper
  that called curves tool on non-relevant histogram channels
  (now check for alpha channel, and type rgb or gray)
  fixed processing order of channels.
  
  with the old order the results were different to the GIMP color curves tool
  for rgb images in case when both value and color r/g/b modifications
  are applyed)

    * gap/gap_wr_color_curve.c

2009-01-19 Wolfgang Hofer <hof@gimp.org>

- wrapper for the curves tool now support both the old and new fileformat
  for new color curves (saved with GIMP-1.2 upto GIMP-2.4 and GIMP-2.6)

- fixed some (but not yet all) GtkWarnings about deprecated usage
   (gap_player_dialog:4654): Gtk-WARNING **: GtkSpinButton: setting an adjustment with non-zero page size is deprecated

   * gap/TESTPROT_iter_ALT
   * gap/gap_player_dialog.c
   * gap/gap_wr_color_curve.c

2009-01-18 Wolfgang Hofer <hof@gimp.org>

Started port to GIMP-2.6.4

- FilterAllLayers basically works, but prints annoying error message:

    Fehler beim Aufruf der Prozedur "gimp-procedural-db-proc-info":
    Prozedur "plug-in-alienmap2-Iterator" wurde nicht gefunden
  
  Gap used gimp-procedural-db-proc-info to check if an procedure is available.
  The implemented workaround mow queries the full list of all procedures,
  and first checks the list before mking an attempt to query gimp-procedural-db-proc-info
  
  TODO [optional]: is there is a better way for a plugin to test if another PDB procedure is available
  without causing Error messages if the searched name not exists ?

- Filter all Layer compatibility test

  fixed ERROR: p_plug_in_flame_iter_ALT  stored Data missmatch in size 8104 != 7048  
         in iterator_ALT procedure (xform array size canged FLAME_NVARS   from 7 to 29)
  fixed ERROR: p_plug_in_ripple_iter_ALT  stored Data missmatch in size 32 != 28 
         in iterator_ALT procedure (added parameter gint          phase_shift;)

  plug-in-wr-color-levels fails to load files that are saved with the curves tool of GIMP-2.6.4
  the fileformat has canged, ... not yet fixed just warn that new format not yet supported.

  TODO parser shall support both old "# GIMP Curves File"
      and new format...              "# GIMP curves tool settings"
  
  
  
   * gap/TESTPROT_iter_ALT
   * gap/gap_filter_pdb.c
   * gap/gap_pdb_calls.c [.h]
   * gap/gap_wr_color_curve.c
   * gap/iter_ALT/mod/plug_in_flame_iter_ALT.inc
   * gap/iter_ALT/gen/plug_in_ripple_iter_ALT.inc

2009-01-14 Wolfgang Hofer <hof@gimp.org>

- changed frame fetcher to use image parasites to mark cached images (and temporary duplicates)
  the old implementation based on static global lists did not work for filtermacros
  because the filtermacro that registers as cache user typically
  runs in another process than the iterator (that is invoked from the called filter)
  With the old implementation all images that were fetched via persistent drawable_id
  in filtermacros were never deleted and filled up memory until gimp-swap fills up the disk
  then caused no more space left on device errors.

- bugfix Master Video Encoder.
  Again the "Encoder" page labels were not updated as expected.
  The labels did show just the highest digit (FramesDone  8   when 817 frame done ..)
  the new fix already creates the label with placeholder for 6 digits. "######".
  procedure p_set_label_to_numeric_value uses leading blanks

- added storyboard feature "area replacement" via format string that provides
   videoclip and framenumber specific logo inserts for all handled clips of type movie.
   Framespecific area replacement can be used for individual fixes 
   (provided as manual edited frame image) on some partly damaged frames
 
- drawable iterator: additional checks for valid drawables

- morph or fade can be used to create tweens (for missing frames in a framesequence)
 


   * docs/reference/txt/plug-in-gap-storyboard-master-prop.txt  
   * gap/gap_file_util.c  
   * gap/gap_filter_iterators.c  
   * gap/gap_frame_fetcher.c  
   * gap/gap_image.c  
   * gap/gap_image.h  
   * gap/gap_layer_copy.c  
   * gap/gap_layer_copy.h  
   * gap/gap_morph_dialog.c  
   * gap/gap_morph_dialog.h  
   * gap/gap_morph_exec.c  
   * gap/gap_morph_exec.h  
   * gap/gap_morph_main.c  
   * gap/gap_morph_main.h  
   * gap/gap_story_dialog.c  
   * gap/gap_story_file.c  
   * gap/gap_story_file.h  
   * gap/gap_story_main.h  
   * gap/gap_story_properties.c  
   * gap/gap_story_render_lossless.c  
   * gap/gap_story_render_processor.c  
   * gap/gap_story_render_types.h  
   * gap/gap_story_syntax.c  
   * gap/gap_story_syntax.h  
   * gap/Makefile.am  
   
   NEW FILES:
   * gap/gap_morph_tween_dialog.c  
   * gap/gap_morph_tween_dialog.h  
   * gap/gap_wr_resynth.c  
  
2008-12-16 Wolfgang Hofer <hof@gimp.org>

- fixed split image to frames for indexed images, and
  implemented feature to copy image properties such as channels,
  pathes, guides etc..to all resulting frame images.
  (#564330 and #564333

- fixed a bug in gap_lib.c where saving of thumbnails failed in case the frame image
  was created in one of the gap plug-ins and subsequent save operation had not
  yet set the filename.

   * gap/gap_main.c
   * gap/gap_split.c [.h]
   * gap/gap_lib_common_defs.h
   * gap/gap_lib.c
  
2008-11-27  Sven Neumann  <sven@gimp.org>

	* configure.in: define GIMP_DISABLE_DEPRECATED when compiling
	against GIMP 2.4 or GIMP 2.6.

2008-11-08 Wolfgang Hofer <hof@gimp.org>

- fix for the bugfix (The "Encoder" page labels were not updated as expected.)
  (accidently the previous check in added a non working version)
  
   * vid_common/gap_cme_gui.c

2008-11-08 Wolfgang Hofer <hof@gimp.org>

- bugfix Master Video Encoder.
  The "Encoder" page labels were not updated as expected.
  The labels did show just the highest digit (FramesDone  8   when 817 frema done ..)
  maybe this is a gtk problem, but the fix 
  in procedure p_set_label_to_numeric_value 
  now repeats the gtk_misc_set_alignment call
  to force refresh the alignment when the value changes.
  
   * vid_common/gap_cme_gui.c

2008-11-02 Wolfgang Hofer <hof@gimp.org>

- bugfix Master Video Encoder. The "Encoder" page of the notebook widget
  is sporadic not visible when the encoding thread is running.
  Workaround: show the encoder tab already at creation of the dialog
  and keep it visible all the time.
  
   * vid_common/gap_cme_gui.c
   * vid_common/gap_cme_callbacks.c

2008-11-02 Wolfgang Hofer <hof@gimp.org>

- fix #558529

- Master Video Encoder dialog now stays open while video encoding is active
  to display encoding progress, including statistics how many frames
  were encoded so far and how many frames could be copied 1:1 
  (for encoder types that support the "dont recode flag"
  for lossles cut)
  

   * vid_common/gap_cme_main.c [.h]
   * vid_common/gap_cme_gui.c [.h]
   * vid_common/gap_cme_callbacks.c
   * libgapvidutil/gap_gve_misc_util.c [.h]
   * libgapvidutil/gap_gvetypes.h
 
   * vid_enc_avi/gap_enc_avi_main.c
   * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
   * vid_enc_rawframes/gap_enc_rawframes_main.c
   * vid_enc_single/gap_enc_singleframes_main.c

   * gap/gap_story_file.c

2008-10-31  Sven Neumann  <sven@gimp.org>

	* gap/gap_dbbrowser_utils.c: removed redeclaration of
	gimp_proc_view_new(). This function is in libgimp since GIMP 2.4.
	Declaring it here breaks the build with GIMP 2.6.

2008-10-31  Sven Neumann  <sven@gimp.org>

	* autogen.sh: also support automake 1.10.

2008-10-26 Wolfgang Hofer <hof@gimp.org>

- storyboard properties: replaced mask_name entry by a conbo box
  (restricts mask reference selections to the list of available mask definitions)

- fixed a bug that rendered unitialized data in the mask preview of the 
  storyboard properties dialog when adding a mask to a clip
  that had no mask when the dialog was created.
  
  Happens when the 1st rendering of the preview has a desaturation_request
  and the widget is not realized yet (has no window pointer).
  In this case nothing is rendered, but subsequent repaint uses
  uninitialized data.

- fixed a bug that caused crash on attempt to propagate changes
  to already closed (dead) propery dialogs
  (GapStbPropWidget)
  
   * gap/gap_story_main.h
   * gap/gap_story_dialog.c
   * gap/gap_story_properties.c [.h]
   * gap/gap_story_att_trans_dlg.c

2008-10-22 Wolfgang Hofer <hof@gimp.org>

- implemented deinterlace support for all storyboard clip types.
  (previous version did only support cliptype GAP_FRN_MOVIE)

   * libgapvidapi/gap_vid_api.c [.h]
   * gap/gap_story_render_processor.c

2008-10-20 Wolfgang Hofer <hof@gimp.org>

- refactoring of procedure p_story_render_fetch_composite_image_private

   * gap/gap_story_render_processor.c

2008-10-19 Wolfgang Hofer <hof@gimp.org>
- fixed bug when closing clip properties dialog
  (the check for non-unique mask definition name must be restricted to
  mask-definition clips and MUST NOT run for other clips)
  
- STORYBOARD clip properties now supports deinterlace modes
    Odd First
    Even First
  The new modes apply the deintelace filter (that builds a full frame
  from the rows of one half-frame similar to the already existing Odd and Even modes)
  but does switch to the oppsite half-frame in case non integer stepsize is used,
  and the non-integer part of the resulting framenumber position is >= 0.5.
  
  Example:
  Video clips (from DVD source) are typically interlaced frames.
  One interlaced frame contains 2 half frames A and B
  where A and B are shot in double speed than the specified framerate of the clip.
  
  framerate 25 fps
  
  frame 000001
    +----------------+
    |  half frame A  |  t = 0
    +----------------+
    |  half frame B  |  t = 1/50 sec
    +----------------+


  frame 000002
    +----------------+
    |  half frame A  |  t = 2/50 sec  (1/25 sec)
    +----------------+
    |  half frame B  |  t = 3/50 sec
    +----------------+


  a videoclip with stepsize 0.5 with deinterlace mode Odd fetches:
  
  frame 000001 (A)
  frame 000001 (A)
  frame 000002 (A)
  frame 000002 (A)

  a videoclip with stepsize 0.5 played with deinterlace mode Odd First will fetch:

  frame 000001 (A)
  frame 000001 (B)
  frame 000002 (A)
  frame 000002 (B)
  
  This gives smooth movement in half speed slow motion playback.
    

   * NEWS
   * gap/gap_story_file.c
   * gap/gap_story_render_processor.c
   * gap/gap_story_properties.c
   * gap/gap_story_main.h
   * gap/gap_story_render_lossless.c

2008-10-15 Wolfgang Hofer <hof@gimp.org>

- changed the wrapper for rotate any angle functionality to support
  animated fliter apply with varying value.

   * gap/gap_wr_trans.c

2008-10-12 Wolfgang Hofer <hof@gimp.org>

- added wrapper for rotate any angle functionality.
  This provides variable rotation functionality in filtermacros
  and therefore can also be used in storyboards.
- fixed detection if there is a selection for all transform wrappers in
  gap_wr_trans.c 
  (the bug caused error messages "gimp_selection_load was called with invalid drawable_id")

   * gap/gap_wr_trans.c

2008-10-11 Wolfgang Hofer <hof@gimp.org>

- fixed BUG #555279 (canged the message to avoid the "100%" string
  that leads to misinterpretation by xgettext.

   * gap/gap_video_index_creator.c
   
2008-10-05 Wolfgang Hofer <hof@gimp.org>

- fixed BUG #523115 that sometimes caused a crash when splitting an image to frames.
     (The procedure gap_lib.c:gap_lib_strdup_add_underscore
      allocated a string for the result that was 1 character too short,
      but the crash occured later in the g_free call

   * gap/gap_lib.c

- bugfix: in the Storyboard Mask definition dialog
  Entering a mask name leads to crash while typing mask name
  in case the partly typed name matches an already existing mask name.
  
  Now the mask_name is not automatically updated while typing.
  The update is done later, when closing the dialog,
  or on explicite request via the new button for explicite setting the mask name.
  Furthermore the update checks for unique name and rejects a non-unique
  name with an erro message.

   * gap/gap_story_main.h
   * gap/gap_story_properties.c

- bugfix: Master Videoencoder dialog: create composite audio extract of multiple audio clips 
  from the same video did extract from start playtime of 1st clip 
  until end playtime of last clip refering the video file (OK)
  but this was done foreach clip that makes processing slow and finally filled up my disk in a large
  storyboard project.
  (Bug was introduced with the storyboard section feature, 
   and therefore not relevant for the stable branch)

    * gap/gap_story_render_audio.c

- player otone playback in storyboard file:
  fixed offset calculation for the start sample
  must use local samplerate of the refered video clip
  (p_get_audio_relevant_FrameNr and p_audio_start_play)

    * gap/gap_player_dialog.c

2008-07-31 Wolfgang Hofer <hof@gimp.org>

- new feature: Persistent drawable id references.
      Filtermacro supports persistent drawable_id mapping.
      allows applying recorded filtermacro apply in another gimp session
      when the recorded last values buffer data  has references
      to drawable ids.

      Example:
      the filetermacro has recorded settings to apply the
      plug_in_bump_map
      
      that has a reference to a drawable_id that shall be used as map
      
      The new feature creates a persistent mapping for this drawable_id in a file
      named <filtermacro>.fmref with information about the imagefile and layer
      
      RESTRICTIONS:
       The current implementation can NOT handle parallell processing of multiple filtermacros
       because there is only ONE context that will be overwritten in case of concurrent calls.

  
    * NWES
    * gap/Makefile.am
    * gap/gap_fmac_base.c
    * gap/gap_fmac_main.c
    * gap/gap_filter_pdb.c [.h]
    * gap/gap_filter_iterators.c
    * gap/gap_player_main.c [.h]
    * gap/gap_player_dialog.c
   
    * gap/gap_frame_fetcher.c [.h]            # NEW files
    * gap/gap_fmac_context.c [h]              # NEW files
    * gap/gap_drawable_vref_parasite.c [.h]   # NEW files
    * gap/gap_story_render_processor.c
    * gap/gap_story_dialog.c
    * gap/gap_story_file.c
    * gap/gap_story_vthumb.c
    * gap/gap_story_render_types.h
    * libgapvidutil/gap_gve_story.h

2008-07-13 Wolfgang Hofer <hof@gimp.org>

- new feature: viedo extract supports generating transparency via bluebox

- new feature Modify Frames create grayscale layer from
   alpha channel, or layermask or mix of both
 
    * gap/gap_layer_copy.c  [.h]
    * gap/gap_mod_layer.c [.h]
    * gap/gap_mod_layer_dialog.c [.h]
    * gap/vex_main.c [.h]
    * gap/vex_exec.c
    * gap/gap_vek_dialog.c
    * gap/Makefile.am

2008-07-05 Wolfgang Hofer <hof@gimp.org>

 - new feature: Player supports extracting audio track when playing clips
   that refere to a videofile that has one or more audiotrack(s)

 - video extract plugin: made auido extract work again. 
  (bug caused by recent refactoring 2008-06-29)

  * NEWS
  * gap/gap_audio_extract.c [h]
  * gap/gap_player_main.c [.h]
  * gap/gap_player_dialog.c
  * gap/gap_vex_exec.c
  * libgapvidapi/gap_vid_api.h

2008-06-29 Wolfgang Hofer <hof@gimp.org>
   Merged in current locale development.

   (2008-06-24 Wolfgang Hofer <hof@gimp.org>

    - moved audio extract feature from gap_vex_exec.c to a new module 
   gap_audio_extract.c [.h]
   (this is the 1st refactoring step, required for a planed feature of the
   player that shall provide original auditrack when playback refers to a videofile.

  
 
   (2008-06-22 Wolfgang Hofer <hof@gimp.org>)
   - experimental AVI encoder support for png codec.

   allows packing png frames into an AVI video fileformat.
   (the dont_recode_flag can be used to significantly speed up operation
    if the refered source frames are already PNGs in correct size)
   
   The PNG codec is based on the gimp-file-save-png plug-in.
   and offers video encoding without loss of quality.
   (such as RAW codec does, but PNG has lossless compression
   and can be used to reduce storage resources where lossless
   frames are required)

   oops, PNG codec is not supported in mplayer when playback AVI
   therefore the PNG encoded videofiles do not make sense today..
   (the ffmpeg "png" codec name is only for access single frames
   but cant be used when PNG frames are stored in the AVI container
    (mplayer:
     VIDEO:  [PNG ]  640x480  24bpp  1.000 fps  3620.9 kbps (442.0 kbyte/s)
     Clip info:
      Software: gimp-gap-2.5.0
     ==========================================================================
     Cannot find codec matching selected -vo and video format 0x20474E50.
     Read DOCS/HTML/en/codecs.html!
     ==========================================================================

   TODO: disable the PNG encoder until some player supports it.

   

  
   (2008-06-15 Wolfgang Hofer <hof@gimp.org>

   Storyboard render processor: changed frame fetch procedure to
   support fetching already compreessed frames from disc
   and use this new feature in the AVI video encoder.
   (now it is possible to do lossless encoding via storyboard
   if no transitions are required. This allows fetching alread compressed
   JPEG files both from image files and from MPEG I-frames)

   My Olympus SP560UZ Digitalcamera can record AVI videos,
   where each frame is a MJPG encoded jpeg image. GIMP-GAP now supports
   lossless cut for such AVI videos.

   Gap video api provides new procedure to query the codec name
   (GVA_get_codec_name). This is used for lossless cut features
   when the encoder enables the relevant check_flag
     GAP_VID_CHCHK_FLAG_VCODEC_NAME 
   Those checks shall help to avoid corrupt output videos
   when the user tries to mix differnt video file resources
   into one resulting output video in lossless mode
   (e.g. with dont recode flag enabled)

   TODO: check how the changes affected the lossless mpeg encoding
         features (Those features were once developed based on
         the libmpeg3 as decoder and libavformat as encoder engine
         and were still in experimental state before this changes.


  (2008-06-07) Wolfgang Hofer <hof@gimp.org> )

  attempt to implemnet raw video chunk fetching support
  for ffmpeg based video decoder.
  (new procedure p_wrapper_ffmpeg_get_video_chunk)
  this implementation builds the base for lossless video cut operations.
  until now libmpeg3 was the only decoder with video chunk fetching support
  (but libmpeg3 is old and unmaintained since years)
  
  

  New experimental "rawframes" encoder.
  The rawframes works similar to the single frames encoder
  and "extracts" singleframes from a storyboard source,
  The rawframes encoder writes the videoframes 1:1 as single files to disc
  instead of encoding to one videofile. It is mainly intended for
  extracting I Frames 1:1 from MPEG or AVI as JPEG files
  where the decoding and reencoding process is skipped where possible
  This results in fast and lossless extract of keyframes.


  * Makefile.am
  * configure.in
  * vid_enc_rawframes                             # NEW dir
  * vid_enc_rawframes/gap_enc_rawframes_main.c    # NEW file
  * vid_enc_rawframes/Makefile.am                 # NEW file
  * po/POTFILES.in
  
  * vid_enc_avi/gap_enc_avi_gui.c
  * vid_enc_avi/gap_enc_avi_main.c [.h]
  * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

  * libgapvidutil/Makefile.am
  * libgapvidutil/gap_gve_png.c[.h]               # NEW FILE
  * libgapvidapi/gap_vid_api.h
  * libgapvidapi/gap_vid_api_util.c
  
  * libgapvidapi/gap_vid_api.c [.h]
  * libgapvidapi/gap_vid_api_util.c
  * libgapvidapi/gap_vid_api_ffmpeg.c
  * gap/Makefile.am
  * gap/gap_story_render_processor.c [.h]
  * gap/gap_story_render_lossless.c               # NEW FILE
  * gap/gap_audio_extract.c [.h]                  # NEW FILES
  * gap/gap_vex_exec.c



2008-06-29 Wolfgang Hofer <hof@gimp.org>
  - fixed endless loop in the Player on attempt to enter a vaild audiofile name.
  
  * gap/gap_player_dialog.c

2008-05-19 Wolfgang Hofer <hof@gimp.org>
- bugfix: extract JPEG frames from videofile shall not pop up save dialog
        on each handled frame.
- bugfix:  #348456 enable undo for image extracted from a video.
          (The video api now checks if undo is enabled
          and makes only one call to disables undo when required)

 * gap/gap_vex_exec.c:
 * libgapvidapi/gap_vid_api.c

- use png imagetype for storyboard render debug frame save feature

 * gap/gap_story_render_processor.c

2008-05-18 Wolfgang Hofer <hof@gimp.org>
 - storyboard now supports 8 digit framenumbers 
  (increased GAP_STB_MAX_FRAMENR from 999999 99999999)

 * gap/gap_story_file.c [.h]
 * gap/gap_story_properties.c

2008-05-18 Wolfgang Hofer <hof@gimp.org>
- bugfix: #531735 enable undo after creating the animated preview image.
- bugfix: save jpeg frames for the singleframes encoder must use gap specific
          procedure gap_lib_save_named_image (direct call of gimp_file_save causes dialog
          prompts on each handled frame because runmode with last values is uesed)

 * gap/gap_mov_exec.c
 * gap/gap_lib.c
 * vid_enc_single/gap_enc_singleframes_main.c

2008-05-18 Wolfgang Hofer <hof@gimp.org>
  - bugfix: save frames as jpeg was broken due to new behaviour of the file_jpeg_save plug in.
     run with last values opens dialog for each handled frame which is not acceptable
     for saving lots of frames.
     The fix now uses the Non interactive save mode and the jpeg save values
     that is stored as image parasite by the  file_jpeg_save plugin when saving
     the 1st handled frame.

  - bugfix: frames renumber start frame number maximum changed from 999999 to 99999999
    (this is required if someone will use the maximum supported length of 8 digits for the framenumber part)
  
  * gap/gap_base_ops.c
  * gap/gap_lib.c

2008-03-10 Wolfgang Hofer <hof@gimp.org>
  - bugfix in storyboard processor: if processed image has only one layer with a layermask
    the layermask was ignored at render processing.
    
  * gap/gap_story_render_processor.c

2008-04-06  Wolfgang Hofer <hof@gimp.org>

    Lots of updates (merged in local development since 2006-07-16)
    This also includes merge of the changes and bugfixes that were alredy applied
    in the stable gimp-gap-2.4 branch.
    
    Merge protocol:
        NEW FILES ADDED TO SVN:
          gap/gap_fmac_base.c 
          gap/gap_fmac_base.h  
          gap/gap_fmac_name.c  
          gap/gap_fmac_name.h  
          gap/gap_fmac_varying_main.c  
          gap/gap_story_section_properties.c  
          gap/gap_story_section_properties.h  
          gap/gap_story_undo.c  
          gap/gap_story_undo.h  
          gap/gap_story_undo_types.h  
          gap/gap_story_vthumb.c  
          gap/gap_story_vthumb.h  
          gap/gap_video_index_creator.c  

          images/gap-story-icon-blacksection.png  
          images/gap-story-icon-section-main.png  
          images/gap-story-icon-section-mask.png  
          images/gap-story-icon-section.png  

          libgapbase  
          libgapbase/gap_val_file.c  
          libgapbase/gap_val_file.h  
          libgapbase/Makefile.am  



        CHANGED FILES (checked and merged):
        m-  merge was necessary and performed.
        l-  use 1.1 copy from local latest
        s-  use 1.1 copy from  from svn trunc latest


        m-  ChangeLog  
        m-  configure.in 
        l-  Makefile.am  
        l-  NEWS  
        l-  README  

        l-  docs/reference/txt/gap_gimprc_params.txt  
        l-  docs/reference/txt/INTRODUCTION.txt  
        l-  docs/reference/txt/plug-in-gap-storyboard-edit.txt  
        l-  docs/reference/txt/STORYBOARD_FILE_DOC.txt  

        l-  extern_libs/configure_options_ffmpeg.txt  
        l-  extern_libs/ffmpeg.tar.gz  
        l-  extern_libs/Makefile.am  
        l-  extern_libs/README_extern_libs  

        l-  gap/gap_arr_dialog.c  
        l-  gap/gap_arr_dialog.h  
        m-  gap/gap_bluebox.c  
        s-  gap/gap-dup-continue.scm  
        l-  gap/gap_file_util.c  
        l-  gap/gap_file_util.h  
        l-  gap/gap_filter_codegen.c  
        l-  gap/gap_filter_foreach.c  
        l-  gap/gap_filter.h  
        l-  gap/gap_filter_iterators.c  
        l-  gap/gap_filter_pdb.c  
        l-  gap/gap_filter_pdb.h  
        l-  gap/gap_fmac_main.c  
        m-  gap/gap_layer_copy.c  
        l-  gap/gap_lib.c  
        l-  gap/gap_lib.h  
        l-  gap/gap_mod_layer.c  
        l-  gap/gap_mod_layer_dialog.c  
        l-  gap/gap_mod_layer.h  
        l-  gap/gap_morph_dialog.c  
        l-  gap/gap_morph_exec.c  
        m-  gap/gap_mov_dialog.c  
        m-  gap/gap_mov_render.c  
        l-  gap/gap_navigator_dialog.c  
        l-  gap/gap_pdb_calls.c  
        m-  gap/gap_player_dialog.c  
        l-  gap/gap_player_main.c  
        l-  gap/gap_player_main.h  
        s-  gap/gap_pview_da.c  
        l-  gap/gap_range_ops.c  
        l-  gap/gap_split.c  
        l-  gap/gap_story_att_trans_dlg.c  
        m-  gap/gap_story_dialog.c  
        l-  gap/gap_story_dialog.h  
        l-  gap/gap_story_file.c  
        l-  gap/gap_story_file.h  
        l-  gap/gap_story_main.c  
        l-  gap/gap_story_main.h  
        m-  gap/gap_story_properties.c  
        l-  gap/gap_story_render_audio.c  
        l-  gap/gap_story_render_processor.c  
        l-  gap/gap_story_render_processor.h  
        l-  gap/gap_story_render_types.h  
        l-  gap/gap_story_syntax.c  
        l-  gap/gap_story_syntax.h  
        l-  gap/gap_vex_dialog.c  
        l-  gap/gap_vin.c  
        l-  gap/gap_vin.h  
        l-  gap/gap_wr_color_curve.c  
        l-  gap/gap_wr_color_huesat.c  
        l-  gap/gap_wr_color_levels.c  
        l-  gap/gimplastvaldesc.h  
        l-  gap/Makefile.am  
        s-  gap/sel-to-anim-img.scm  
        l-  gap/TESTPROT_iter_ALT  


        l-  gap/iter_ALT/gen/plug_in_alpha2color_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_blinds_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_borderaverage_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_checkerboard_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_CML_explorer_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_colorify_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_color_map_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_cubism_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_destripe_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_diffraction_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_displace_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_edge_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_engrave_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_flarefx_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_fractal_trace_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_gauss_iir2_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_gauss_iir_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_gauss_rle2_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_gauss_rle_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_gfig_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_glasstile_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_grid_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_jigsaw_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_mblur_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_mosaic_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_newsprint_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_noisify_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_pixelize_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_randomize_hurl_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_randomize_pick_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_randomize_slur_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_ripple_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_rotate_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_scatter_hsv_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_sharpen_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_shift_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_spread_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_video_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_vpropagate_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_waves_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_whirl_pinch_iter_ALT.inc  
        l-  gap/iter_ALT/gen/plug_in_wind_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_alienmap2_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_alienmap_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_apply_canvas_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_applylens_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_blur_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_bump_map_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_cartoon_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_colors_channel_mixer_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_colortoalpha_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_convmatrix_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_deinterlace_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_depth_merge_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_despeckle_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_dog_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_emboss_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_exchange_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_flame_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_gauss_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_gimpressionist_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_illusion_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_lic_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_lighting_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_make_seamless_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_map_object_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_max_rgb_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_maze_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_neon_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_nlfilt_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_normalize_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_nova_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_oilify_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_pagecurl_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_papertile_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_photocopy_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_plasma_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_polar_coords_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_retinex_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_sample_colorize_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_sel_gauss_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_sinus_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_small_tiles_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_sobel_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_softglow_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_solid_noise_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_sparkle_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_Twist_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_unsharp_mask_iter_ALT.inc  
        l-  gap/iter_ALT/mod/plug_in_vinvert_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_anamorphose_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_blur2_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_CentralReflection_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_colorify_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_encript_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_figures_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_gflare_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_holes_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_julia_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_magic_eye_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_mandelbrot_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_randomize_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_refract_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_struc_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_tileit_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_universal_filter_iter_ALT.inc  
        l-  gap/iter_ALT/old/plug_in_warp_iter_ALT.inc  

        l-  images/Makefile.am  

        m-  libgapvidapi/gap_vid_api.c  
        l-  libgapvidapi/gap_vid_api_ffmpeg.c  
        l-  libgapvidapi/gap_vid_api_gimp.c  
        l-  libgapvidapi/gap_vid_api.h  
        l-  libgapvidapi/gap_vid_api_mpeg3.c  
        l-  libgapvidapi/gap_vid_api_quicktime.c  
        l-  libgapvidapi/gap_vid_api_vidindex.c  
        l-  libgapvidapi/Makefile.am  

        l-  libgapvidutil/gap_gvetypes.h  
        l-  libgapvidutil/Makefile.am  

        s-  po/ar.po  
        s-  po/bg.po  
        s-  po/ca.po  
        s-  po/ChangeLog  
        s-  po/en_GB.po  
        s-  po/es.po  
        s-  po/fi.po  
        s-  po/fr.po  
        s-  po/it.po  
        s-  po/ne.po  
        l- po/POTFILES.in  
        s-  po/pt_BR.po  
        s-  po/ru.po  
        s-  po/sl.po  
        s-  po/sv.po  

        l-  vid_common/gap_cme_callbacks.c  
        l-  vid_common/gap_cme_gui.c  
        l-  vid_common/gap_cme_main.c  
        l-  vid_common/gap_cme_main.h  
        l-  vid_common/Makefile.am  

        m-  vid_enc_avi/gap_enc_avi_main.c  
        l-  vid_enc_avi/gap_enc_avi_main.h  
        l-  vid_enc_avi/Makefile.am  

        m-  vid_enc_ffmpeg/gap_enc_ffmpeg_main.c  
        l-  vid_enc_ffmpeg/gap_enc_ffmpeg_main.h  
        l-  vid_enc_ffmpeg/gap_enc_ffmpeg_par.c  
        l-  vid_enc_ffmpeg/Makefile.am  

        l-  vid_enc_single/gap_enc_singleframes_main.c  
        l-  vid_enc_single/Makefile.am  
    
    Here comes the detailed List of the changes:
    
    (2008-03-22)
    - Storyboard Dialog feature (CTRL-DoubleClick) additional invokes external image viewer
      (work only for clip types image frame...)

      gimprc: 
      (video_external_image_viewer "eog")

    (2008-01-05)
    - modify frames support to expand layer to image size 
      (applied patch #488653)

    - fixed bug #505001 (replaced calls to deprecated gimp_path_* procedures)
    * gap/gap_mov_dialog.c

    * gap/gap_mod_layer_dialog.c
    * gap/gap_mod_layer.c
    * gap/gap_mod_layer.h

    (2008-01-01)
    - ffmpeg encoding crash at close (when calling url_fclose for the encoded video file)
      ==> workaround uses a private version of url_fclose (my_url_fclose)

    - ffmpeg encoding bug with recent version produces corrupted result.
      (tested with codecs: MPEG1 and MPG2)

       prints out the error message:
          [mpeg @ 0x83d8bf4]buffer underflow i=0 bufi=14756 size=38114


    ffmpeg encoder use  1 as deniominator (where possible) when setup the AVRational struct.

    * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
    * extern_libs/README_extern_libs
    * extern_libs/ffmpeg.tar.gz  # updated to svn snaphot from 2007.12.20

    (2007-12-01)
    - bugfix video api ffmpeg (prefere_native_seek yes) was se in the .analyze file
      but vindex was used in seek operations.

     * libgapvidapi/gap_vid_api_ffmpeg.c

    (2007-12-01)
    - bugfix in modify frames when  using a filter appply function:
       works, but causes GIMP error messages:
            a calling error occurred while trying to run: "gimp-image-delete"

       now calling gimp_image_delete before gimp_display_delete (gap_mod_layer.c)
       and modify frames works without displaying this error message.

    - continue update of _Iterator_ALT procedures for gimp-2.4
      changes the following iterators:

    - bugixes related to animated filtercalls.
    The gimp-2.4.x release has renamed all plug ins to match Canonical identifier names.

      * Canonical identifiers are e.g. expected by the PDB for procedure
      * and parameter names. Every character of the input string that is
      * not either '-', 'a-z', 'A-Z' or '0-9' will be replaced by a '-'.

    canonicalized identifiers are now used in gimp_set_data, gimp_get_data procedures
    and in PDB procedure names.
    conversion is done via

       gimp_canonicalize_identifier.

    (this replaces all underscore characters to minus character)

    the GIMP-GAP Iterator stuff was broken because GIMP-GAP name conventions
    did not match canonical names and many last value buffer structures
    changed since gimp-2.2.x.
    Now changed all names related to Iterator stuff
    to make things work again with GIMP-2.4.0.

    Note that there is no longer backward compatibility with older releases,
    that do not operate with canonical names. (most plug ins also
    changed the structure of their last values buffer.
    (many plug ins had a boolean preview flag in this buffer that was
     removed with gimp-2.4.0)


    configure.in                 # updated required gimp version to 2.4.0

    gap/gap_filter_pdb.c
    gap/gap_filter.h
    gap/gap_filter_foreach.c
    gap/gap_filter_iterators.c
    gap/gap_fmac_base.c
    gap/gap_fmac_main.c
    gap/gap_mod_layer.c
    gap/gap_wr_color_curve.c
    gap/gap_wr_color_hue_saturation.c
    gap/gap_wr_color_levels.c
    gap/gimplastvaldesc.h

    gap/TESTPROT_iter_ALT
    gap/iter_ALT/gen/*.inc
    gap/iter_ALT/mod/*.inc
    gap/iter_ALT/old/*.inc


    (2007-11-28)
    startet update of _Iterator_ALT procedures for gimp-2.4
    all of them must follow the new naming style (underscore changed to minus character).

    * gap/gap_filter.h
    * gap/gap_filter_pdb.c
    * gap/gap_filter_iterators.c

    * gap/iter_ALT/mod/plug_in_map_object_iter_ALT.inc



    (2007-11-24)
     added progress dialog to video index creation plug-in,
     now supports QUICK, SMART and FULLSCANN modes.

     bugifx: video index creation plug-in plug-in was greyed out if no image opened 
      ==> registrate with NULL as PLUG_IN_IMAGE_TYPES, because this plugin works without any image.

    * gap/gap_video_index_creator.c

    (2007-11-20) Wolfgang Hofer <hof@gimp.org>
    video index creation now performs timecode stepsize checks, and updates the video analyze file
    if necessary. (e.g. if critical steps are detected)

    * gap_vid_api_ffmpeg.c


    (2007-11-18)
    fix attempt for crash in storyboard when video thumbnail prefetch is busy.
    caused by concurrent video fetch operations that occured 
    because the prefetch code calls g_main_context_iteration to keep GUI alive.
    ==> current solution automatically cancelles the video thumbnail prefetch
        if another GUI activity requires access to a video thumbnail.

    !!!! sometimes still CRASHING (at open clip properties window)
    ==> dont open properties window if gva_lock set


     * gap/gap_story_dialog.c
     * gap/gap_story_dialog.h
     * gap/gap_story_vthumb.c


    (2007-11-11)
    merged changes from svn into local development.
    ( gimp_show_help_button )

    * gap/gap_arr_dialog.c
    * gap/gap_dbbrowser_utils.c
    * gap/gap_fmac_main.c
    * gap/gap_mov_dialog.c
    * gap/gap_onion_dialog.c
    * gap/gap_resi_dialog.c


    (2007-11-03)
    update libavcodec/libavformat to recent ffmpeg libraries
      - configure option canged from: --enable-xvid  to: --enable-libxvid

    - 2.4 bugfix: GAP_LIB goto frame crashes on non-xcf frames
        caused by gap_lib.c::p_lib_save_named_image2
        attempt to g_free drawable fails with gimp-2.4:

            GimpDrawable *l_drawable;

            l_drawable = gimp_drawable_get(layer_id);
            g_free(l_drawable);                            // crash with invalid pointer exception.

          ==> for correct operation shall use
              gimp_drawable_detach(l_drawable);

              but in this case it is not necessary to call gimp_drawable_get at all.
              changed the code to operate on the gint32 drawable_id.

    - 2.4 bugfix: Master Videoencoder does not recognize the registered encoder plug-ins.
       ==> gimp-2.4 gimp_procedural_db_query does not accept the same wildcard as gimp-2.2
           (underscore characters are no longer found via wildcard)

       changed GAP_WILDCARD_VIDEO_ENCODERS  and use minus character for the all the encoder plug ins.
       from   "^plug_in_gap_enc_.*" 
       to     "^plug-in-gap-enc-.*"


    - gimprc key for tooltips changed in gimp-2.4
      use one common procedure gap_lib_check_tooltips that uses the 2.4 variant.

      value_string = gimp_gimprc_query("show-tool-tips");  // 2.2
      value_string = gimp_gimprc_query("show-tooltips");   // 2.4

    * extern_libs/ffmpeg.tar.gz        (update to snapshot 2007.10.31)
    * extern_libs/README_extern_libs
    * configure.in
    * gap/gap_arr_dialog.c
    * gap/gap_lib.c
    * gap/gap_filter_pdb.c 
    * gap/gap_pdb_calls.c
    * gap/gap_navigator_dialog.c
    * gap/gap_morph_dialog.c
    * gap/gap_story_att_trans_dlg.c


    * libgapvidutil/gap_gvetypes.h
    * docs/reference/txt/INTRODUCTION.txt

    (2007-10-28)
    Started testing based on gimp-2.4.0
     - tooltips are NOT active, even if enabled in GIMP preferences!
      value_string = gimp_gimprc_query("show-tool-tips");  // 2.2
      value_string = gimp_gimprc_query("show-tooltips");   // 2.4

      is there a solution working both in gimp2.2. and gimp2.4 ?

     - bugfix in Gap Playback dialog: 
        Calls with invalid image_id were done at click on preview widget to create a gimp-image.
          gimp-image-set-resolution
          gimp-image-set-unit

        ==> gap_vid_api.c::GVA_image_set_aspect. must set aspect on image_id 
           (and not on gvahand->image_id as was implemented before)

     - annoying warning "No audiosupport .." if wavplay is not installed on each Player start
       the warning is now deferred until 1st attempt to play an audiofile. 

    * libgapvidapi/gap_vid_api.c
    * gap/gap_player_dialog.c



    (2007-10-21)
    - Storyboard Playback button for cliplist and storyboard
      changed normal click and SHIFT-click behaviour.

      old:
         normal:     play all clips of current track,
         SHIFT:      play selected clips of current track
         CTRL:       play composite video, all clips of all tracks
         CTRL_SHIFT: play composite video, only selected clips.
                     (if the user did not make useful selections
                      the result did not produce useful results)

      new:
         normal:     play selected clips of current track
                     (if nothing is selected play all clips)

                     This is the most frequent use case of playback
                     and shall not require a modifier key.

         SHIFT:      play all clips of current track
         CTRL:       play composite video, only selected clips of current track
                     (automatic select and playback frames in all other
                     tracks
         CTRL_SHIFT: play composite video, all clips of all tracks.


      - Storyboard undo/redo support
      - Storyboard debug features triggerd via file
         (the file has constant name: GAP_DEBUG_STORYBOARD
         and is searched in the gimp_directory.

    * gap/Makefile.am
    * gap/gap_story_dialog.c
    * gap/gap_story_undo.c [.h]             # new files
    * gap/gap_story_undo_types.h            # new files

    (2007-10-13)
    - created icon symbol for storyboard section.
    - Storyboard added section properties (popup) dialog
      that handles creation, update and delete of sub-sections.

    * images/Makefile.am
    * images/gap-story-icon-blacksection.png  # new file
    * images/gap-story-icon-section.png       # new file
    * images/gap-story-icon-section-main.png  # new file
    * images/gap-story-icon-section-mask.png  # new file
    * gap/Makefile.am
    * gap/gap_story_vthumb.c [.h]             # new files

    (2007-10-06)
    Storyboard dialog: thumbnail rendering support for clip types
    section and anim-image, based on the storyboard render processor.


    * gap/Makefile.am
    * gap/gap_story_section_properties.c [.h]   # new files

    (2007-09-29)
      - fixed showstopper bugs in the storyboard render processor engine
        (internal bugs in the new section based features)
      - first successful storyboard rendering test using sub sections.
      - selection mapping for playback of composite video.
        the new concept keeps all clips in all tracks of the relevant section
        in the duplicate that is passed to the player, and provides
        a mapping of the selected frame ranges.
        The player uses this mapping to pick only framenumbers that
        are mapped to selected clips.
        (The old approach did include only selected clips in the duplicate
        but this is not sufficient if there is more than one track present.
        Different selections in multiple tracks often leads 
        to unwanted displacements between the tracks
        depending and produces other results
        as the rendering of the finally output video will do, and the user
        would expect).


     * gap/gap_story_render_processor.c [.h]
     * gap/gap_story_file.c [.h]
     * gap/gap_story_dialog.c
     * gap/gap_player_dialog.c

     (2007-09-25)
     storyboard support to save/load edit_settings
     includes current value of active_section, video track and page
     (e.g. scroll position)

     (2007-09-19)
     Continued coding for Storyboard section support. (not yet finished)

     * gap/gap_story_att_trans_dlg.c
     * gap/gap_story_dialog.c
     * gap/gap_story_dialog.h
     * gap/gap_story_file.c
     * gap/gap_story_file.h
     * gap/gap_story_main.c
     * gap/gap_story_main.h
     * gap/gap_story_properties.c
     * gap/gap_story_properties.h
     * gap/gap_story_render_audio.c
     * gap/gap_story_render_audio.h
     * gap/gap_story_render_processor.c
     * gap/gap_story_render_processor.h
     * gap/gap_story_render_types.h
     * gap/gap_story_syntax.c
     * gap/gap_story_syntax.h

     (2007-09-08)
     - bugfix STORYBOARD parser.
       did reject legal duration value 0 on attribut records
       VID_ZOOM and VID_MOVE
     - bugfix: gap_cme_callbacks.cprocedure on_cme__spinbutton_framerate_changed
       no longer cast framerate to integer !
       This error poped up because
       recent versions of libavcodec dont accept framerates, that do
       not exactly match the supported standard values.
       therefore an additional fix was required in the ffmpeg encoder
       to guarantee exactly the expected rates of the codecs
       for some common used framerates.
       (59.94 ==>  60000 / 1001
        29.97 ==>  30000 / 1001
        23.98 ==>  24000 / 1001)

       (caused videos with 29.97 fps fail to encode for some codecs,
       other codecs just used the unwanted truncated value of 29.0)

     - new value "ask-always"  for gimprc parmeter (video-index-creation )
       ask-always provides the old behaviour of the setting "ask".
       the default value "ask" no longer asks the user to create a videoindex in case
       where native seek works, and the videoindex is not required.
       (asking in those situation is rather annoying, especially when working
       with the storyboard dialog)

     - STORYBOARD dialog layout: prepare for new feature that introuces
       sections. 
       - added combo box to select section MAIN, Mask (still without functionality)
       - hide the rowpage spinbutton (Row x of n) to get space for the
         new section name combo box. Note that rowpage spinbutton is redundant information,
         since there is already a vscale widget for scrolling and visualize
         the current position.

     * gap/gap_story_file.c
     * gap/gap_story_main.h
     * gap/gap_story_dialog.c
     * gap/gap_arr_dialog.c
     * docs/reference/txt/gap_gimprc_params.txt

     * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
     * vid_common/gap_cme_callbacks.c

    (2007-09-05)
    - New storyboard feature allows arrange video tracks
      at inverse order e.g video track 1 can appear in backround
      or as foreground (on top of layerstack in the composite frame,
      this is default for compatibility with older storyboard files.)

     * docs/reference/txt/STORYBOARD_FILE_DOC.txt
     * gap/gap_story_syntax.c [.h]
     * gap/gap_story_file.c [.h]
     * gap/gap_story_render_processor.c
     * gap/gap_story_dialog.c

     (2007-05-17)
     detection of external libs for ffmpeg (liba52 and x264)
     if those libs are installed configure ffmpeg accordingly.
     (added configure options to explicite disable both libs)

     * configure.in

    (2007-05-12)
    - continued refactoring libbase
    - removed key/value procedures from gap_vin.c[.h] and
      use common key/value procedures of the new gap_val_file.h
      module.
    - gimprc prameter (video-gva-libavformat-video-analyse-persistent "yes")


     * */Makefile.am        # (changed all Makefiles)
     * gap/gap_vin.c [.h]
     * libgapvidapi/gap_vid_api_ffmpeg.c
     * libgapvidapi/gap_vid_api_vidindex.c


    (2007-05-08)
    - started key/value file refactoring (created libbase)

     * libgapbase                       # new dir
     * libgapbase/Makefile.am           # new file
     * libgapbase/gap_val_file.c        # new file
     * libgapbase/gap_val_file.h        # new file

     * Makefile.am
     * configure.in


     (2007-04-28)
     ffmpeg native seek
     - support for videos that include negative timecode steps.
         * example:
         * video timcode sequence with negative stepsizes may look like this:
         *   seek_framenumber:000556; seek_timecode:45555; stepsize:1;
         *   seek_framenumber:000557; seek_timecode:49306; stepsize:3751; 
         *   seek_framenumber:000558; seek_timecode:45557; stepsize:-3749;
         *   seek_framenumber:000559; seek_timecode:45558; stepsize:1;

     * libgapvidapi/gap_vid_api_ffmpeg.c


    (2007-04-21)
     bugfix storyboard processor crashed
     if the last frame of a video shall be fetched for rendering.
     when the ffmpeg API wrappers are used.

     ==> gap_vid_api_ffmpeg.c::p_seek_private
         old: constraint l_frame_pos to gvahand->total_frames -1
         new: constraint l_frame_pos to gvahand->total_frames.

         must allow full number of frames, because this is the upper
         limit for the seek position.
         The seek position indicates what frame number will be read
         with the next sequential read. The wrong constraint was responsible
         for positioning one frame less than required.
         then the processor performed the read operation with
         intention to read the last frame (but got last-1)
         the following processing could not find the required
         framenumber of the last frame and lead to the crash.


     * libgapvidapi/gap_vid_api_ffmpeg.c
     * libgapvidapi/gap_vid_api.c


     (2007-04-21)
     AVI encoder: removed old unused GUI dialog code variant.

     * vid_enc_avi/gap_enc_avi_main.c


     (2007-04-14)
     bugfixes on ffmpeg native seek
     - gap player: must reset cancel request before trigger self test.
     - ffmpeg native seek: added procedure p_clear_inbuf_and_vid_packet
       must clear the old input buffer content after seek
       otherwise following read operation sometimes crashes at call of avcodec_decode_video
       because the input buffer may still point to an old (now invalid) packet.

     * NEWS
     * gap/gap_player_dialog.c
     * libgapvidapi/gap_vid_api_ffmpeg.c


     (2007-04-13)
     (Applied patch to fix Bug #427487)
     * gap/gap_mod_layer_dialog.c


     (2007-04-10)
     added Video API procedure GVA_check_seek_support
     based on this procedure the caller gets information if
     fast random access is possible with or without creating
     a video index (or not possible at all).

     This information is now presented in the video index creation
     dialog. This dialog only comes up in case where gimprc setting is
       (video-index-creation "ask")
     that is also the default if nothing is configured at all.

     Changes for configuration:
       (video-index-creation "yes")

       the video index creation is NOT done if native seek works
       or if seek does not work at all and video index would be useless.

     * gap/gap_arr_dialog.c [.h]
     * gap/gap_story_dialog.c
     * gap/gap_player_dialog.c:

     * libgapvidapi/gap_vid_api.c [.h]
     * libgapvidapi/gap_vid_api_ffmpeg.c
     * libgapvidapi/gap_vid_api_gimp.c
     * libgapvidapi/gap_vid_api_mpeg3.c
     * libgapvidapi/gap_vid_api_quicktime.x


     (2007-04-04)
     fixed wrong checks for CR character  (was \a, correct is \r)
     * gap/gap_file_util.c
     * gap/gap_story_file.c


     (2007-04-03)
     new plug-in for explicite video index creation.
     <Toolbox>/Xtns/Video Index Creation...

     ffmpeg timecode logging for internal analysis of videofiles.

     logging is triggered at video index creation
     if gimprc parameter (video-libavformat-timecodelog "1")
     it creates a logfile with same name as the videoindex + ".timelog"

     The gimprc parameter video-libavformat-timecodelog
     defaults to "0" where no .timelog file is written.
     *.timelog files are useful for developers 
     to analyze and verify native timcode based
     seek operations. *.timelog files contain timecodes and stepsize differences
     for each frame of the analyzed video and CRITICAL warnings where
     variable or non-plausible timecodes were detected.


     * libgapvidapi/gap_vid_api_ffmpeg.c
     * gap/Makefile.am
     * gap/gap_video_index_creator.c          # new file

    (2007-03-17)
     new gimprc parameter video-libavformat-seek-gopsize 
     to control usage of native seek via libavformat.

     * libgapvidapi/gap_vid_api_ffmpeg.c
     * docs/reference/txt/gap_gimprc_params.txt

     ==> bugs:
     - for videos with fixed duration for all frames.
       positioning sometimes not exact.
       (differs by 1 sometimes after backwards positioning
        and after EOF situation)

        file: NUMs....mpg  
        player position: frame 221  shows frame Nr 220!

        probably Player BUG, because Log messages says that
        positioning to 220 is required !
        (positioning was done with slider, maybe a rounding error
        caused display of wrong number in the spinbutton ?)


        AVFORMAT: av_seek_frame retcode: 0 seek_pos_microsecs:810000 frame_pos:220
        [mpeg1video @ 0x84a589c]end mismatch left=4824 6EEA2F
        [mpeg1video @ 0x84a589c]concealing 1350 DC, 1350 AC, 1350 MV errors
        AVFORMAT: (0) debug read frame timecode: 810000 (target_timecode:821250, stepsize:3750 (3750))
        AVFORMAT: (1) debug read frame timecode: 813750 (target_timecode:821250, stepsize:3750 (3750))
        AVFORMAT: (2) debug read frame timecode: 817500 (target_timecode:821250, stepsize:3750 (3750))
        AVFORMAT: (3) debug read frame timecode: 821250 (target_timecode:821250, stepsize:3750 (3750))


     - sometimes crash 


     - how to detect videos with individual frame durations ?
       (without scanning the full videofile)
       allow operate with average frame duration ?

       videofile: /home/tmp_hof/TEST.MPG  (has individual frame durations!)


     TODO:
     write regression tests to verify positioning.
     (shall be configuable with llist of videofiles,
     and perform seek ops  with and without native seek!


     gap_vid_api_ffmpeg.c:764: warning: `img_convert' is deprecated 
      (declared at /home/hof/gimp_cvs/unstable/gap-ffmpeg/g   In file included from gap_vid_api.c:726:
     gap_vid_api_ffmpeg.c: In function `p_read_audio_packets':
     gap_vid_api_ffmpeg.c:2446: warning: `avcodec_decode_audio' is deprecated 
      (declared at /home/hof/gimp_cvs/unstable/gap-ffmpeg/gimp-gap-ffmpeg/extern_libs/ffmpeg/libavcodec/avcodec.h:2714)


     (2007-03-15)
     - attempt fixed bug for non-interactive call of plug_in_wr_curves
       (expects 4 paramsm but did check for at least 5)


     test with scrip-fu console:
     (plug-in-wr-curves 1 1 1 "/windows/vol1/testdata_gap_storyboard/test.curve") 

     Error: PDB call of gimp_curves_explicit failed status:0
     Error: PDB call of gimp_curves_explicit failed status:0
     Error: PDB call of gimp_curves_explicit failed status:0
     Error: PDB call of gimp_curves_explicit failed status:0


     * gap/gap_wr_color_curve.c

    (2007-03-14)
     use libavformat native seek for positioning videostream.
     use probe read to detect timecode offset of 1.st frame
     and stepsize for one frame.

     ==> still buggy, 
        - MPEG files sometimes deliver trash 
          (maybe keyframe detection does not work properly
          and seek takes us to P or B frame position ?

          .VOB file semmd to deliver clean frames.
        - tuning to deliver exact position required.
        - vex plugin (seems to use incorrect aspect ratio on 16:9 .VOB files
           1,42222)
        - seek after EOF results in endless loop.

     * libgapvidapi/gap_vid_api_ffmpeg.c


     (2007-03-14)
     fix for bug#417524 (frames to image for indexed frames)
     * gap/gap_range_ops.c

     (2007-03-11)
     libavformat, libavcodec NEW: libavutil

     * configure.in
     * extern_libs/Makefile.am
     * libgapvidapi/gap_vid_api_ffmpeg.c
     * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

     compile with recent ffmpeg OK, read test (using video extract) passed OK.

     (2007-03-06) Started upgrade to recent ffmpeg
      --------------------------------------------

     replaced ffmpeg tarball with ffmpeg-export-snapshot-2007.03.06.tar   
     made configure updates to allow compile with new ffmpeg

     - configure.in: handle #comments in configure_options_ffmpeg.txt files

     WARNING: this ffmpeg tarball came without liba52 !
     therefore no ac3 available (result: NO AUDIO support for DVD videos)

     * configure.in
     * extern_libs/ffmpeg.tar.gz   (now SVN snapshot-2007.03.06)
     * extern_libs/configure_options_ffmpeg.txt

     currently COMPILE ERRORs
     (update in gap sources still missing)

      gap_vid_api_ffmpeg.c: In function `p_wrapper_ffmpeg_seek_frame':
      gap_vid_api_ffmpeg.c:916: warning: implicit declaration of function `round'
      gap_vid_api_ffmpeg.c: In function `p_ff_open_input':
      gap_vid_api_ffmpeg.c:1710: warning: comparison between signed and unsigned
      gap_vid_api_ffmpeg.c:1712: warning: assignment from incompatible pointer type
      gap_vid_api_ffmpeg.c:1781: error: incompatible types in assignment
      gap_vid_api_ffmpeg.c:1794: error: structure has no member named `frame_rate'
      gap_vid_api_ffmpeg.c:1797: error: structure has no member named `frame_rate'
      gap_vid_api_ffmpeg.c:1797: error: structure has no member named `frame_rate_base'
      gap_vid_api_ffmpeg.c:1798: error: structure has no member named `frame_rate_base'
      gap_vid_api_ffmpeg.c:1802: error: structure has no member named `frame_rate_base'
      In file included from gap_vid_api.c:726:
      gap_vid_api_ffmpeg.c: In function `p_read_audio_packets':
      gap_vid_api_ffmpeg.c:2270: warning: `avcodec_decode_audio' is deprecated (declared at /home/hof/gimp_cvs/unstable/gap-ffmpeg/gimp-gap-ffmpeg-update-branch/extern_libs/ffmpeg/libavcodec/avcodec.h:2714)



     (2006-12-19)
     Storyboard FEATURE: support applying filtermacro on 
           processed video clips with varying values.

     Clip Properties dialog:

      - spinbutton to enter macro steps to define duration in frames
        (how long it takes to fade from master macro values
         to alternate macro values)
        Values > 1 enable filter apply with varying values.

      - label that indicates presence of the alternate macro file
        and wheter it is active (ON) or turned off by stepsize 1 (OFF)


        Alternate macro files are automatically detected via name convention
        via the keyword .VARYING (as suffix or before the extension)


          New
	  * gap_fmac_name.c [.h]        # newly created files
	  * gap_fmac_base.c [.h]        # newly created files
	  * gap_fmac_varying_main.c     # newly created file

          Changed:
          * docs/reference/txt/STORYBOARD_FILE_DOC.txt
	  * po/POTFILES.in

          * gap/Makefile.am
          * gap/gap_story_file.c
          * gap/gap_story_file.h
          * gap/gap_story_properties.c.txt
          * gap/gap_story_render_processor.c
          * gap/gap_story_render_types.h
          * gap/gap_story_syntax.c
          * gap/gap_filter_pdb.c [.h]
          * gap/gap_fmac_main.c

       (2006-12-09)
       Storyboard: added ClipTarget togglebutton
       For selecting the clip target (ON: storyboard, OFF cliplist)
       when creating a new clip via player feature "add selected range" as clip. 
       For assotiation the clip target toggle button uses the same icon
       as the corresponding button in the (integrated) playback window.

       * gap/gap_story_dialog.c
       * gap/gap_story_main.c [.h]

       (2006-12-03)
       Storyboard: speed up video thumbnail creation (minimize open/frame seek times)
       Testfile with 503 storyboard records of ty VID_PLAY_MOVIE
       after  optimize: 1 min 40sec
       before optimize: 1 min 27sec

       new storyboard dialog properties flag to "Force Aspect"
        gimprc parameter: (video-storyboard-force-aspect-playback "yes")
        ON:  force display of all clips to proportions defined in Storyboard properties.
        OFF: display clips at their native proportions

       * gap/gap_story_dialog.c
       * gap/gap_story_file.c [.h]
       * gap/gap_story_main.c [.h]

       * gap/gap_player_dialog.c
       * gap/gap_vex_main.c
       * docs/reference/txt/gap_gimprc_params.txt



       (2006-11-20)
       Storyboard: extend selection (SHIFT click) now respects the vtrack number.

       * gap/gap_story_dialog.c
       * gap/gap_story_file.c [.h]

       (2006-08-31)
	  - bugfix original tone track generation created pause
            instead of the original tone for clips with duration of one frame.
       * gap/gap_story_file.c

       (2006-08-24)
       - bugfix: videoindex was slow for videos with variable GOP size.
         (stepsize for ffmpeg is calculated via guess of the GOP,
         but index entries may dffer in step size depending if the
         video is encoded with constant or variable GOP size.
         the calculation of the first index to use works for constant
         stepsize, but requires adjusting the picked index
         (the already existing adjustment only checked if
         the frame position is too big, A further adjustment
         was added that checks if the picked index uses a frame number that
         is much too small and would cause too much full frame read).

       * libgapvidapi/gap_vid_api_vidindex.c
       * libgapvidapi/gap_vid_api_ffmpeg.c

       (2006-08-10)
       - storyboard editor show number of frames.

           *gap/gap_story_dialog.c [.h]

       (2006-07-16)
       - storyboard saving aspect used wrong record key word VID_MASTER_SIZE
       - parse storyboard attributes allow duration 0..n
         (the check for duration >= 1 is not ok, because the editor
         allows creating 0 duration)


2008-02-14  Sven Neumann  <sven@gimp.org>

	Merged from gap-2-4:

	* gap/gap_pview_da.c (gap_pview_set_size): added a sanity check
	for the preview size.

	* gap/gap_mov_dialog.c (mov_path_prevw_create)
	(mov_pview_size_allocate_callback)
	* gap/gap_player_dialog.c (p_update_pviewsize): make sure that the
	preview size doesn't become zero. Fixes bug #516443.

2008-01-29  Kevin Cozens  <kcozens@cvs.gnome.org>

	* gap/gap-dup-continue.scm: De-tabified.

	* gap/sel-to-anim-img.scm: Fixed bad syntax in let block. Moved some
	set! calls in to let block. De-tabified.

2008-01-29  Sven Neumann  <sven@gimp.org>

	Merged from gap-2-4:

	* configure.in: use the same definition for LOCALEDIR as what the
	Makefile in the po directory uses as the install location for the
	message catalogs.

2007-10-14  Yannig Marchegay  <yannig@marchegay.org>

	* configure.in: Added 'oc' to ALL_LINGUAS.

2007-10-09  Sven Neumann  <sven@gimp.org>

	Merged from gap-2-2:

	* gap/gap_wr_color_curve.c: fixed check for the number of parameters
	(bug #466176).

2007-08-15  Adam Weinberger  <adamw@gnome.org>

	* configure.in: Re-add en_CA to ALL_LINGUAS.

2007-08-04  Sven Neumann  <sven@gimp.org>

	* gap/sel-to-anim-img.scm: applied patch from Saul Goode to make
	the script work with Tiny-Fu.

2007-08-03  Sven Neumann  <sven@gimp.org>

	* gap/gap_wr_color_huesat.c
	* gap/gap_wr_color_levels.c
	* gap/gap_wr_color_curve.c: added missing calls to
	gimp_plugin_domain_register().

2007-08-03  Sven Neumann  <sven@gimp.org>

	* gap/gap_arr_dialog.c
	* gap/gap_dbbrowser_utils.c
	* gap/gap_fmac_main.c
	* gap/gap_mov_dialog.c
	* gap/gap_onion_dialog.c
	* gap/gap_player_dialog.c
	* gap/gap_resi_dialog.c: show help buttons conditionally.
	Fixes bug #463074.

2007-08-03  Sven Neumann  <sven@gimp.org>

	* gap/gap_player_dialog.c
	* gap/gap_story_properties.c
	* gap/gap_story_dialog.c: applied patch from Thierry Moisan that
	fixes typos in user-visible strings (bug #352351).

2007-07-31  Ignacio Casal Quinteiro  <nacho.resa@gmail.com>

	* configure.in: Added 'gl' to ALL_LINGUAS.

2007-07-30  Sven Neumann  <sven@gimp.org>

	* gap/gap_mod_layer_dialog.c: duplicate the strings attached to
	menu items. Fixes bug #427487.

2007-07-29  Sven Neumann  <sven@gimp.org>

	* gap/gap_lib.c: applied patch from Wolfgang Hofer to fix bug #452080.

2007-07-29  Sven Neumann  <sven@gimp.org>

	* gap/gap_bluebox.c
	* gap/gap_filter_pdb.c
	* gap/gap_layer_copy.c
	* gap/gap_lib.c
	* gap/gap_morph_dialog.c
	* gap/gap_morph_exec.c
	* gap/gap_mov_render.c
	* gap/gap_pview_da.c
	* libgapvidapi/gap_vid_api.c
	* vid_enc_avi/gap_enc_avi_main.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c: applied patch from Saul Goode:
	Release drawables using gimp_drawable_detach(). Fixes bug #451350.

2006-09-12  Pema Geyleg  <pgeyleg@gmail.com>

	* configure.in: Added dz in ALL_LINGUAS

2006-08-03  Jakub Friedl <jfriedl@suse.cz>

	* gap/gap_story_att_trans_dlg.c: missing space in UI string

2006-07-17  Jakub Friedl <jfriedl@suse.cz>

	* gap/gap_morph_dialog.c: Fixed English spelling in UI
	translatable strings (koordinate->coordinate)

2006-07-12  Wolfgang Hofer <hof@gimp.org>
	- flip transformation support is now also available for mask definitions.
        - attempts to open an binary file for storyboard parsing
          now limits the erros printed to standard out to printable
          characters and stops logging to stdout if too much unprintables are detected. 
          (in case of accidently specified binary files the log output 
          of the parser can take much time and the full content is not from any interest)
        
	(2006-07-03)
	refactoring. (mask_elem is now part of stb_elem, mask definitions
        are represented as track number 0 at editing (not in the render processor)
         *gap/gap_story_file.c
         *gap/gap_story_file.h
         *gap/gap_story_main.h
         *gap/gap_story_properties.c
         *gap/gap_story_render_processor.c
         *gap/gap_story_render_types.h

	(2006-06-30)
	player support to playback composite video
        
        added playback button to storyboard transition attributes dialog
        to visualize the transition effect.
        This button triggers playback of composite video resticted
        to the relevant track and range concerning the transition effect.
        
         *gap/gap_story_att_trans_dlg.c 
         *gap/gap_story_dialog.c [.h]
         *gap/gap_story_file.c [.h]
       
        
	(2006-06-28)
        refactoring: player_dialog spliited p_display_frame into
        several subroutines.
        
        refactoring: storyboard rendering is required
        for the player (to provide rendering of composite video)
        therefore moved functionality to new gap/story_*  modules
        and make them part of libgapstory.a
        to prepare common use in player, storyboard dialog and encoders.
        
        libgapstory.a now contains all modules of libgimpgap.a
        (libgapstory uses those modules and each program had to include
        both libs in correct order before this change)
                

        * gap/Makefile.am
        * vid_common/Makefile.am
        * vid_enc_avi/Makefile.am
        * vid_enc_ffmpeg/Makefile.am
        * vid_enc_single/Makefile.am
        * gap/gap_libgapstory.h
        * gap/gap_lib_common_defs.h
        * gap/gap_story_render_audio.c [.h]  # NEW FILES
        * gap/gap_story_render_processor.c [.h]  # NEW FILES
        * gap/gap_story_render_types.h           # NEW FILES
        * gap/gap_story_sox.c [.h]               # NEW FILES
        * gap/gap_player_dialog.c [.h]
        * libgapvidutil/gap_gvetypes.h
        * libgapvidutil/gap_gve_sox.c [.h]
        * vid_common/gap_cme_gui.c
        

	(2006-06-24)
        - storyboard dialog shows correct framenumbers respecting overlapping.
	- player now skips overlapping parts when storboard is played.
        
        * gap/gap_story_*.c [.h]
        * gap/gap_player_main.c [.h]
        * gap/gap_player_dialog.c [.h]
        
	(2006-06-19)
	- rendering support of built in simple flip transformations in the pview
	  widget, and in all storyboard dialogs (including the player)
        - bugfix: edit storyboard master properties must set unsaved changes flag.

        * gap/Makefile.am
        * gap/gap_lib_common_defs.h       # NEW file created
        * gap/gap_lib.h
        * gap/gap_layer_copy.c [.h]
        * gap/gap_player_main.c [.h]
        * gap/gap_player_cache.c [.h]
        * gap/gap_player_dialog.c [.h]
        * gap/gap_pview_da.c.[.h]
        * gap/gap_story_att_trans_dlg.c
        * gap/gap_story_dialog.c
        * gap/gap_story_properties.c
        * gap/gap_vex_dialog.c
        
        * libgapvidutil/gap_gve_story.c
       

	(2006-06-18)
	- Syntax definition, parsing, and saving for the new storyboard features
           VID_* clips support built in transformations flip hor/ver/both,
            and are able to refere to layer mask definitions.
           MASK_* definition records to describe layer mask frames
           VID_OVERLAP  (is a new part of transition attribute,
                         allows overlap frames within the same track.)

        - Storyboard processor implementation of overlap and flip features.
        - Storyboard clip properties dialog: added radio buttons for
          built in transformations (flip hor,ver and rotate by 180 degree)
        - Storyboard clip properties dialog: added radio buttons for
          built in transformations (flip hor,ver and rotate by 180 degree)
        - Storyboard transition attributes dialog: added spinbutton
          for overlapping number of frames within the same track,
          and extended rendering of the preview by adding a prefetch
          layer to the preview images in case overlapping is active.
          
        
        * libgapvidutil/gap_gve_story.c [.h]
        * gap/gap_story_properties.c
        * gap/gap_story_main.h
        * gap/gap_story_att_trans_dlg.c
        
	(2006-06-14)
	- added text docfiles to EXTRA_DIST makefile target
             plug-in-gap-reverse.txt
             plug-in-gap-storyboard-attr-prop.txt
             
	- merged in changes from 2.2.1 release (mainline)
          to my local new-feature-branch
                    
        * docs/reference/txt/Makefile.am
          
	(2006-06-03)
	Player layout changes:
         - configure option to hide/show go button array and position scale
         - use icons for the buttons to have more space for the frame preview
           moved buttons right next the corresponding spinbuttons
           (for shorter mouse move distances)
         - shorter texts for checkbuttons
         - time position (mm:sec:msec)
           is shown next to the position scale widget in the same row
         - use col/row spacing for layout of the player control widget table
           (instead of hseperators)

	Storyboard layout changes:
        - Stock Buttons reduced in width (now showing only the icon)
          this allows showing the full set both for the cliplist and the storyboard.
        - progress bar is displayed right next to the stock buttons
          (no more need to waste space for an extra layout row)
        - use persitent Global storyboard settings via
          automatically query/save settings as gimprc options.

        - storyboard file format extension:
          new (optional) record keyword: VID_MASTER_FRAME_ASPECT
          implemented support for video frame aspect in the storyboard
          dialog.
          
          TODO: use the aspect in the encoder(s) too 
          (if video format is capable to handle aspect ratio)
          
          currently the aspect is available in the ffmpeg specific encoder
          but only via ffmpeg parameter settings and no connection
          to get the aspect from the storyboard.          
          

	* images/Makefile.am
	* images/gap-range-end.png
	* images/gap-range-start.png
	* images/gap-set-range-end.png
	* images/gap-set-range-start.png
	* images/gap-speed.png
        
        * gap/gap_stock.c
        * gap/gap_stock.h
        * gap/gap_story_dialog.c
        * gap/gap_story_syntax.h 
        * gap/gap_story_syntax.c
        * gap/gap_story_file.c 
        * gap/gap_story_file.h 
        
        * docs/reference/txt/STORYBOARD_FILE_DOC.txt
	* docs/reference/txt/gap_gimprc_params.txt  
	* NEWS 

        
	(2006-05-31)
        - basic implementation of player cache feature.
          The player does now support a frame cache for any type of frames.
          frames are cached at current preview size of the player.
          
          (caching of frames at original size read from videofiles in the video API
           is still supported too)
           
          if the same sequence is played more than one time (loop mode)
          it is now possible to do fast playback in best possible
          display quality. (without using thumbnails).

	* gap/Makefile.am
	* gap/gap_player_dialog.c 
	* gap/gap_player_main.c 
	* gap/gap_player_main.h  

2006-06-09  Sven Neumann  <sven@gimp.org>

	* Made 2.2.1 release.

2006-06-09  Sven Neumann  <sven@gimp.org>

	* configure.in: builds fine with gimp 2.3.9.

2006-06-07  Wolfgang Hofer <hof@gimp.org>
	bugfix: no more check for int result of the already
        removed gethostname call. 

        * gap/gap_story_dialog.c
        
2006-06-07  Sven Neumann  <sven@gimp.org>

	* vid_enc_avi/avilib.c (AVI_open_input_file): added missing
	parameter to g_open(). Spotted by Michael Schumacher.

2006-06-07  Sven Neumann  <sven@gimp.org>

	* gap/gap_player_dialog.c: use g_open().

	* vid_enc_avi/avilib.c: use g_open(); define flags used with open()
	in case they are undefined (bug #344071).

2006-06-06  Sven Neumann  <sven@gimp.org>

	* configure.in: applied patch from Michael Schumacher to finally
	fix linking problems with MinGW (bug #324854).

2006-06-02  Alexander Shopov  <ash@contact.bg>

	* configure.in (ALL_LINGUAS): Added "bg" (Bulgarian)

2006-05-31  Wolfgang Hofer <hof@gimp.org>
	- bugfix: player framenr position hscale sometimes showed a non
	  actual framenumber value different from the framenr spinbutton
          (both using the same adjstment).
          
	* gap/gap_player_dialog.c
	* gap/gap_player_main.c 
	* gap/gap_player_main.h
        
2006-05-31  Sven Neumann  <sven@gimp.org>

	* gap/gap_lib.c: include "gap_image.h" for gap_image_is_alive().

2006-05-31  Sven Neumann  <sven@gimp.org>

	* configure.in
	* README: added check for glib >= 2.8.0.

2006-05-30  Wolfgang Hofer <hof@gimp.org>
	- use glib file utility wrappers for posix functions
          (fopen, chmod, mkdir, rename, remove)
          
	* gap/gap_arr_dialog.c
	* gap/gap_audio_wav.c
	* gap/gap_base_ops.c
	* gap/gap_decode_mplayer.c
	* gap/gap_decode_xanim.c
	* gap/gap_file_util.c
	* gap/gap_filter_codegen.c
	* gap/gap_fmac_main.c
	* gap/gap_lib.c
	* gap/gap_morph_exec.c
	* gap/gap_mov_exec.c
	* gap/gap_mpege.c
	* gap/gap_story_file.c
	* gap/gap_thumbnail.c
	* gap/gap_vex_exec.c
	* gap/gap_vin.c
	* gap/gap_wr_color_curve.c
	* gap/gimplastvaldesc.c
        * libgapvidapi/gap_vid_api.c
        * libgapvidapi/gap_vid_api_mpeg3.c
        * libgapvidapi/gap_vid_api_mpeg3toc.c
        * libgapvidapi/gap_vid_api_vidindex.c
        * libgapvidutil/gap_gve_sox.c
        * libgapvidutil/gap_gve_story.c
        * libgapvidutil/gap_gve_xvid.c
        * vid_common/gap_cme_callbacks.c
        * vid_common/gap_cme_main.c
        * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

2006-05-30  Sven Neumann  <sven@gimp.org>

	* libgapvidapi/gap_vid_api_mpeg3toc.c
	* libgapvidapi/gap_vid_api_util.c
	* libgapvidutil/gap_gve_xvid.c: include <glib/gstdio.h>.

	* vid_enc_avi/gap_enc_avi_gui.c: use gtk_widget_set_size_request()
	instead of the deprecated gtk_widget_set_usize().

2006-05-30  Sven Neumann  <sven@gimp.org>

	* configure.in: use DISABLE_DEPRECATED for glib >= 2.11, pango >= 1.13
	and gimp >= 2.3.8.

	* gap/gap_audio_wav.c
	* gap/gap_file_util.c
	* gap/gap_lib.c
	* gap/gap_navigator_dialog.c
	* gap/gap_story_properties.c
	* gap/gimplastvaldesc.c: include <glib/gstdio.h> instead of <stdio.h>.

2006-05-29  Wolfgang Hofer <hof@gimp.org>
	- Fix for ffmpeg libnames on MinGW
         ( avformat.lib, avcodec.lib )
          Should fix bug #324854.
        - Replaced gethostname and stat
           by OS-independent glib variants
           g_get_host_name , g_stat
           
          (should fix #342941 without the need to link
          with winsock lib)
        - fixed typos (#342973)
        - 
        
	* configure.in: $LIBPREF
        * gap/gap_story_dialog.c
        
        * gap/gap_audio_wav.c
        * gap/gap_bluebox.c
        * gap/gap_file_util.c [.h]
        * gap/gap_lib.c
        * gap/gap_navigator_dialog.c
        * gap/gap_pview_da.c [.h]
        * gap/gimplastvaldesc.c
        * libgapvidapi/gap_vid_api_mpeg3toc.c
        * libgapvidapi/gap_vid_api_util.c
        * libgapvidutil/gap_gve_xvid.c
        * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
        
        
2006-05-22  Sven Neumann  <sven@gimp.org>

	* configure.in: added missing call of AC_CANONICAL_HOST.

2006-05-19  Sven Neumann  <sven@gimp.org>

	* configure.in: added missing check for target architecture.
	Should fix bug #324854.

2006-05-18  Wolfgang Hofer <hof@gimp.org>
         fixed more than 40 typos (#342108)
 
         * typo fixes in many files..

2006-05-16  Clytie Siddall <clytie@riverland.net.au>

	* configure.in	Added vi in ALL_LINGUAS line.
	
2006-05-14  Wolfgang Hofer <hof@gimp.org>
	configure per default --disable-unix-frontends  on WIN32 systems,
        default on UNIX systems is --enable-unix-frontends.

	* configure.in

2006-05-10  Wolfgang Hofer <hof@gimp.org>
	- updated PDB regstration to gimp-2.2 PDB API,
          where the menu path is specified via searate call to
          gimp_plugin_menu_register.
          
          (commented out gimp_plugin_menu_branch_register calls
          to be compatible with the stable gimp-2.2.x versions)

	* gap/gap_bluebox_main.c
	* gap/gap_filter_main.c
	* gap/gap_fmac_main.c
	* gap/gap_frontends_main.c
	* gap/gap_main.c
	* gap/gap_morph_main.c
	* gap/gap_name2layer_main.c
	* gap/gap_navigator_dialog.c
	* gap/gap_onion_main.c
	* gap/gap_player_main.c
	* gap/gap_story_main.c
	* gap/gap_vex_main.c
	* gap/gap_wr_color_curve.c
	* gap/gap_wr_color_huesat.c
	* gap/gap_wr_color_levels.c
	* gap/gap_wr_opacity.c
	* gap/gap_wr_trans.c
	* vid_common/gap_cme_main.c

2006-05-01  Wolfgang Hofer <hof@gimp.org>
	fixes to make gimp-gap usable with the more restrictive
        PDB checks that were introduced with the gimp-2.2.8 release.
       
        the fix assumes that gimp core deletes unused image after 
        reconnecting the display.
        The gimp-gap code no longer attempts to delete the old image if it has
        become invalid.
        
        using any valid layer id instead of -1 when calling 
        gap procedures via PDB that have unused drawable parameters.
        (to satisfy the more restrictive PDB parameter checks of gimp-2.3.8)
        This shall work in most cases and be compatible to gimp-2.2.x.
        (it will fail for frame images that have no layer at all)

        partly fixes bug #339840,
        in some situations there are still error messages
        caused by the restrictive checks.
        
        One example is using a hot-key for fast stepping from frame to next frame,
        that results in errors:
             PDB calling error for procedure 'gimp_image_get_filename':
             Argument 'image' (#1, type GimpImageID) out of bounds (validation changed '167' to '-1')


             PDB calling error for procedure 'gimp-image-set-filename':
             Argument 'image' (#1, type GimpImageID) out of bounds (validation changed '167' to '-1')


             PDB calling error for procedure 'gimp-image-get-active-layer':
             Argument 'image' (#1, type GimpImageID) out of bounds (validation changed '167' to '-1')
             
         have not found yet whats wrong, because slow stepping via hot key works OK ?
         GAP now makes additional checks for valid images in its main program, and rejects
         both calls on invalid images and locked images.
         (if the image_id is not found in the list delivered by gimp_image_list()
          gap considers this as invalid image.
         )
         Probably it has to do with multiple concurrent prallel calls,
         and the gimp_image_list is not always up to date in such situations.         
         

	- VCR Navigator dialog: support scroll event. (mouse wheel)
        - PDB API for plug_in_gap_layers_run_animfilter was extended
            (added the missing varying_flag.
            useful for my private half automated testsuite) 
        - use GAP_VERSION_WITH_DATE (generated by configure.in) as config value
          for gap plug-ins when registrating to the PDB.
          (this replaces all local PLUG_IN_VERSION definitions)
        
        * NEWS
        * README
        * configure.in
        * gap/TESTPROT_iter_ALT
        * gap/gap_filter.h
        * gap/gap_filter_foreach.c
        * gap/gap_filter_main.c
        * gap/gap_frontends_main.c
        * gap/gap_image.c  [.h]
        * gap/gap_lib.c
        * gap/gap_lock.c
        * gap/gap_main.c
        * gap/gap_morph_main.c
        * gap/gap_mov_dialog.c
        * gap/gap_name2layer_main.c
        * gap/gap_navigator_dialog.c
        * gap/gap_onion_main.c
        * gap/gap_onion_worker.c
        * gap/gap_player_dialog.c
        * gap/gap_player_main.c
        * gap/gap_story_dialog.c
        * gap/gap_vex_main.c
        * gap/gap_wr_color_curve.c
        * gap/gap_wr_color_huesat.c
        * gap/gap_wr_color_levels.c
        * gap/gap_wr_opacity.c
        * gap/gap_wr_trans.c
        * gap/sel-to-anim-img.scm
        * libgapvidapi/gap_vid_api_gimp.c
        * libgapvidutil/gap_gve_misc_util.c
        * vid_common/gap_cme_main.c
        * vid_enc_avi/gap_enc_avi_main.c
        * vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
        * vid_enc_single/gap_enc_singleframes_main.c
        
	added gap/gap_story_att_trans_dlg.c to POTFILES.in
        because it contains translation relevant message texts.
        
	* po/POTFILES.in

2006-04-18  Wolfgang Hofer <hof@gimp.org>
        applied patch provided with #338556

        * gap/gap_mod_layer.c [.h]
        * gap/gap_mod_layer_dialog.c
        * docs/reference/txt/plug-in-gap-modify.txt

	2006-04-14  Wolfgang Hofer <hof@gimp.org>
        applied patch provided with #337441
        
	* gap/gap_base_ops.c [.h]
	* gap/gap_main.c
        
        * docs/reference/txt/plug-in-gap-reverse.txt              # new file
        * docs/reference/txt/plug-in-gap-shift.txt
        * docs/reference/txt/plug-in-gap-storyboard-attr-prop.txt # new file
        * docs/reference/txt/INTRODUCTION.txt
         
	2006-04-12  Wolfgang Hofer <hof@gimp.org>
	bugfix #337587: check version in the autogen.sh script
        (using separate checks for major, minor micro version)
        
        bugfix: on videoindex creation.
        - video indexes created in normal time were droped after switch to
          daylight saving time even if the videofile was not modified
          since videoindex creation.
        - dialogs for video index creation show wrong filename
        for the index. The video track number that is part of the
        vidoindex filename must use the internal
        track number that starts at 0, but dialogs show the external
        representation starting at 1.
        (keeping the suffix   .0.libavformat.gvaidx to be compatible
        with already existing video indexes)
        
	* autogen.sh
        * libgapvidapi/gap_vid_api_vidindex.c
        
	2006-04-08  Wolfgang Hofer <hof@gimp.org>
        - bugfix gap_layer_clear_to_color 
          , restore original BG color)
        - replaced private implementation p_layer_resize_to_imagesize
          by gimp_layer_resize_to_image_size that does the same.
        - use color range 0.0 to 1.0 for internal calculations in storyboard processing.
	- storyboard dialog: added graphic views of the attributes
          at start and end frame in the treansition attribute properties dialog.
          
        * gap/gap_pview_da.c [.h]
        * gap/gap_lib.c [.h]
        * gap/gap_layer_copy.c [.h]
        * gap/gap_vex_exec.c
        * libgapvidutil/gap_gve_story.c [.h]
	* gap/gap_story_att_trans_dlg.c [.h]

	2006-04-06  Wolfgang Hofer <hof@gimp.org>
	- storyboard processing: VID_FIT_SIZE record
        is internally handled as transition attribute.
        (now we have only ony type of attribute,
        the attribute dialog support for fit_size is not implemented yet.)
                
	* gap/gap_story_dialog.c [.h]
	* gap/gap_story_file.c [.h]
	* gap/gap_story_main.h
	* libgapvidutil/gap_gve_story.c
        
	2006-04-02  Wolfgang Hofer <hof@gimp.org>
	- extract video range dialog: added labels to display
          From and To Frames as time code mm:ss:ms
        - added storyboard dialog icon for transition attributes

	* gap/gap_vex_dialog.c
        * gap/gap_vex_main.h
        * images/gap-story-icon-transition-attr.png  # new icon
        * images/Makefile.am


	2006-03-31  Wolfgang Hofer <hof@gimp.org>
	- bugfix: storyboard processing changed the calculation of
	  layer offsets. (the old code had bugs, and assumed that 
	  gimp_edit_paste
	  would center the pasted layer within the destination layer
	  which is not true with gimp-2.2.10)
	  The new calculation includes centering and scrolling
	  according to the MOVE_Y/MOVE_Y attribute settings of the 
	  storyboard file and only uses this self calculated offest.
	  
	- Storyboard dialog support to edit transition attributes
	(MOVE X/Y ZOOM X/Y and OPACITY) of the storyboard file.

        Added menu to create a transition attribute (as last element)
	Right mouse button on the transition attribute's thumbnail
	also opens the new transition attributes properties dialog.
	
	* gap/gap_story_att_trans_dlg.c [.h]  # NEW files
	* gap/Makefile.am
	* gap/gap_story_file.c [h]
	* gap_story_dialog.c
	* gap/gap_story_main.h
	* gap/gap_story_properties.c
	* docs/reference/txt/STORYBOARD_FILE_DOC.txt
	* libgapvidutil/gap_gve_story.c
	* NEWS
	
	2006-03-28  Wolfgang Hofer <hof@gimp.org>
	- internal changes of the storyboard file handling and processing
	(attributes MOVE X/Y ZOOM X/Y and OPACITY are now handled
	as one common TRANSITION attribute,
	for the planed basic GUI support of those transformations)
	
	* gap/gap_story_file.c [h]
	* libgapvidutil/gap_gve_story.c
	* gap/gap_player_dialog.c
	* gap/gap_story_dialog.c
	
	2006-03-19  Wolfgang Hofer <hof@gimp.org>
	player dialog: support step/backstep frame via scroll event.
	(mouse wheel)
	storyboard dialog: support scroll event.
	
	* gap_player_dialog.c
	* gap_story_dialog.c

2006-04-17  Kjartan Maraas  <kmaraas@gnome.org>

	* configure.in: Remove obsolete entry for no_NO.
	* po/no.po: And the translation.

2006-03-11  Wolfgang Hofer <hof@gimp.org>
	- bugfix for selection handling via modify frames (#333978)
	
	* gap/gap_mod_layer.c [.h]
	* gap/gap_mod_layer_dialog.c
	
2006-03-02  Wolfgang Hofer <hof@gimp.org>
	- added more functions to modify frames
	  (based on the attachments of 
	  feature requests #332689 #332959)
	  plus function to apply filter on layermask.
	- frames convert: changed default extension from ".tif" to ".jpg"
	
	* gap/gap_mod_layer.c [.h]
	* gap/gap_mod_layer_dialog.c
	* gap/gap_main.c
	* gap/gap_range_ops.c
	* docs/reference/txt/plug-in-gap-modify.txt
	* NEWS

2006-02-28  Wolfgang Hofer <hof@gimp.org>
	- could not reproduce bug #332689 that causes crash
	  on duplicate frame operations, but made attempt to fix.
	  The stacktrace applied to that bug points to a problem
	  related to g_free for the thumbnail.

	   now using g_object_unref instead of g_free to free up
	   GimpThumbnail objects.
	   
	* gap/gap_story_file.c [.h]
	   
	   
2006-02-10  Wolfgang Hofer <hof@gimp.org>
	- storyboard support to act as drag and drop destination for
	  image files and video clips
	  application internal copy and move of clips is also supported.
	- render default icon dependent to type of the clip.
	  (use png images for the default icons)

	* gap/gap_story_properties.c
	* gap/gap_story_file.c [.h]
	* gap/gap_story_dialog.c
	* gap/gap_pview_da.c [.h]
	* gap/gap_story_main.h
	* NEWS
	* docs/reference/txt/plug-in-gap-storyboard-edit.txt
	
	* images/Makefile.am
        * images/gap-story-icon-movie.png
        * images/gap-story-icon-frames.png
        * images/gap-story-icon-animimage.png
        * images/gap-story-icon-image.png
        * images/gap-story-icon-color.png
        * images/gap-story-icon-default.png
	  
2006-02-05  Wolfgang Hofer <hof@gimp.org>
	- bugfix: AVI RAW encoding did not work 
	  (used XVID encoding but declared as "RAW " in the AVI file)
	  or delivered:
	  ERROR: GAP AVI encoder CODEC RAW delivered empty buffer at frame
	  (in case when compiled without XVID support)
	  
	  added checkbutton for vertical flip 
	  (player like WinDVD wants raw AVI vflipped,
	   gmplayer on linux want same order of rows than gimp)
	  
	  * vid_enc_avi/gap_enc_avi_main.c [.h]
	  * vid_enc_avi/gap_enc_avi_gui.c [.h]
	  
2006-02-04  Wolfgang Hofer <hof@gimp.org>
        - bugfix: in procedure on_vid_preview_size_allocate
	  (dont access the gpp->ainfo_ptr befor the == NULL check)
	  
	  * gap/gap_player_dialog.c
	  
	- attempt to fix #326201 (MinGW link problem with ffmpeg.)
	  (not yet tested with MinGW, i have no win development environment)

	  * configure.in
	
	- fixed typos reported by Fabrizzio Mellerti 
	 
          * gap/gap_mov_dialog.c
          * gap/gap_navigator_dialog.c
          * gap/gap_vex_dialog.c
          * vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c

2005-12-03  Wolfgang Hofer <hof@gimp.org>

        gap file util must use the binary file type open mode
	(consequent usage of fopen(file, "rb");)
        
	* gap/gap_file_util.c [h]

2005-11-20  Wolfgang Hofer <hof@gimp.org>
	fixed bug when building with libmpeg3.
	AC_SUBST(GAP_PTHREAD_LIB) required due to deferred expansion
	introduced with patch for bug #321348.
	
	* configure.in: # added AC_SUBST(GAP_PTHREAD_LIB)
	
2005-11-15  Sven Neumann  <sven@gimp.org>

	* configure.in: bumped version to 2.2.1.

2005-11-15  Sven Neumann  <sven@gimp.org>

	* configure.in
	* gap/Makefile.am
	* libgapvidutil/Makefile.am
	* vid_common/Makefile.am
	* vid_enc_avi/Makefile.am
	* vid_enc_ffmpeg/Makefile.am
	* vid_enc_single/Makefile.am: applied patch that fixes the build
	for srcdir != builddir (bug #321348).

2005-11-15  Sven Neumann  <sven@gimp.org>

	* gap/Makefile.am
	* libwavplayclient/client.c
	* libwavplayclient/msg.c
	* libwavplayclient/wpc_msg.c
	* vid_common/Makefile.am
	* vid_enc_avi/Makefile.am
	* vid_enc_ffmpeg/Makefile.am
	* vid_enc_single/Makefile.am: aplied patch that fixes build issues
	on Cygwin (bug #321347).

2005-11-01  Wolfgang Hofer <hof@gimp.org>

	- bugfix: matching end of string did not work for stringlength
	equal to pattern length.

        changes for UTF8 support (bugzilla #319710)
	- added utf8 support for simple gap layername matching
	and frame number substitution in layernames.
	now checks for utf8 compliance using g_utf8_validate
	and take care of multibyte characters when
	iterating layername or pattern strings.
	- active layer tracing: support utf8 encoded layernames
	(gap_lib.c p_set_active_layer_by_name)

	* gap/gap_match.c
	* gap/gap_lib.c

2005-10-28  Sven Neumann  <sven@gimp.org>

	* Made 2.2.0 release.

2005-10-28  Sven Neumann  <sven@gimp.org>

	* configure.in: pass $CC to the ffmpeg configure script, check for
	native Win32.

	* gap/Makefile.am: another try at getting the link order right.
	Pass -mwindows to the linker on Win32.

2005-10-26  Wolfgang Hofer <hof@gimp.org>

	- added GimpProgressBar to the VCR Navigator dialog
	  to display progress in this dialog rather than
	  in the invokining image. (bug # 135185)
	  
	- bugfix: player stand alone mode without progress_bar
	  when have no progress_bar must init gpp->progress_bar
	  with NULL
	  
	  fixes warnings to stdout:
	  (gap_player_dialog:17992): GLib-GObject-WARNING **: invalid unclassed pointer in cast to `GtkProgressBar'
          (gap_player_dialog:17992): Gtk-CRITICAL **: gtk_progress_bar_set_text: assertion `GTK_IS_PROGRESS_BAR (pbar)' failed

	- bugfix: player click on go-button printed critical warning
	  (only if click results in loading a frame into the invoking image)
	
	  (gap_player_dialog:19725): GLib-GObject-CRITICAL **: g_object_get_data: assertion `G_IS_OBJECT (object)' failed
	
	* gap/gap_navigator_dialog.c
	* gap/gap_player_dialog.c

2005-10-25  Sven Neumann  <sven@gimp.org>

	* gap/gap_arr_dialog.c (combo_create_value): use g_object_new() to
	create an empty combobox to avoid compiler warnings with gimp-2.3.

2005-10-25  Sven Neumann  <sven@gimp.org>

	* gap/gap_lib.c
	* gap/gap_match.c: use g_ascii_toupper() instead of toupper().

2005-10-23  Wolfgang Hofer <hof@gimp.org>
	- bugfix typo in messages (#318856)
	
	* gap/gap_story_file.c 
	* vid_common/gap_cme_gui.c

2005-10-08  Wolfgang Hofer <hof@gimp.org>

	- player: do not always print the framerange to stdout
	now restricted to explicite request via clicking From/To Frame buttons
	when the player is NOT embedded into storyboard dialog.

	- bugfix for color curves wrapper dialog.
	fixed init size of entry widget for curves file.
	(after porting to gtk_widget_set_size_request
	the height of 0 resulted in 1 pixel height
	that made the entry unusable)
	
	- bugfix: dont call gtk_widget_set_size_request wit -2 as height value
	(fixes warnings Gtk-CRITICAL **: gtk_widget_set_size_request: assertion `height >= -1' failed)
	
	- disable some debug output to stdout
	- Storyboard dialog: clip properties uses previous filename
	  when th dialog is creating a new clip.
	  (fixes Gtk-CRITICAL **: gtk_file_selection_set_filename: assertion `filename != NULL' failed
	  warning)
	- repeated filter all layers test with gimp-2.2.8 and gtk+-2.6.7
	
	* gap/gap_wr_color_curve.c
	* gap/gap_vex_dialog.c
	* vid_common/gap_cme_gui.c
	* gap/gap_story_dialog.c
	* gap/gap_story_properties.c
	* gap/gap_player_dialog.c
	* gap/TESTPROT_iter_ALT
	
2005-10-07  Wolfgang Hofer <hof@gimp.org>

	use GThread instead of pthread (fixes bug #318045)
	Note: pthread is still required for the libmpeg3.
	The configure.in script now checks for pthread library
	and disables libmpeg3 if pthread is not available.
	
	The new configure option 
	   --with-preinstalled-libmpeg3incdir=/usr/local/include
	   --with-preinstalled-libmpeg3=/usr/local/lib/libmpeg3.a
	allows to build GIMP-GAP with already installed libmpeg3
	
	for those who use newer gcc (and cannot compile libmpeg3 that requires
	older gcc 3.3, but already have libmpeg3-1.5.4 installed)
	.. Carol reported such a situation ...
	
	But those options work WITHOUT reliable checks. 
	(I failed once again to to write clean library checks for that beast,
	that is the reason why it was added as sourcecode, but i did not
	know about the compile problems with newer gcc 4.x versions,
	and i dont want to drop libmpeg3 because it can parse DVD typical .ifo
	files and supports compressed frame access
	that is required for GIMP-GAP's lossless mpeg cut feature ...)
	
	Specify those options on your own risk,
	wrong libmpeg3 versions may build, but crash at runtime...

	* configure.in
	* libgapvidapi/gap_vid_api.h
	* libgapvidapi/gap_vid_api.c
	* libgapvidapi/gap_vid_api_gimp.c
	* libgapvidutil/gap_gvetypes.h
	* vid_common/Makefile.am
	* vid_common/gap_cme_callbacks.c
	* vid_common/gap_cme_main.c
	* vid_common/gap_cme_gui.c
	* vid_common/gap_cme_gui.h


2005-10-05  Sven Neumann  <sven@gimp.org>

	* vid_common/gap_cme_gui.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c: undeprecated.

2005-10-05  Sven Neumann  <sven@gimp.org>

	* gap/Makefile.am (*_LDADD): reordered libraries.

2005-10-05  Sven Neumann  <sven@gimp.org>

	* gap/gap_file_util.c (gap_file_make_abspath_filename): fixed
	compilation on G_OS_WIN32; include <string.h>.

2005-10-05  Sven Neumann  <sven@gimp.org>

	* gap/gap_dbbrowser_utils.c
	* gap/gap_fmac_main.c
	* gap/gap_morph_dialog.c
	* gap/gap_navigator_dialog.c
	* gap/gap_resi_dialog.c
	* gap/gap_story_dialog.c
	* gap/gap_story_properties.c
	* gap/gap_vex_dialog.c
	* gap/gap_wr_color_curve.c
	* gap/gap_wr_color_huesat.c
	* gap/gap_wr_color_levels.c: undeprecated.

2005-10-05  Sven Neumann  <sven@gimp.org>

	* configure.in (CPPFLAGS): do not disable APIs that may be
	deprecated in the future.

2005-10-05  Sven Neumann  <sven@gimp.org>

	* configure.in: check if the libmpeg3 code can be compiled (it
	doesn't compile with gcc 4.0 for example).

2005-10-05  Sven Neumann  <sven@gimp.org>

	* README
	* configure.in: cosmetic changes.

2005-09-27  Sven Neumann  <sven@gimp.org>

	* configure.in: applied patch by Wolfgang Hofer that adds a check
	for libxvidcore.

2005-09-23  Sven Neumann  <sven@gimp.org>

	* gap/gap_morph_dialog.c
	* gap/gap_player_dialog.c: fixed compilation errors.

2005-09-23  Sven Neumann  <sven@gimp.org>

	* autogen.sh: prefer newer version of automake over older ones.

2005-09-22  Wolfgang Hofer <hof@gimp.org>

	- added sourcecode of external_libs (libmpeg3 and ffmpeg)
	  as gzipped tarballs.
	  Those libs are now automatically configured, built
	  and linked statically with the gimp-gap plug-ins
	  (as convenience libraries).
	  
	  configure options for the external libs can be
	  specified via files:
	  
	  extern_libs/configure_options_ffmpeg.txt
	  extern_libs/configure_options_libmpeg3.txt
	  
	- removed configure support for linking
	  libavformat and libavcodec with already installed
	  libraries.
	  (the removed code did not properly check
	   and was limited to fixed installation dirs)
	
	* configure.in  
	* Makefile.am
	* README 
	
	* extern_libs               # newly added directory
	* extern_libs/Makefile.am  
	* extern_libs/configure_options_ffmpeg.txt
	* extern_libs/configure_options_libmpeg3.txt
	* extern_libs/README_extern_libs
	* extern_libs/ffmpeg.tar.gz
	* extern_libs/libmpeg3.tar.gz
	
2005-09-09  Rajesh Ranjan  <rajeshkajha@yahoo.com>

	* configure.in : Added "hi" to ALL_LINGUAS.

2005-09-07  Wolfgang Hofer <hof@gimp.org>
	- bugfix: typo's pointed out in bug #313965
	- bugfix in generation of original tone audio track.
          Must fetch the original framerate of the videoclips
          (VID_PLAY_MOVIE)
          for creating the corresponding audioclips
          and supply this framerate parameter in the generated
          AUD_PLAY_MOVIE record.
          This is necessary to ensure correct timing if the
          handled clips have different framerates or framerates
          other than the gimp-gap default of 25 fps.

	- ffmpeg encoder change progress text if frames are copied
          rather than encoded. this gives immediate feedback if
          the "dont recode" option is in affect or not.
          (e.g if lossless mpeg cut is active)
	- renamed internal procedure to p_flip_separators

	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
	* gap/gap_story_file.c

	* gap/gap_decode_mplayer.c
	* gap/gap_decode_xanim.c
	* gap/gap_frontends_main.c
	* gap/gap_vex_main.c

2005-09-06  Wolfgang Hofer <hof@gimp.org>
	bugfix MasterVideo encoder OK button did not work in case
	of encoding with a single audio inputfile.
	(init of local variables was missing:
        all_playlist_references and valid_playlist_references)

	* libgapvidutil/gap_gve_sox.c

2005-09-06  Wolfgang Hofer <hof@gimp.org>

	- storyboard properties: added filtermacro entry widget
        (TODO: add button to invoke a filesel widget)

	* gap/gap_story_main.h
	* gap/gap_story_properties.c

2005-09-06  Ankit Patel  <ankit644@yahoo.com>

	* configure.in : Added "gu" to ALL_LINGUAS.

2005-08-21  Jens Seidel <jseidel@cvs.gnome.org>
	- fixed a typo (s/occured/occurred/) in a few msgid strings and other
	  files (inclusive all translations).

2005-08-18  Jens Seidel <jseidel@cvs.gnome.org>
	- fixed a typo (s/seperate/separate/) in a msgid string and other
	  files (inclusive all translations).

2005-07-24  Wolfgang Hofer <hof@gimp.org>
	- extended the FFMPEG based video encoder to support encoding
	  multiple tracks.
	  Video is still limited to one track, but multiple
	  audiotrack encoding is supported as hidden feature.
	  To use that feature, just pass a textfile
	  with references to multiple audio wavefiles instead of
	  one audio file to this encoder.
	- fixed bug related to checking for valid RIFF WAVE file format.
	  (relevant for audiofiles with additional chunk(s) before the data
	  chunk)

	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
	* libgapvidutil/gap_gve_sox.c
	* libgapvidutil/gap_gve_story.c [.h]
	* gap/gap_audio_wav.c [.h]
	* gap/gap_file_util.c [.h]
	* gap/gap_libgimpgap.h
	* vid_common/gap_cme_gui.c
	* docs/reference/txt/plug-in-gap-vid-encode-master.txt
	* po/POTFILES.in
	
2005-07-23  Wolfgang Hofer <hof@gimp.org>
	check for errors while writing audio files.
	in case of error print the error message and exit
	* gap/gap_audio_wav.c
	* libgapvidutil/gap_gve_story.c
	
2005-07-21  Pawan Chitrakar  <pawan@nplinux.org>

	* configure.in: Added ne in ALL_LINGUAS

2005-05-22  Wolfgang Hofer <hof@gimp.org>
	- some of the mplayer options (-aofile  -jpeg -z) of the mplayer version 1.0pre5
	  dont work with mplayer version 1.0pre7 (dont know about pre6 release)
	  
	  i updated to the new options, but added a checkbox labeled Mplayer1.0pre5
	  in the dialog of the mplayer based frame extract plug-in
	  that still allows switching back to the old options
	  (you need this only in case you still run  mplayer version 1.0pre5)
	  
	  examples of the new option syntax:
	  
	  mplayer -vo png:z=9 -ss 00:00:14 -frames 25  videoinput.rm
	  mplayer -vo jpeg:quality=92:smooth=70 -ss 00:00:14 -frames 150  videoinput.rm
	  
  
	* gap/gap_decode_mplayer.c [.h]

2005-05-11  IÃ±aki LarraÃ±aga  <dooteo@euskalgnu.org>

	* configure.in: Added "eu" (Basque) to ALL_LINGUAS.

2005-05-01  Wolfgang Hofer <hof@gimp.org>
	- added new wrappers to support layer transformations
	  (flipping and simple rotate)
	  for the useage in animated filtercalls and filtermacro.
	  
	* gap/Makefile.am
	* gap/gap_wr_trans.c    # new file
	* gap/.cvsignore
	* po/POTFILES.in
	 
2005-04-17  Wolfgang Hofer <hof@gimp.org>

	- added docs/*/txt/*.txt files as EXTRA_DIST stuff
	  (created Makefile.am in the docs subdir)
	  and some minor fixes to make distdir work
	- added missing filenames to POTFILES.in 
	  (thanks to Marcel Telka for pointing that out)
	   vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c
           vid_enc_ffmpeg/gap_enc_ffmpeg_par.c


	* README
	* NEWS
	* Makefile.am
	* gap/Makefile.am
	* configure.in
	* po/ChangeLog
	* po/POTFILES.in
	
2005-04-13  Sven Neumann  <sven@gimp.org>

	* autogen.sh: updated; require automake >= 1.7.

	* configure.in: removed cruft that was needed for automake 1.6 only.

2005-04-09  Wolfgang Hofer <hof@gimp.org>

	- disabled some hardcoded debug output.
	- MovePath: new feature for advanced reset and grabbing a gimp path.
	  When The SHIFT Key is held down while the "Grab Path" button is
	  pressed the path is grabbed in a way that results in one
	  controlpoint per handled frame.
	  The moving object may follow the bezier path in more precise
	  manner (not just straight lines between the anchor points),
	  when the move path operation affects many frames.

	* libgapvidapi/gap_vid_api_ffmpeg.c
	* libgapvidapi/gap_vid_api_util.c
	* vid_enc_single/gap_enc_singleframes_main.c
	* libgapvidutil/gap_gve_story.c
	* gap/gap_mov_dialog.c
	* gap/gap_morph_dialog.c
	* docs/reference/txt/plug-in-gap-move-path.txt
	* NEWS


2005-04-04  Wolfgang Hofer <hof@gimp.org>
	2005-04-04:
	- replaced some deprecated calls
	  (gimp_rotate, gimp_perspective, gimp_drawable_image_id
	  
	  (thanks to carol for pointing out)
	
	* gap/gap_pdb_calls.c
	* gap/gap_mov_render.c
	* gap/gap_filter_codegen.c

	2005-03-29:

        - added new configure options:
	  --with-ffmpegsrcdir=DIR      specify where to find ffmpeg src directory DIR
	  --with-libmpeg3srcdir=DIR    specify where to find libmpeg3 src directory DIR
	  
	  those options may be used for static linking ffmpeg and libmpeg3
	  from their sourcetree without the need to install those libs.
	  (you have to configure / make both libs manually before
	   configure gimp-gap)
	   
	  The new options are primary for internal use on my development
	  machine, but can be also used to create gimp-gap binaries
	  without dependencies to libavformat, libavcodec and libmpeg3.
	   
	  There still should be more sophisticated checks for the
	  case where the user wants to compile with installed versions
	  of those libs.

	* configure.in
	* README

	2005-03-24:

        - added new configure options:
	  --with-ffmpegsrcdir=DIR      specify where to find ffmpeg src directory DIR
	  --with-libmpeg3srcdir=DIR    specify where to find libmpeg3 src directory DIR
	  
	  those options may be used for static linking ffmpeg and libmpeg3
	  from their sourcetree without the need to install those libs.
	  (you have to configure / make both libs manually before
	   configure gimp-gap)
	  
	  (i droped the plan to include the tarballs of those libs)
	  but this may cause problems
	  

	- new feature: ffmpeg video encoder now supports
	  save/load paramters to/from parameterfile
	- NON-interactive PDB interface to set parameters
	  changed. 
	  (instead of passing all the parameters
	  the caller has to pass the name of an
	  ffmpeg video encoder parameterfile).
	  
        - reorganized notebook widget of the 
	  FFMPEG Video Encode Parameters dialog window.
	  
	  Added New Tab: Expert Flags
	   IntraOnly, GOP, B-Frames and Aspect moved to
	   the "Basic Options" Tab.
	  
        - GUI support for many new ffmpeg encoder parameters 
	  (depends on LIBAVCODEC_BUILD  >= 4744)

	- Tried to provide encoder presets 
	  (based on ffmpeg.c code reading) but most of the preset values
	  are still a wild guess.
	  
	  Algorithms Tab:
	    added algoritmhm combo boxes:
	    -Macroblock cmp
	    -ildct cmp
	    -Fullpel cmp
	    -Subpel cmp
	    -Pre motion estimation Cmp
	    -frame_skip_cmp
	    -predictor
	    -coder
	
	 Expert Flags Tab:
	    added checkbuttons for new flags:
	      
	    -use_ss;		  "enable Slice Structured mode (h263+)"
	    -use_aiv;		  "enable Alternative inter vlc (h263+)"
	    -use_obmc;		  "use overlapped block motion compensation (h263+)"
	    -use_loop;		  "use loop filter (h263+)"
	    -use_alt_scan;  	  "enable alternate scantable (MPEG2/MPEG4)"
	    -use_trell;		  "enable trellis quantization" 							    
	    -use_mv0;		  "try to encode each MB with MV=<0,0> and choose the better one (has no effect if mbd=0)"  
	    -do_normalize_aqp;	  "normalize adaptive quantization"							    
	    -use_scan_offset;	  "enable SVCD Scan Offset placeholder" 						    
	    -closed_gop;          "closed gop"
	    -strict_gop           "strictly enforce GOP size"									    
	    -use_qpel;		  "enable 1/4-pel"									    
	    -use_qprd;		  "use rate distortion optimization for qp selection"					    
	    -use_cbprd;		  "use rate distortion optimization for cbp"						    
	    -do_interlace_dct;	  "use interlaced dct"  								    
	    -do_interlace_me;	  "interlaced motion estimation"							    
  
	  
	  

	The current FFMPEG version has lots of video encoder parameters 
	(more than 100) 
	but most of them i dont know what they are used for.
	I think most of the parameters can be set to default value
	unless you are an ffmpeg expert.
	
	Some of the new parameters are not supported in the 
	video encoder parameter GUI, but support via
	parameterfile is implemented.
	FFMPEG experts can edit the parameterfile
	and then load the edited parameterfile.
	

	* vid_enc_ffmpeg/Makefile.am
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_par.c [.h]  # new files

	2005-03-19:
	made gap_vin procedures and types public and 
	fit for common use to read/write other parameter files.
	 
	*  gap/gap_vin.c [.h]
	
	2005-03-16:
	- ffmpeg Params updated GUI for those params that
	   allow additional values in ffmpeg versions >= 0.4.9
	   
	   DCT algorithm "faan"
	   IDCT algorithms "sh4", "simplearm", "h264"
	   
	   the new param values can be set from GUI when linked with
	   sufficient ffmpeg CVS version (LIBAVCODEC_BUILD  >= 4744)

	- bugfix attempt: try to detect aspect ratio with ffmpeg >= 0.4.9
	    when reading video 
	    (by additional reading AVCodecContext.dtg_active_format
	     information, but this does not work either)

	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
	* libgapvidapi/gap_vid_api_ffmpeg.c 


        2005-03-13:
	- bugfix: lossles mpeg cut:
	  fixed check for required framesequence to copy P and B frames
	  (compare used assign operator (= / == missmatch))
	  
	
	* libgapvidutil/gap_gve_story.c

2005-04-01  Steve Murphy  <murf@e-tools.com>

        * configure.in: Added "rw" to ALL_LINGUAS.

2005-03-12  Wolfgang Hofer <hof@gimp.org>

        - bugfix: #169311
	 Player must not display onionskin layers for the current image
	 when the Option "Auto delete before save" is ON.
	
	- bugfix: #169320 
	 when automatic onionskinlayer creation is turned on
	 store active_layer before the onionskin layers are added
	 and restore active_layer before save. 
	 Without this fix one of the added onionskin layers is
	 stored as the active layer in the saved file.
	 This did break the workflow when the frame is loaded later on.

	 new feature:
	 tracking of the active_layer by name (as described in bug #169320)
	 and by layerstack position can be configured in the VCR Navigator dialog
	 (The configuration value is stored in the _vin.gap file.
	  therefore the scope is permanent per animation and independent
	  from automatic onionskin layer creation)

	  (active_layer_tracking 0) # 0: OFF 1: by name  2: by stackposition
	
	- bugfix: when Player is used as widget 
	  in another dialog, its shell_window is null.
	  dont try to handle resize for shell_window when its a NULL pointer.

	  fixes warnings like that:
	  (storyboard:24245): Gtk-CRITICAL **: file gtkwindow.c: line 3044
	    (gtk_window_set_default_size): assertion `GTK_IS_WINDOW (window)' failed

	* gap/gap_player_dialog.c
	* gap/gap_onion_base.c [.h]
	* gap/gap_lib.c
	* gap/gap_player_main.c [.h]
	* gap/gap_vin.c [.h]
	* gap/gap_navigator_dialog.c
	* docs/reference/txt/plug-in-gap-navigator.txt
	* NEWS

2005-03-05  Wolfgang Hofer <hof@gimp.org>
	- ffmpeg-CVS (snapshot from 2005.03.02) based encoder:
	  initalize values for the encoder options that are new
	  in this ffmpeg CVS snapshot

	  this fixes "buffer underflow" errors that were reported 
	  (more than once per encoded frame) to stdout 
	  by the encoder while executing av_write_frame.

	  GAP provides now explicite support for ffmpeg library versions:
	     0.4.8     (stable)
	     0.4.9pre1 (latest official)
	     CVS Snapshots equal or newer than 2005.03.02
	     (identified by LIBAVCODEC_BUILD       4744
	      GAP internal marked as #define HAVE_FULL_FFMPEG)
	  
	  (GUI support to edit the new options is still missing)
	
	- bugfix: Storyboard processing. 
	  skipping the analyze of already known video elements
	  did not work and made processing slower.
	
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
	* libgapvidutil/gap_gve_story.c
	
2005-02-27  Wolfgang Hofer <hof@gimp.org>
        - bugfix (attempt) ffmpeg-0.4.9 frame aspect handling at encoding
	    did not work. 
	    (the bugfix follows the code of ffmpeg.c without understanding
	     but seems to work)
	    
	    BUT: aspect detection at read access does not work with ffmpeg-0.4.9
	    (dont know why, seems to be a bug in ffmpeg-0.4.9)
	    
	- bugfix:  lossless MPEG cut with ffmpeg-0.4.9 based encoder:
	   workaround encodes a dummy frame 
	   for each 1:1 copied frame to keep codec internal handled
	   timestamps and picturenumbers up to date.
	   (newer versions of ffmpeg do require ascending timestamsps
	    and will not work if the codec is completely bypassed
	    for those frames.)
	   
	   lossles mpeg cut now works with both ffmpeg-0.4.8  ffmpeg-0.4.9
	   and more recent ffmpeg CVS snapshots.

	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c

2005-02-19  Wolfgang Hofer <hof@gimp.org>
	- bugfix: STORYBOARD processing fixed crash that happened
	  sometimes after creating the composite audiofile.
	  (aud_elem->tmp_audiofile pointers did refere to the same
	   adress that was g_free'd more than one time)
	   
	- bugfix: STORYBOARD processing of AUD_PLAY_MOVIE records
	  from:000001 to:000002 resulted in too short duration time 
	  of just one frame.
	  now results in duration time for 2 frames to match with
	  the video duration time that is 2 frames in that case.
	  
	  * gap/gap_story_file.c
	  * libgapvidutil/gap_gve_story.c
	  * README
	  
2005-02-05  Wolfgang Hofer <hof@gimp.org>
	- API for video read access now also compiles and works with
	  ffmpeg-0.4.9pre1 (and should also work with recent CVS snapshots
	  tested with FFMpeg-20050120 CVS snapshot)
	  
	  existing videoindexes that are based on ffmpeg-0.4.8 will
	  not work after upgrade to ffmpeg-0.4.9 or later versions.
	  
	  therefore it is recommanded to delete the old indexes,
	  and create new ones based on the new version of ffmpeg.
	  To delete videoindexes on UNIX use these commands:
	  
	  cd $HOME/.gimprc/gvaindexes
	  rm *.libavformat.gvaidx
	
	* libgapvidapi/gap_vid_api_ffmpeg.c
	
2005-01-30  Wolfgang Hofer <hof@gimp.org>

	Help Buttons for storyboard pop-up dialogs 
	"master properties" and "generate original tone audio"
	
	Videoaccess parameter exactseek now defaults to value 0.
	(allow videoindex based fast seek operations)
	value 1 forces the (very slow) sequential reads.
	
	- disabled some further debug printfs
	- tested filter all layers with gimp-2.2.3
	   plug_in_noisify_iter_ALT
	   plug_in_wr_curves
	- bugfix: gap/gap_wr_color_curve.c calling gimp_dialog_new
	  with help_function but help_id == NULL resulted in
	  errors and crash of the plug-in
	  
	  (wr_curves:4630): Gdk-CRITICAL **: file gdkscreen-x11.c: line 232 (gdk_screen_get_root_window): assertion `GDK_IS_SCREEN (screen)' failed

        - ffmpeg (0.4.8) encoder presets:
	  dont use motion_estimation algorithm "Full" any longer in the presets
	  and replaced those settings with "EPZS"
	  (it makes encoding much slower, and seems not to deliver better
	  quality, even worse it has problems on fast moving dark objects
	  that are sometimes encoded fully black, resulting
	  in visible annoying black blocks.)
	
	* gap/gap_story_main.h
	* gap/gap_story_dialog.c
	* gap/gap_story_file.c
	* gap/gap_vex_dialog.c
	* gap/gap_vex_exec.c
	* gap/gap_fmac_main.c
	* gap/gap_wr_color_curve.c
	* gap/gap_wr_color_huesat.c
	* 
	* gap/TESTPROT_iter_ALT
	* libgapvidutil/gap_gve_story.c
	* libgapvidapi/gap_vid_api_ffmpeg.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
	* gap/gap_filter_iterators.c
	* gap/iter_ALT/gen/plug_in_noisify_iter_ALT.inc
	* docs/reference/txt/STORYBOARD_FILE_DOC.txt
	* docs/reference/txt/plug-in-gap-storyboard-gen-otone.txt    # NEW file
	* docs/reference/txt/plug-in-gap-storyboard-master-prop.txt  # NEW file
	* docs/reference/txt/plug-in-wr-curves.txt                   # NEW file
	* docs/reference/txt/plug-in-wr-color-levels.txt             # NEW file
	* docs/reference/txt/plug-in-wr-huesat.txt                   # NEW file
	
	
2005-01-22  Wolfgang Hofer <hof@gimp.org>
	- Storyboard dialog: added key support for crtl-c,ctrl-x,ctrl-v (copy/cut/paste)
	
	* gap/gap_story_dialog.c
	* gap/gap_story_mian.h
	
2005-01-15  Wolfgang Hofer <hof@gimp.org>
	- bugfix: Storyboard dialog: after save as, and encoder call:
          the encoder was called with the OLD name!
	- gap_arr_dialog replaced global data to enable 2 pop-ups
	  created with gap_arr_dialog open at same time.
	  (fixes some bugs from my internal list
	   related to the storyboard dialog that does use
	   2 or more arr_dialog based pop-ups)
	  
	* gap/gap_story_dialog.c
        * gap/gap_arr_dialog.c
	* docs/reference/txt/STORYBOARD_FILE_DOC.txt
	
2005-01-14  Wolfgang Hofer <hof@gimp.org>
	- STORYBOARD Processing:
	  Show progress while analyzing storyboard files and while
	  extracting audioparts of videofiles to temporary audiofiles
	  for creating the composite audio track.

	- GVA workaround for libmpeg3 crash on close bug (limited to UNIX systems).
	  the workaround forks a child process with its own sgnal handler.
	  the child process tries open/close. Crashes are then caught
	  in the signal handler of the child process and tell the parent
	  process (via retcode) that this videofile cant be handled by libmpeg3.
	  
	  This workaround makes open safe but slow 
	  (mainly caused by additional open/close rather than by forking).
	  but with gimprc parameter:
	  
	  (video-workaround-for-libmpeg3-close-bug "no")
	  
	  the workaround can be skipped.
	
	* vid_common/gap_cme_gui.c
	* libgapvidutil/gap_gve_story.c
	* libgapvidapi/gap_vid_api_mpeg3.c
	* libgapvidapi/gap_vid_api.c
	* docs/reference/txt/gap_gimprc_params.txt
	* NEWS
	
2005-01-13  Wolfgang Hofer <hof@gimp.org>
	- Storyboard added feature to generate audio original tone
	  cut references in the storyboard file
	  for all the clips refering to videofiles.
	  
	* gap/gap_story_dialog.c [.h]
	* gap/gap_story_file.c [.h]
	* gap/gap_story_main.h
	* docs/reference/txt/plug-in-gap-storyboard-edit.txt
	
2005-01-12  Wolfgang Hofer <hof@gimp.org>
	- Master Videoencoder: added button 'Create Composite Audiofile'
	  this starts the long running audio mixdown for storyboard processing.
	  
	  in the old behaviour this was started implicite when a new
	  storyboard filename was entered, and there was no way to skip that
	  part. the explicite start gives more flexibility if the user
	  wants to encode only the video part, or the composite audiofile
	  is already there from a previous encoder call, and wants to encode
	  again with other compression parameters.
	  
	- Storyboard processing optimized:
	  - the new flag create_audio_tmp_files controls the long running
	    creation of temporary audiofiles. Setting this flag to FALSE
	    can speed up storyboard processing for the case when
	    the storyboard file contains audio tracks, and the caller
	    (== the Master Videoencoder) is only interested in
	    total audioplaytime and if syntax of audio records is OK.

	  - implicite extracting audiodata from videofiles for the
	    mix down of the composite audiotrack is now reduced
	    to the affected range(s) refering a videofile.
	    (old behaviour extracted always the audiodata in full length)

	* gap/gap_story_file.c [.h]
	* vid_common/gap_cme_gui.c [.h]
	* vid_common/gap_cme_callbacks.c [.h]
	* vid_common/gap_cme_main.c [.h]
	* libgapvidutil/gap_gve_story.c [.h]
	
	* docs/reference/txt/plug-in-gap-vid-encode-master.txt
	* docs/reference/txt/plug-in-gap-extract-video.txt
	
	  
2005-01-06  Wolfgang Hofer <hof@gimp.org>
	- Storyboard syntax: the AUD_PLAY_MOVIE command
	  now provides positioning in unit frames.
	  this makes it easier to add an original tone
	  audiotrack (by manual editing) because
	  the video clips (VID_PLAY_MOVIE syntax) is also mesured in frames.

	* gap/gap_story_syntax.c
	* gap/gap_story_file.c [.h]
	
2005-01-05  Wolfgang Hofer <hof@gimp.org>
	- removed/disabled more debug output printf statements
	- video_extract: show aspect_ratio information of the video
	  (this feature does not work with the libmpeg3 decoder,
	   mpeg3_aspect_ratio delivered 0.0
	   for all tested video files, 
	   libavformat did deliver correct aspect informations)
	  
	  when available the aspect ratio is also used to set the 
	  image resolution in all the handled (extracted) videoframe images, 
	  where yresolution is fixed at 72 DPI and xresolution
	  is calculated according to the aspect ratio of the video.
	  Typically 16:9 DVDs have 720x576 non-quadratic pixels. 
	  This results in xresolution 60.75 DPI  and yresolution 72.0 DPI.
	  
	  the aspect is set in the Video API procedure GVA_image_set_aspect.
	
2004-12-22  Wolfgang Hofer <hof@gimp.org>
	-fixed some bugs in message texts (reported by popolon via mail)
	-fixed bug scanning strings from _vin.gap files
	 and initialise errors for combo boxes in the Onionskin
	 configuration dialog (fix for #161620)
	- removed/disabled debug output printf statements

	* gap/gap_navigator_dialog.c
	* gap/gap_player_dialog.c
	* gap/gap_vex_dialog.c
	* vid_common/gap_cme_gui.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c
	
	* gap/gap_onion_dialog.c
	* gap/gap_vin.c
	
2004-12-12  Wolfgang Hofer <hof@gimp.org>
	reorganized and updated available doc files
	and added some of the missing docs.
	(there are still some chapters left to do..)
	Splitted the large gap/README textfile into plug-in related
	subfiles (using the HELP_ID's + .txt as name)
	
	* README
	* gap/README
	
	# NEWLY added doc files:
	* docs/reference/txt/INTRODUCTION.txt
	* docs/reference/txt/STORYBOARD_FILE_DOC.txt
	* docs/reference/txt/gap-filterall-db-browser.txt
	* docs/reference/txt/gap_gimprc_params.txt
	* docs/reference/txt/plug-in-bluebox.txt
	* docs/reference/txt/plug-in-filter-macro.txt
	* docs/reference/txt/plug-in-gap-anim-crop.txt
	* docs/reference/txt/plug-in-gap-anim-resize.txt
	* docs/reference/txt/plug-in-gap-anim-scale.txt
	* docs/reference/txt/plug-in-gap-del.txt
	* docs/reference/txt/plug-in-gap-density.txt
	* docs/reference/txt/plug-in-gap-dup.txt
	* docs/reference/txt/plug-in-gap-exchg.txt
	* docs/reference/txt/plug-in-gap-extract-player.txt
	* docs/reference/txt/plug-in-gap-extract-video.txt
	* docs/reference/txt/plug-in-gap-modify.txt
	* docs/reference/txt/plug-in-gap-morph.txt
	* docs/reference/txt/plug-in-gap-move-path.txt
	* docs/reference/txt/plug-in-gap-mpeg-encode.txt
	* docs/reference/txt/plug-in-gap-mpeg2encode.txt
	* docs/reference/txt/plug-in-gap-mplayer-decode.txt
	* docs/reference/txt/plug-in-gap-navigator.txt
	* docs/reference/txt/plug-in-gap-onionskin-configuration.txt
	* docs/reference/txt/plug-in-gap-range-convert.txt
	* docs/reference/txt/plug-in-gap-range-flatten.txt
	* docs/reference/txt/plug-in-gap-range-layer-del.txt
	* docs/reference/txt/plug-in-gap-range-to-multilayer.txt
	* docs/reference/txt/plug-in-gap-renumber.txt
	* docs/reference/txt/plug-in-gap-shift.txt
	* docs/reference/txt/plug-in-gap-split.txt
	* docs/reference/txt/plug-in-gap-storyboard-clip-prop.txt
	* docs/reference/txt/plug-in-gap-storyboard-edit.txt
	* docs/reference/txt/plug-in-gap-storyboard-player.txt
	* docs/reference/txt/plug-in-gap-vid-encode-master.txt
	* docs/reference/txt/plug-in-gap-videoframes-player.txt
	* docs/reference/txt/plug-in-gap-xanim-decode.txt
	* docs/reference/txt/plug-in-name2layer.txt

	* docs/howto/txt/HOWTO-do-lossless-MPEG-cut.txt 
	* docs/howto/txt/HOWTO-write-animated-plug-ins.txt   
	
	
2004-12-06  Wolfgang Hofer <hof@gimp.org>
	Added frontend fro MPlayer based videoframe extracted plug-in.
	MPlayer offers support to read from many videoformats.
	
	This offers access to much more videoformats than the already existing 
	ffmpeg/libmeg3 based video extract plug-in, but does not
	allow precise frame positioning. There is also no visual
	positioning provided in the plug-in. 
	
	an optional gimprc parameter (mplayer_prog "/usr/local/bin/mplayer")
	can be used if mplayer is installed, but is not found in
	the directories specified in the PATH environment variable.
	
	* gap/Makefile.am
	* gap/gap_frontends_main.c
	* gap/gap_decode_xanim.c
	* gap/gap_decode_mplayer.c [.h]    # NEWLY ADDED FILES
	* po/POTFILES.in
		
2004-12-04  Wolfgang Hofer <hof@gimp.org>
        Storyboard: Shorten frame header texts (if filenamepart gets too long)
	
	* gap/gap_story_dialog.c
	* gap/gap_story_main.c [.h]
	* gap/gap_lib.c [.h]
	* gap/gap_player_dialog.c
	
2004-12-02  Wolfgang Hofer <hof@gimp.org>
	Storyboard: prefetch videothumbnail previews all at once
	and show advance in the progress bar
	(when activated via Menu)

	Storyboard: implemented the missing dialog pop-up for Global/Properties
	for selecting Layout Presets.
	
	* gap/gap_story_dialog.c
	* gap/gap_story_main.c [.h]
	
2004-11-29  Wolfgang Hofer <hof@gimp.org>
	message text fixed (#159593)
	* gap/gap_bluebox.c
	
2004-11-28  Wolfgang Hofer <hof@gimp.org>
	- gap changed limit for framenumberdigits from 6 to 8
	  now use define GAP_LIB_MAX_DIGITS 
	  and allow frames with basename part is NULL
	   e.g.  framenames looking like that:
	    
	    00000001.png
	    00000002.png
	    
	  this was done to be compatible with mplayer's frame extracting feature
	  (mplayer-1.0pre5 uses 8 digits for the extracted frames
	   where the frames are just numberpart and extension)

	* gap/gap_lib.c  [.h]
	* gap/gap_base_ops.c
	* gap/gap_main.c
	* gap/gap_vex_dialog.c
	* gap/gap_vex_main.c
	* libgapvidapi/gap_vid_api_util.c
	
	
	
2004-11-23  Wolfgang Hofer <hof@gimp.org>
	bugfix: storyboard dialog asked for videoindex creation permission
	        even if a valid videoindex is available
        * gap/gap_story_dialog.c
	* gap/gap_arr_dialog.c
		
2004-11-18  Wolfgang Hofer <hof@gimp.org>
	- tested plug-ins of the gimp-2.2pre1 release
	  for animated "filter all layers" capabilites,
	  and fixed _iter_ALT procedures.
	  
	- #158078  added "filter all layers" support for:
	     plug_in_gimpressionist
	     plug_in_autostretch_hsv         (limited to constant apply)
	     plug_in_blur                    (limited to constant apply)
	     plug_in_c_astretch              (limited to constant apply)
	     plug_in_cartoon
	     plug_in_color_adjust            (limited to constant apply)
	     plug_in_color_enhance           (limited to constant apply)
	     plug_in_colors_channel_mixer
             plug_in_dilate                  (limited to constant apply)
	     plug_in_dog
	     plug_in_erode                   (limited to constant apply)
	     plug_in_gauss
	     plug_in_gradmap                 (limited to constant apply)
	     plug_in_hot                     (limited to constant apply)
	     plug_in_laplace                 (limited to constant apply)
	     plug_in_make_seamless           (limited to constant apply)
	     plug_in_max_rgb                 (limited to constant apply)
	     plug_in_neon
	     plug_in_normalize
	     plug_in_photocopy
	     plug_in_qbist                   (limited to constant apply)
	     plug_in_softglow
	     plug_in_vinvert
	     
	- dropped "filter all layers" support for:
	  (by removing the iter_ALT procedure registration)
	 
	     plug_in_blur
	     plug_in_gauss_iir
	     plug_in_gauss_iir2
	     plug_in_gauss_rle
	     plug_in_gauss_rle2
	     plug_in_make_seamless    (removed just iter_ALT, const apply still there)
             plug_in_max_rgb          (removed just iter_ALT, const apply still there)
	     plug_in_rotate           (has no GUI dialog, apply without specify angle makes no sense)
	     plug_in_normalize        (removed just iter_ALT, const apply still there)
	     plug_in_vinvert          (removed just iter_ALT, const apply still there)
	
	* gap/TESTPROT_iter_ALT
	* gap/Makefile.am
	* gap/gap_filter_iterators.c
	* gap/gap_filter_pdb.c
	
	# Created NEW files:
	* gap/iter_ALT/mod/plug_in_cartoon_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_colors_channel_mixer_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_dog_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_gauss_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_gimpressionist_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_neon_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_photocopy_iter_ALT.inc
	* gap/iter_ALT/mod/plug_in_softglow_iter_ALT.inc
	
	
2004-11-16  Wolfgang Hofer <hof@gimp.org>
	- bugfix: gap_filt_pdb_call_plugin call plug-ins
	  with pointer to string "\0" rather than using NULL pointer
	  Some plug-ins crash when string args are passed
	  as NULL pointer, even if the call is INTERACTIVE
	  (example:  plug_in_gimpressionist)
	
	* gap/gap_filter_pdb.c
	* vid_common/gap_cme_gui.c
	
2004-11-16  Sven Neumann  <sven@gimp.org>

	* configure.in: check for GIMP >= 2.2.0.

2004-11-14  Wolfgang Hofer <hof@gimp.org>
	- bugfix VCR navigator: Timezoom changes and Goto other frame
	  actions did not
	  update the scale widgets adjustment (dyn_adj)
	- bugfix: after gap controlled image excange disable undo
	  (otherwise undo can discard the layers
	   step by step in order they were added by the image load operation)
	- gap_Use the same PDB-description render procedures
	  as the official DBBROWSER plug-in
	  copied code from gimp-2.1.7/plug-ins/dbbrowser/gimpprocbrowser.c

	  IDEA: if this code is transfered to libgimp
	  it could be used both from the offical DBBROWSER plug-in
	  and in GAP. (maybe after the gimp-2.2 release ?)
	  
	  * gap/gap_dbbrowser_utils.c
	  * gap/gap_navigator_dialog.c
	  * gap/gap_lib.c

2004-11-12  Wolfgang Hofer <hof@gimp.org>
	- hardcoded precompiler switch GAP_MORPH_DEBUG_FEATURES
	  to hide experimental and debug features in the morph plug-in
	  
	  * gap/gap_morph_dialog.c
	  	  
2004-11-11  Wolfgang Hofer <hof@gimp.org>
	- gap_arr_dialog  added new widget type: GAP_ARR_WGT_HELP_BUTTON
	- Added HelpButtons for most GAP plug-ins
	  (the ones where i think they should have a Help page.)
	  
	  some of the gap plug-ins had already a Help Button per default
	  because the implementation uses gimp_dialog_new to create
	  the dialog shell window.
          
	  All GAP help-buttons call the GIMP standard help procedure
	  gimp_standard_help_func
	 
	 - changed existing HELP_ID strings
	  from:  "plug_in_xxx.html"
	  to:    "plug-in-xxx"

        - here is the list of HELP_ID's. 
	  For each HELP-ID we need a html help page.
	  
	  As far as i know there are no help-pages for gimp-gap available
	  at all (until now). 
	  Some (partly outdated) information is already available 
	  in the gap/README textfile.

	  (dont know howto create Helppages and have no XML knowledge either.)
	   


	new HELP_ID                           menupath:
	--------------------------------------------------------
	"plug-in-bluebox"		      <Image>/Video/Bluebox
	"plug-in-gap-modify"                  <Image>/Video/Frames Modify
        "plug-in-gap-vid-encode-master"       <Image>/Video/Encode/Master Encoder
	"plug-in-gap-encpar-avi1"             ## AVI videoencoder params (invoked via master encoder)
	"plug-in-gap-encpar-ffmpeg"           ## FFMPEG videoencoder params (invoked via master encoder)
	"plug-in-gap-navigator"               <Image>/Video/VCR Navigator
        "plug-in-gap-morph"                   <Image>/Video/Morph
        "plug-in-gap-extract-video"           <Image>/Video/Split Video to Frames/Extract Videorange
	
	"plug-in-gap-move-path"               <Image>/Video/Move Path
        "plug-in-gap-xanim-decode"	      <Image>/Video/Split Video to Frames/Any XANIM readable
	"plug-in-filter-macro"                <Image>/Filters/Filtermacro
        "gap-filtermacro-db-browser"          ## gap_dbbrowser dialog invoked from filtermacro
        "gap-modframes-db-browser"            ## gap_dbbrowser dialog invoked from modify frames plug-in
        "gap-filterall-db-browser"            <Image>/Filters/Filter all Layers
	"plug-in-gap-onionskin-configuration" <Image>/Video/Onionskin/Configuration
	"plug-in-gap-storyboard-edit"         <Image>/Video/Storyboard  (has HelpMenu, no Button)
	"plug-in-gap-storyboard-clip-prop"    ## storyboard edit dialog sub window  (clip properties)
	"plug-in-gap-videoframes-player"      <Image>/Video/Playback
	"plug-in-gap-extract-player"          ## Player invoked from videoextract plug-in
	"plug-in-gap-storyboard-player"       ## Player invoked from storyboard dialog editor plug-in
	"plug-in-gap-anim-scale"              <Image>/Video/Frames Scale
	"plug-in-gap-anim-resize"             <Image>/Video/Frames Resize
	"plug-in-gap-anim-crop"               <Image>/Video/Frames Crop
        "plug-in-gap-range-flatten"           <Image>/Video/Frames Flatten
        "plug-in-gap-range-layer-del"         <Image>/Video/Frames Layer Delete
	"plug-in-gap-range-convert"           <Image>/Video/Frames Convert
        "plug-in-gap-range-to-multilayer"     <Image>/Video/Frames to Image
        "plug-in-gap-renumber"                <Image>/Video/Frames Renumber
        "plug-in-gap-shift"                   <Image>/Video/Framesequence Shift
	"plug-in-gap-dup"                     <Image>/Video/Duplicate Frames
	"plug-in-gap-density"                 <Image>/Video/Frames Density
        "plug-in-gap-split"                   <Image>/Video/Split Img to Frames
        "plug-in-gap-del"                     <Image>/Video/Delete Frames
	"plug-in-gap-exchg"                   <Image>/Video/Exchange Frame
	"plug-in-gap-mpeg-encode"             <Image>/Video/Encode/MPEG1...
	"plug-in-gap-mpeg2encode"             <Image>/Video/Encode/MPEG2...
	"plug-in-name2layer"                  <Image>/Video/Filename to Layer...

	* touched most source files
	
2004-11-10  Wolfgang Hofer <hof@gimp.org>
	- reorganized master encoder dialog
	  replaced deprecated GtkOptionMenu widgets by gimp_int_combo_box
        - bugfix: ffmpeg default presets must not use b_frames for msmpeg4
	  codecs (ffmpeg-0.4.8 does crash with this parameter set > 0)
	  changed presets, and made workaround to avoid this crash.

	* vid_common/gap_cme_callbacks.c [.h]
	* vid_common/gap_cme_gui.c [.h]
	* vid_common/gap_main.c [.h]
	* gap/gap_morph_dialog.c
	* gap/gap_morph_dialog.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
		
2004-11-06  Wolfgang Hofer <hof@gimp.org>
	- replaced deprecated GtkOptionMenu widgets by gimp_int_combo_box
	  (not finished yet
	   todo: the master videoencoder dialog)
	   
	- reorganized ffmpeg encoder dialog code,
	  (the old glade generated code was much harder to read by humans)
	- ffmpeg encoder dialog: B-frames changed from checkbutton
	  to spinbutton (allows values 0 upto 8)
	  to specify number of B-frames per GOP.
	  (ffmpeg supported this since 0.4.8 but GAP gui-dialog
	   did forget to follow up this feature)

	* vid_enc_ffmpeg/gap_enc_ffmpeg_callbacks.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_gui.c [.h]
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c [.h]

	* vid_enc_avi/gap_enc_avi_main.h
	* vid_enc_avi/gap_enc_avi_gui.c
	
	* gap/gap_vex_dialog.c
	* gap/gap_vex_main.h
	* gap/gap_onion_main.h
	* gap/gap_onion_dialog.c
	
2004-11-04  Wolfgang Hofer <hof@gimp.org>
	replaced deprecated gimp procedure calls and adapted 
	corresponding callbacks
	
	DEPRECATED proc:                   REPLACEMENT:
	- gimp_layer_menu_new              gimp_layer_combo_box_new
	- gimp_image_menu_new              gimp_image_combo_box_new
	- gimp_palette_set_background      gimp_context_set_background
	- gimp_palette_set_foreground      gimp_context_set_foreground
	
	* gap/gap_morph_dialog.c [.h]
	* gap/gap_mov_dialog.c
	* gap/gap_layer_copy.c
	* gap/iter_ALT/mod/plug_in_exchange_iter_ALT.inc
	* libgapvidutil/gap_gve_story.c
	* gap/gap_navigator_dialog.c
	
	
2004-11-02  Wolfgang Hofer <hof@gimp.org>
	applied patches from pippin that enable compile with the
	ffmpeg-4.0.9pre1 prerelease.
	(made some changes to enable compile with both 
	stable FFMPEG_VERSION 0.4.8 and
	newest FFMPEG_VERSION 4.0.9pre1    
	(experimental code, failed at 1.st video extract test, need more
	tests and bugfixes)
	
	added #ifdef HAVE_OLD_FFMPEG_0408
	
	well, it compiles now but:
	.. there are much changes between ffmeg 0.4.8 and 4.0.9pre1.
	this requires deeper analyse and lots of tests and changes in the
	GAP code to get a working support for the new ffmpeg 4.0.9pre1.
	also requires support for the new encoder parameters of the
	4.0.9pre1 release.
	
	now using hardcoded #define HAVE_OLD_FFMPEG_0408
	to avoid successful (but useless) compiling with
	ffmpeg 4.0.9pre1.
	
	Maybe we should ship gimp-gap-2.2 with included
	ffmeg 0.4.8 and libmpeg3 sources, and link those libs
	statically ?

	* configure.in
	* gap/gap_vex_main.c
	* libgapvidapi/gap_vid_api.c
	* libgapvidapi/gap_vid_api_ffmpeg.c
	* libgapvidapi/gap_vid_api_gimp.c
	* libgapvidapi/gap_vid_api_mpeg3.c
	* vid_enc_ffmpeg/gap_enc_ffmpeg_main.c
	
2004-11-01  Wolfgang Hofer <hof@gimp.org>
	redesign of the ModifyFrames plug-in dialog using GTK+ rather than
	gap_array_dialog.
	gives more flexibility to set widget sensibility
	and allows grouping of the functions in submenus.
	
	* gap/gap_mod_layer_dialog.c [.h]   ## New files
	* gap/gap_mod_layer.c [.h]
	* gap/Makefile.am
	* po/POTFILES.in
2004-10-31  Wolfgang Hofer <hof@gimp.org>
	For the old MPEG encoder frontends:
	Added Information label to tell the user that the
	Master Videoencoder is the more efficient methode
	for videoencoding.
	* gap/gap_mpege.c
	* gap/gap_decode_xanim.c

2004-10-27  Wolfgang Hofer <hof@gimp.org>
	updated README file(s)
	got mail from: Marcel Telka <marcel@telka.sk>
	   I have tested module gimp-gap (CVS branch HEAD) which lives
	   in GNOME CVS for missing translatable files with `intltool-update -M`
	   command.

	   Here is a content of the 'missing' file:

	   libgapvidapi/gap_vid_api_mpeg3.c
	   libgapvidapi/gap_vid_api_vidindex.c
	   
	* README
	* gap/README
	* docs/STORYBOARD_FILE_DOC.txt
	* po/POTFILES.in
	
2004-10-26  Wolfgang Hofer <hof@gimp.org>
	Master Videoencoder dialog:
	Added radio buttons to select the input mode explicite.
	This makes clear that the encoder can handle all 3 types of input,
	If invoked from an animation frame "Frames" is selected at startup.
	for other (multilayer) images "Layers" is selcted automatically
	(this was already done before, but now the user has a chance
	to see whats going on, and can encode the layers of 
	one animation frame too if he wants to do so.)
	
	Storyboard dialog: added "Encode" menu item(s) to call the 
	Master video encoder dialog from the storyboard.
	
	* vid_common/gap_cme_main.c [h]
	* vid_common/gap_cme_gui.c
	* libgapvidutil/gap_gvetypes.h
	* vid_enc_avi/gap_enc_avi_main.h
	
	* gap/gap_story_main.c [h]
	* gap/gap_story_dialog.c

2004-10-24  Wolfgang Hofer <hof@gimp.org>
	bugfix: player now uses only valid videoindex files
	and forces re-creation on invalid ones.
	
	workaround: ffmpeg videoapi backend now makes an initial frame read
	and then reopens the video.
	this is done to detect the CODEC's native pixel format (YUV420 or YUV422).
	Before reading the 1.st frame libavcodec seems to deliver always YUV420
	that does match most, but not all codecs and,
	delivered wrong results for the 1.st read frame on the non matching codecs.
	
	bugfix: use gimp_context_get_background, gimp_context_set_background
	rather than the deprecated procedures: gimp_palette_get_background, gimp_palette_set_background
	
	* gap/gap_player_dialog.c
	* libgapvidapi/gap_vid_api_ffmpeg.c
	* gap/sel-to-anim-img.scm
	
2004-10-27  Sven Neumann  <sven@gimp.org>

	* libgapvidapi/gap_vid_api-intl.h: forgot to add this file to CVS.

2004-10-16  Wolfgang Hofer <hof@gimp.org>
	bugfix: Frames Modify plug-in
	Function: Add layermask from selection
	gimp_layer_add_mask call was missing after layermask creation.
	
	The GIMP-2.1.7 core crashed somewhere IN displays_reconnect_invoker
	after that fix. 
	(but only for Function: Add layermask from selection
	 not in other Functions)
	 
	Now this crash does not happen any more
	after the additional optimizing step
	in the Frames Modify plug-in.
	(old: 
	      save current frame 
	      foreach frame 
	      {
	        load; processing; save; delete;
	      }
	      load current frame
	      reconnect displays,
	      delete current frame
	 new:
	      foreach frame 
	      {
	        if(frame == current)
		{ 
		  processing; save
		}
		else
		{ 
	          load; processing; save; delete;
		}
	      }
	 )
	
	* gap/gap_mod_layer.c
2004-10-15  Wolfgang Hofer <hof@gimp.org>
	Layout changes (spacing, alingnment, widget sensitivity) for the VideoExtract Plugin
	to get one step closer to GNOME HIG
	
	feature: when the player is started from the videoextract plug-in,
	the player now uses the initial range (fom/to) selection
	from the video extract dialog.
	
	feature: the player button widget "FrameNr" was splitted into
	2 separate buttons "Frame" and "Nr",
	where "Frame" sets the current FramNr as Begin of selected Range
	and   "Nr"    sets the current FramNr as End of selected Range.

	The old behaviour (ALT-click for end) is harder to handle
	because it needs additional keyboard interaction.
	
	PlayerDialog: added the flag: caller_range_linked
	this flag causes the player to propagate changes in the
	selected framerange immediate to the callers
	Frame-Range widgets (by calling the p_printout_range procedure)
	
	The videoextract plug-in calls the player with the new
	caller_range_linked set TRUE.
	
	The explicite manual transfer of the of the players selected range
	into the extract dialog's extract range (Player Buttons: FromFrame / ToFrame)
	might be hard to find for new users and was removed.
	(The Player Buttons: FromFrame / ToFrame are replaced by
	 Labels when caller_range_linked is TRUE)

	When The player is called via STORYBOARD dialog,
	the caller_range_linked flag is set to FALSE.
	In this case the Player Buttons: FromFrame / ToFrame
	do create a new Clip. This must not be triggered automatically
	on each change in the Player's selected range
	-- otherwise we would produce lots of unwanted clips--
	
	* gap/gap_player_dialog.c
	* gap/gap_vex_dialog.c
2004-10-12  Wolfgang Hofer <hof@gimp.org>
	- renamed gimprc parameter from 
	  old: (video-gvaindexes-dir "dir")
	  new: (video-index-dir "dir")
	- bugfix: create of libmpeg3 videoindex toc files crashed after scanning th whole video
	  if the file could not be opened.
	  (in most cases this happened when the gvaindexes directory does not exist)
          
	  - extended the gap_arr_create_vindex_permission procedure:
	    now tries automatically create the gvaindex dir when permission is granted.
	    also try precreate empty videoindex file for immediate detection
	    of file creation errors.
